/* cheese-window.c generated by valac 0.46.2, the Vala compiler
 * generated from cheese-window.vala, do not modify */

/*
 * Copyright © 2010 Yuvaraj Pandian T <yuvipanda@yuvi.in>
 * Copyright © 2010 daniel g. siegel <dgsiegel@gnome.org>
 * Copyright © 2008 Filippo Argiolas <filippo.argiolas@gmail.com>
 *
 * Licensed under the GNU General Public License Version 2
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include "cheese-fileutil.h"
#include <clutter/clutter.h>
#include <gio/gio.h>
#include <clutter-gtk/clutter-gtk.h>
#include "thumbview/eog-thumb-nav.h"
#include "thumbview/cheese-thumb-view.h"
#include "cheese-camera.h"
#include "cheese-flash.h"
#include "cheese-effect.h"
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>
#include "cheese-camera-device.h"
#include <cairo.h>
#include "canberra-gtk.h"
#include <canberra.h>
#include <float.h>
#include <math.h>

#define CHEESE_TYPE_MAIN_WINDOW (cheese_main_window_get_type ())
#define CHEESE_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CHEESE_TYPE_MAIN_WINDOW, CheeseMainWindow))
#define CHEESE_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CHEESE_TYPE_MAIN_WINDOW, CheeseMainWindowClass))
#define CHEESE_IS_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CHEESE_TYPE_MAIN_WINDOW))
#define CHEESE_IS_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CHEESE_TYPE_MAIN_WINDOW))
#define CHEESE_MAIN_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CHEESE_TYPE_MAIN_WINDOW, CheeseMainWindowClass))

typedef struct _CheeseMainWindow CheeseMainWindow;
typedef struct _CheeseMainWindowClass CheeseMainWindowClass;
typedef struct _CheeseMainWindowPrivate CheeseMainWindowPrivate;

#define CHEESE_TYPE_EFFECTS_MANAGER (cheese_effects_manager_get_type ())
#define CHEESE_EFFECTS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CHEESE_TYPE_EFFECTS_MANAGER, CheeseEffectsManager))
#define CHEESE_EFFECTS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CHEESE_TYPE_EFFECTS_MANAGER, CheeseEffectsManagerClass))
#define CHEESE_IS_EFFECTS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CHEESE_TYPE_EFFECTS_MANAGER))
#define CHEESE_IS_EFFECTS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CHEESE_TYPE_EFFECTS_MANAGER))
#define CHEESE_EFFECTS_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CHEESE_TYPE_EFFECTS_MANAGER, CheeseEffectsManagerClass))

typedef struct _CheeseEffectsManager CheeseEffectsManager;
typedef struct _CheeseEffectsManagerClass CheeseEffectsManagerClass;

#define CHEESE_TYPE_COUNTDOWN (cheese_countdown_get_type ())
#define CHEESE_COUNTDOWN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CHEESE_TYPE_COUNTDOWN, CheeseCountdown))
#define CHEESE_COUNTDOWN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CHEESE_TYPE_COUNTDOWN, CheeseCountdownClass))
#define CHEESE_IS_COUNTDOWN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CHEESE_TYPE_COUNTDOWN))
#define CHEESE_IS_COUNTDOWN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CHEESE_TYPE_COUNTDOWN))
#define CHEESE_COUNTDOWN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CHEESE_TYPE_COUNTDOWN, CheeseCountdownClass))

typedef struct _CheeseCountdown CheeseCountdown;
typedef struct _CheeseCountdownClass CheeseCountdownClass;
enum  {
	CHEESE_MAIN_WINDOW_0_PROPERTY,
	CHEESE_MAIN_WINDOW_NUM_PROPERTIES
};
static GParamSpec* cheese_main_window_properties[CHEESE_MAIN_WINDOW_NUM_PROPERTIES];
typedef enum  {
	CHEESE_MAIN_WINDOW_DELETE_RESPONSE_SKIP = 1,
	CHEESE_MAIN_WINDOW_DELETE_RESPONSE_SKIP_ALL = 2
} CheeseMainWindowDeleteResponse;

#define CHEESE_MAIN_WINDOW_TYPE_DELETE_RESPONSE (cheese_main_window_delete_response_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_source_unref0(var) ((var == NULL) ? NULL : (var = (g_source_unref (var), NULL)))
#define __vala_GtkTreePath_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef void (*CheeseCountdownCountdownCallback) (gpointer user_data);
typedef struct _CheeseCountdownPrivate CheeseCountdownPrivate;
typedef struct _CheeseEffectsManagerPrivate CheeseEffectsManagerPrivate;
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))

struct _CheeseMainWindow {
	GtkApplicationWindow parent_instance;
	CheeseMainWindowPrivate * priv;
};

struct _CheeseMainWindowClass {
	GtkApplicationWindowClass parent_class;
};

struct _CheeseMainWindowPrivate {
	CheeseMediaMode current_mode;
	ClutterScript* clutter_builder;
	GtkBuilder* header_bar_ui;
	GtkHeaderBar* header_bar;
	GSettings* settings;
	GtkClutterEmbed* viewport_widget;
	GtkWidget* main_vbox;
	EogThumbNav* thumb_nav;
	CheeseThumbView* thumb_view;
	GtkBox* thumbnails_right;
	GtkBox* thumbnails_bottom;
	GtkWidget* leave_fullscreen_button_box;
	GtkButton* take_action_button;
	GtkImage* take_action_button_image;
	GtkToggleButton* effects_toggle_button;
	GtkWidget* buttons_area;
	GtkButton* switch_camera_button;
	GtkMenu* thumbnail_popup;
	ClutterStage* viewport;
	ClutterActor* viewport_layout;
	ClutterActor* video_preview;
	ClutterBinLayout* viewport_layout_manager;
	ClutterText* countdown_layer;
	ClutterActor* background_layer;
	ClutterText* error_layer;
	ClutterText* timeout_layer;
	ClutterActor* current_effects_grid;
	guint current_effects_page;
	GList* effects_grids;
	gboolean is_fullscreen;
	gboolean is_wide_mode;
	gboolean is_recording;
	gboolean is_bursting;
	gboolean is_effects_selector_active;
	gboolean action_cancelled;
	gboolean was_maximized;
	CheeseCamera* camera;
	CheeseFileUtil* fileutil;
	CheeseFlash* flash;
	CheeseEffectsManager* effects_manager;
	CheeseEffect* selected_effect;
	GSource* fullscreen_timeout;
	CheeseCountdown* current_countdown;
	gint burst_count;
	guint burst_callback_id;
};

struct _CheeseCountdown {
	GObject parent_instance;
	CheeseCountdownPrivate * priv;
	gboolean running;
};

struct _CheeseCountdownClass {
	GObjectClass parent_class;
};

struct _CheeseEffectsManager {
	GObject parent_instance;
	CheeseEffectsManagerPrivate * priv;
	GList* effects;
};

struct _CheeseEffectsManagerClass {
	GObjectClass parent_class;
};

static gint CheeseMainWindow_private_offset;
static gpointer cheese_main_window_parent_class = NULL;

#define FULLSCREEN_TIMEOUT_INTERVAL (5 * 1000)
#define EFFECTS_PER_PAGE ((guint) 9)
GType cheese_main_window_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CheeseMainWindow, g_object_unref)
GType cheese_effects_manager_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CheeseEffectsManager, g_object_unref)
GType cheese_countdown_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CheeseCountdown, g_object_unref)
static GType cheese_main_window_delete_response_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void cheese_main_window_on_file_open (CheeseMainWindow* self);
static void _cheese_main_window_on_file_open_gsimple_action_activate_callback (GSimpleAction* action,
                                                                        GVariant* parameter,
                                                                        gpointer self);
static void cheese_main_window_on_file_saveas (CheeseMainWindow* self);
static void _cheese_main_window_on_file_saveas_gsimple_action_activate_callback (GSimpleAction* action,
                                                                          GVariant* parameter,
                                                                          gpointer self);
static void cheese_main_window_on_file_trash (CheeseMainWindow* self);
static void _cheese_main_window_on_file_trash_gsimple_action_activate_callback (GSimpleAction* action,
                                                                         GVariant* parameter,
                                                                         gpointer self);
static void cheese_main_window_on_file_delete (CheeseMainWindow* self);
static void _cheese_main_window_on_file_delete_gsimple_action_activate_callback (GSimpleAction* action,
                                                                          GVariant* parameter,
                                                                          gpointer self);
static void cheese_main_window_on_effects_next (CheeseMainWindow* self);
static void _cheese_main_window_on_effects_next_gsimple_action_activate_callback (GSimpleAction* action,
                                                                           GVariant* parameter,
                                                                           gpointer self);
static void cheese_main_window_on_effects_previous (CheeseMainWindow* self);
static void _cheese_main_window_on_effects_previous_gsimple_action_activate_callback (GSimpleAction* action,
                                                                               GVariant* parameter,
                                                                               gpointer self);
CheeseMainWindow* cheese_main_window_new (GtkApplication* application);
CheeseMainWindow* cheese_main_window_construct (GType object_type,
                                                GtkApplication* application);
static void cheese_main_window_set_window_title (CheeseMainWindow* self,
                                          const gchar* title);
static gboolean cheese_main_window_on_window_state_change_event (CheeseMainWindow* self,
                                                          GtkWidget* widget,
                                                          GdkEventWindowState* event);
static gboolean _cheese_main_window_on_window_state_change_event_gtk_widget_window_state_event (GtkWidget* _sender,
                                                                                         GdkEventWindowState* event,
                                                                                         gpointer self);
static void cheese_main_window_do_thumb_view_popup_menu (CheeseMainWindow* self);
static gboolean cheese_main_window_on_thumb_view_popup_menu (CheeseMainWindow* self);
gboolean cheese_main_window_on_thumbnail_button_press_event (CheeseMainWindow* self,
                                                             GtkWidget* iconview,
                                                             GdkEventButton* event);
static void _vala_GtkTreePath_free (GtkTreePath* self);
void cheese_main_window_set_fullscreen (CheeseMainWindow* self,
                                        gboolean fullscreen);
static void cheese_main_window_set_fullscreen_mode (CheeseMainWindow* self,
                                             gboolean fullscreen);
static void cheese_main_window_enable_mode_change (CheeseMainWindow* self);
static void cheese_main_window_disable_mode_change (CheeseMainWindow* self);
static void cheese_main_window_set_resolution (CheeseMainWindow* self,
                                        CheeseMediaMode mode);
static void cheese_main_window_clear_fullscreen_timeout (CheeseMainWindow* self);
static void cheese_main_window_set_fullscreen_timeout (CheeseMainWindow* self);
static gboolean __lambda4_ (CheeseMainWindow* self);
static gboolean ___lambda4__gsource_func (gpointer self);
static gboolean cheese_main_window_fullscreen_motion_notify_callback (CheeseMainWindow* self,
                                                               GtkWidget* viewport,
                                                               GdkEventMotion* e);
static gboolean _cheese_main_window_fullscreen_motion_notify_callback_gtk_widget_motion_notify_event (GtkWidget* _sender,
                                                                                               GdkEventMotion* event,
                                                                                               gpointer self);
void cheese_main_window_set_wide_mode (CheeseMainWindow* self,
                                       gboolean wide_mode);
void cheese_main_window_on_stage_resize (CheeseMainWindow* self,
                                         ClutterActor* actor,
                                         ClutterActorBox* box,
                                         ClutterAllocationFlags flags);
static void cheese_main_window_finish_countdown_callback (CheeseMainWindow* self);
void cheese_main_window_take_photo (CheeseMainWindow* self);
CheeseCountdown* cheese_countdown_new (ClutterText* countdown_actor);
CheeseCountdown* cheese_countdown_construct (GType object_type,
                                             ClutterText* countdown_actor);
void cheese_countdown_start (CheeseCountdown* self,
                             CheeseCountdownCountdownCallback completed_callback,
                             gpointer completed_callback_target);
static void _cheese_main_window_finish_countdown_callback_cheese_countdown_countdown_callback (gpointer self);
static gboolean cheese_main_window_burst_take_photo (CheeseMainWindow* self);
void cheese_main_window_toggle_photo_bursting (CheeseMainWindow* self,
                                               gboolean is_start);
static gboolean cheese_main_window_cancel_running_action (CheeseMainWindow* self);
void cheese_countdown_stop (CheeseCountdown* self);
void cheese_main_window_toggle_video_recording (CheeseMainWindow* self,
                                                gboolean is_start);
static gboolean cheese_main_window_on_key_release (CheeseMainWindow* self,
                                            GdkEventKey* event);
static gboolean cheese_main_window_update_timeout_layer (CheeseMainWindow* self);
static gboolean _cheese_main_window_update_timeout_layer_gsource_func (gpointer self);
static gboolean _cheese_main_window_burst_take_photo_gsource_func (gpointer self);
void cheese_main_window_shoot (CheeseMainWindow* self);
void cheese_main_window_show_error (CheeseMainWindow* self,
                                    const gchar* _error_);
void cheese_main_window_set_effects (CheeseMainWindow* self,
                                     gboolean effects);
static void cheese_main_window_toggle_effects_selector (CheeseMainWindow* self,
                                                 gboolean active);
void cheese_main_window_on_selected_effect_change (CheeseMainWindow* self,
                                                   ClutterTapAction* tap,
                                                   ClutterActor* source);
static gboolean cheese_main_window_is_previous_effects_page (CheeseMainWindow* self);
static void cheese_main_window_activate_effects_page (CheeseMainWindow* self,
                                               gint number);
static gboolean cheese_main_window_is_next_effects_page (CheeseMainWindow* self);
static void cheese_main_window_setup_effects_page_switch_sensitivity (CheeseMainWindow* self);
static void cheese_main_window_update_header_bar_title (CheeseMainWindow* self);
static void cheese_main_window_setup_effects_selector (CheeseMainWindow* self);
CheeseEffectsManager* cheese_effects_manager_new (void);
CheeseEffectsManager* cheese_effects_manager_construct (GType object_type);
void cheese_effects_manager_load_effects (CheeseEffectsManager* self);
static void _cheese_main_window_on_selected_effect_change_clutter_tap_action_tap (ClutterTapAction* _sender,
                                                                           ClutterActor* actor,
                                                                           gpointer self);
void cheese_main_window_camera_state_change_playing (CheeseMainWindow* self);
CheeseEffect* cheese_effects_manager_get_effect (CheeseEffectsManager* self,
                                                 const gchar* name);
void cheese_main_window_camera_state_change_null (CheeseMainWindow* self);
void cheese_main_window_on_switch_camera_clicked (CheeseMainWindow* self);
void cheese_main_window_set_switch_camera_button_state (CheeseMainWindow* self);
void cheese_main_window_setup_ui (CheeseMainWindow* self);
static void _cheese_main_window_on_stage_resize_clutter_actor_allocation_changed (ClutterActor* _sender,
                                                                           ClutterActorBox* box,
                                                                           ClutterAllocationFlags flags,
                                                                           gpointer self);
static gboolean _cheese_main_window_on_thumb_view_popup_menu_gtk_widget_popup_menu (GtkWidget* _sender,
                                                                             gpointer self);
static gboolean _cheese_main_window_on_thumbnail_button_press_event_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                                            GdkEventButton* event,
                                                                                            gpointer self);
static void _cheese_main_window_on_switch_camera_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                      gpointer self);
static gboolean _cheese_main_window_on_key_release_gtk_widget_key_release_event (GtkWidget* _sender,
                                                                          GdkEventKey* event,
                                                                          gpointer self);
ClutterActor* cheese_main_window_get_video_preview (CheeseMainWindow* self);
void cheese_main_window_start_thumbview_monitors (CheeseMainWindow* self);
void cheese_main_window_set_current_mode (CheeseMainWindow* self,
                                          CheeseMediaMode mode);
void cheese_main_window_set_camera (CheeseMainWindow* self,
                                    CheeseCamera* camera);
static void cheese_main_window_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static const GActionEntry CHEESE_MAIN_WINDOW_actions[6] = {{"file-open", _cheese_main_window_on_file_open_gsimple_action_activate_callback}, {"file-saveas", _cheese_main_window_on_file_saveas_gsimple_action_activate_callback}, {"file-trash", _cheese_main_window_on_file_trash_gsimple_action_activate_callback}, {"file-delete", _cheese_main_window_on_file_delete_gsimple_action_activate_callback}, {"effects-next", _cheese_main_window_on_effects_next_gsimple_action_activate_callback}, {"effects-previous", _cheese_main_window_on_effects_previous_gsimple_action_activate_callback}};

static inline gpointer
cheese_main_window_get_instance_private (CheeseMainWindow* self)
{
	return G_STRUCT_MEMBER_P (self, CheeseMainWindow_private_offset);
}

/**
   * Responses from the delete files confirmation dialog.
   *
   * @param SKIP skip a single file
   * @param SKIP_ALL skill all following files
   */
static GType
cheese_main_window_delete_response_get_type (void)
{
	static volatile gsize cheese_main_window_delete_response_type_id__volatile = 0;
	if (g_once_init_enter (&cheese_main_window_delete_response_type_id__volatile)) {
		static const GEnumValue values[] = {{CHEESE_MAIN_WINDOW_DELETE_RESPONSE_SKIP, "CHEESE_MAIN_WINDOW_DELETE_RESPONSE_SKIP", "skip"}, {CHEESE_MAIN_WINDOW_DELETE_RESPONSE_SKIP_ALL, "CHEESE_MAIN_WINDOW_DELETE_RESPONSE_SKIP_ALL", "skip-all"}, {0, NULL, NULL}};
		GType cheese_main_window_delete_response_type_id;
		cheese_main_window_delete_response_type_id = g_enum_register_static ("CheeseMainWindowDeleteResponse", values);
		g_once_init_leave (&cheese_main_window_delete_response_type_id__volatile, cheese_main_window_delete_response_type_id);
	}
	return cheese_main_window_delete_response_type_id__volatile;
}

static void
_g_object_unref0_ (gpointer var)
{
#line 91 "../src/cheese-window.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 367 "cheese-window.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 91 "../src/cheese-window.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 375 "cheese-window.c"
}

static void
_cheese_main_window_on_file_open_gsimple_action_activate_callback (GSimpleAction* action,
                                                                   GVariant* parameter,
                                                                   gpointer self)
{
#line 37 "../src/cheese-window.vala"
	cheese_main_window_on_file_open ((CheeseMainWindow*) self);
#line 385 "cheese-window.c"
}

static void
_cheese_main_window_on_file_saveas_gsimple_action_activate_callback (GSimpleAction* action,
                                                                     GVariant* parameter,
                                                                     gpointer self)
{
#line 37 "../src/cheese-window.vala"
	cheese_main_window_on_file_saveas ((CheeseMainWindow*) self);
#line 395 "cheese-window.c"
}

static void
_cheese_main_window_on_file_trash_gsimple_action_activate_callback (GSimpleAction* action,
                                                                    GVariant* parameter,
                                                                    gpointer self)
{
#line 37 "../src/cheese-window.vala"
	cheese_main_window_on_file_trash ((CheeseMainWindow*) self);
#line 405 "cheese-window.c"
}

static void
_cheese_main_window_on_file_delete_gsimple_action_activate_callback (GSimpleAction* action,
                                                                     GVariant* parameter,
                                                                     gpointer self)
{
#line 37 "../src/cheese-window.vala"
	cheese_main_window_on_file_delete ((CheeseMainWindow*) self);
#line 415 "cheese-window.c"
}

static void
_cheese_main_window_on_effects_next_gsimple_action_activate_callback (GSimpleAction* action,
                                                                      GVariant* parameter,
                                                                      gpointer self)
{
#line 37 "../src/cheese-window.vala"
	cheese_main_window_on_effects_next ((CheeseMainWindow*) self);
#line 425 "cheese-window.c"
}

static void
_cheese_main_window_on_effects_previous_gsimple_action_activate_callback (GSimpleAction* action,
                                                                          GVariant* parameter,
                                                                          gpointer self)
{
#line 37 "../src/cheese-window.vala"
	cheese_main_window_on_effects_previous ((CheeseMainWindow*) self);
#line 435 "cheese-window.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 125 "../src/cheese-window.vala"
	return self ? g_object_ref (self) : NULL;
#line 443 "cheese-window.c"
}

CheeseMainWindow*
cheese_main_window_construct (GType object_type,
                              GtkApplication* application)
{
	CheeseMainWindow * self = NULL;
	GtkBuilder* _tmp0_;
	GObject* _tmp1_;
	GtkHeaderBar* _tmp2_;
	GtkSettings* settings = NULL;
	GtkSettings* _tmp3_;
	GtkSettings* _tmp4_;
	GtkSettings* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
#line 121 "../src/cheese-window.vala"
	g_return_val_if_fail (application != NULL, NULL);
#line 123 "../src/cheese-window.vala"
	self = (CheeseMainWindow*) g_object_new (object_type, "application", application, NULL);
#line 125 "../src/cheese-window.vala"
	_tmp0_ = self->priv->header_bar_ui;
#line 125 "../src/cheese-window.vala"
	_tmp1_ = gtk_builder_get_object (_tmp0_, "header_bar");
#line 125 "../src/cheese-window.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, gtk_header_bar_get_type ()) ? ((GtkHeaderBar*) _tmp1_) : NULL);
#line 125 "../src/cheese-window.vala"
	_g_object_unref0 (self->priv->header_bar);
#line 125 "../src/cheese-window.vala"
	self->priv->header_bar = _tmp2_;
#line 127 "../src/cheese-window.vala"
	_tmp3_ = gtk_settings_get_default ();
#line 127 "../src/cheese-window.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 127 "../src/cheese-window.vala"
	settings = _tmp4_;
#line 129 "../src/cheese-window.vala"
	_tmp5_ = settings;
#line 129 "../src/cheese-window.vala"
	g_object_get (_tmp5_, "gtk-dialogs-use-header", &_tmp6_, NULL);
#line 129 "../src/cheese-window.vala"
	_tmp7_ = _tmp6_;
#line 129 "../src/cheese-window.vala"
	if (_tmp7_) {
#line 488 "cheese-window.c"
		GtkHeaderBar* _tmp8_;
		GtkHeaderBar* _tmp9_;
#line 131 "../src/cheese-window.vala"
		_tmp8_ = self->priv->header_bar;
#line 131 "../src/cheese-window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp8_, TRUE);
#line 132 "../src/cheese-window.vala"
		_tmp9_ = self->priv->header_bar;
#line 132 "../src/cheese-window.vala"
		gtk_window_set_titlebar ((GtkWindow*) self, (GtkWidget*) _tmp9_);
#line 499 "cheese-window.c"
	}
#line 121 "../src/cheese-window.vala"
	_g_object_unref0 (settings);
#line 121 "../src/cheese-window.vala"
	return self;
#line 505 "cheese-window.c"
}

CheeseMainWindow*
cheese_main_window_new (GtkApplication* application)
{
#line 121 "../src/cheese-window.vala"
	return cheese_main_window_construct (CHEESE_TYPE_MAIN_WINDOW, application);
#line 513 "cheese-window.c"
}

static void
cheese_main_window_set_window_title (CheeseMainWindow* self,
                                     const gchar* title)
{
	GtkHeaderBar* _tmp0_;
#line 136 "../src/cheese-window.vala"
	g_return_if_fail (self != NULL);
#line 136 "../src/cheese-window.vala"
	g_return_if_fail (title != NULL);
#line 138 "../src/cheese-window.vala"
	_tmp0_ = self->priv->header_bar;
#line 138 "../src/cheese-window.vala"
	gtk_header_bar_set_title (_tmp0_, title);
#line 139 "../src/cheese-window.vala"
	gtk_window_set_title ((GtkWindow*) self, title);
#line 531 "cheese-window.c"
}

static gboolean
_cheese_main_window_on_window_state_change_event_gtk_widget_window_state_event (GtkWidget* _sender,
                                                                                GdkEventWindowState* event,
                                                                                gpointer self)
{
	gboolean result;
	result = cheese_main_window_on_window_state_change_event ((CheeseMainWindow*) self, _sender, event);
#line 148 "../src/cheese-window.vala"
	return result;
#line 543 "cheese-window.c"
}

static gboolean
cheese_main_window_on_window_state_change_event (CheeseMainWindow* self,
                                                 GtkWidget* widget,
                                                 GdkEventWindowState* event)
{
	GdkWindowState _tmp0_;
	GdkWindowState _tmp1_;
	guint _tmp2_;
	gboolean result = FALSE;
#line 142 "../src/cheese-window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 142 "../src/cheese-window.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 142 "../src/cheese-window.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 145 "../src/cheese-window.vala"
	_tmp0_ = event->new_window_state;
#line 145 "../src/cheese-window.vala"
	_tmp1_ = event->changed_mask;
#line 145 "../src/cheese-window.vala"
	self->priv->was_maximized = ((_tmp0_ - _tmp1_) & GDK_WINDOW_STATE_MAXIMIZED) != 0;
#line 148 "../src/cheese-window.vala"
	g_signal_parse_name ("window-state-event", gtk_widget_get_type (), &_tmp2_, NULL, FALSE);
#line 148 "../src/cheese-window.vala"
	g_signal_handlers_disconnect_matched ((GtkWidget*) self, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _cheese_main_window_on_window_state_change_event_gtk_widget_window_state_event, self);
#line 149 "../src/cheese-window.vala"
	result = FALSE;
#line 149 "../src/cheese-window.vala"
	return result;
#line 575 "cheese-window.c"
}

static void
cheese_main_window_do_thumb_view_popup_menu (CheeseMainWindow* self)
{
	GtkMenu* _tmp0_;
#line 152 "../src/cheese-window.vala"
	g_return_if_fail (self != NULL);
#line 154 "../src/cheese-window.vala"
	_tmp0_ = self->priv->thumbnail_popup;
#line 154 "../src/cheese-window.vala"
	gtk_menu_popup_at_pointer (_tmp0_, NULL);
#line 588 "cheese-window.c"
}

static gboolean
cheese_main_window_on_thumb_view_popup_menu (CheeseMainWindow* self)
{
	gboolean result = FALSE;
#line 157 "../src/cheese-window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 159 "../src/cheese-window.vala"
	cheese_main_window_do_thumb_view_popup_menu (self);
#line 161 "../src/cheese-window.vala"
	result = TRUE;
#line 161 "../src/cheese-window.vala"
	return result;
#line 603 "cheese-window.c"
}

/**
    * Popup a context menu when right-clicking on a thumbnail.
    *
    * @param iconview the thumbnail view that emitted the signal
    * @param event the event
    * @return false to allow further processing of the event, true to indicate
    * that the event was handled completely
    */
static void
_vala_GtkTreePath_free (GtkTreePath* self)
{
#line 176 "../src/cheese-window.vala"
	g_boxed_free (gtk_tree_path_get_type (), self);
#line 619 "cheese-window.c"
}

gboolean
cheese_main_window_on_thumbnail_button_press_event (CheeseMainWindow* self,
                                                    GtkWidget* iconview,
                                                    GdkEventButton* event)
{
	GtkTreePath* path = NULL;
	CheeseThumbView* _tmp0_;
	GtkTreePath* _tmp1_;
	GtkTreePath* _tmp2_;
	CheeseThumbView* _tmp3_;
	GtkTreePath* _tmp4_;
	GdkEventType _tmp10_;
	gboolean result = FALSE;
#line 172 "../src/cheese-window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 172 "../src/cheese-window.vala"
	g_return_val_if_fail (iconview != NULL, FALSE);
#line 172 "../src/cheese-window.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 176 "../src/cheese-window.vala"
	_tmp0_ = self->priv->thumb_view;
#line 176 "../src/cheese-window.vala"
	_tmp1_ = gtk_icon_view_get_path_at_pos ((GtkIconView*) _tmp0_, (gint) event->x, (gint) event->y);
#line 176 "../src/cheese-window.vala"
	__vala_GtkTreePath_free0 (path);
#line 176 "../src/cheese-window.vala"
	path = _tmp1_;
#line 178 "../src/cheese-window.vala"
	_tmp2_ = path;
#line 178 "../src/cheese-window.vala"
	if (_tmp2_ == NULL) {
#line 180 "../src/cheese-window.vala"
		result = FALSE;
#line 180 "../src/cheese-window.vala"
		__vala_GtkTreePath_free0 (path);
#line 180 "../src/cheese-window.vala"
		return result;
#line 659 "cheese-window.c"
	}
#line 183 "../src/cheese-window.vala"
	_tmp3_ = self->priv->thumb_view;
#line 183 "../src/cheese-window.vala"
	_tmp4_ = path;
#line 183 "../src/cheese-window.vala"
	if (!gtk_icon_view_path_is_selected ((GtkIconView*) _tmp3_, _tmp4_)) {
#line 667 "cheese-window.c"
		CheeseThumbView* _tmp5_;
		CheeseThumbView* _tmp6_;
		GtkTreePath* _tmp7_;
		CheeseThumbView* _tmp8_;
		GtkTreePath* _tmp9_;
#line 185 "../src/cheese-window.vala"
		_tmp5_ = self->priv->thumb_view;
#line 185 "../src/cheese-window.vala"
		gtk_icon_view_unselect_all ((GtkIconView*) _tmp5_);
#line 186 "../src/cheese-window.vala"
		_tmp6_ = self->priv->thumb_view;
#line 186 "../src/cheese-window.vala"
		_tmp7_ = path;
#line 186 "../src/cheese-window.vala"
		gtk_icon_view_select_path ((GtkIconView*) _tmp6_, _tmp7_);
#line 187 "../src/cheese-window.vala"
		_tmp8_ = self->priv->thumb_view;
#line 187 "../src/cheese-window.vala"
		_tmp9_ = path;
#line 187 "../src/cheese-window.vala"
		gtk_icon_view_set_cursor ((GtkIconView*) _tmp8_, _tmp9_, NULL, FALSE);
#line 689 "cheese-window.c"
	}
#line 190 "../src/cheese-window.vala"
	_tmp10_ = event->type;
#line 190 "../src/cheese-window.vala"
	if (_tmp10_ == GDK_BUTTON_PRESS) {
#line 695 "cheese-window.c"
		GdkEvent* button_press = NULL;
		GdkEvent* _tmp11_;
#line 192 "../src/cheese-window.vala"
		button_press = (GdkEvent*) event;
#line 194 "../src/cheese-window.vala"
		_tmp11_ = button_press;
#line 194 "../src/cheese-window.vala"
		if (gdk_event_triggers_context_menu (_tmp11_)) {
#line 196 "../src/cheese-window.vala"
			cheese_main_window_do_thumb_view_popup_menu (self);
#line 197 "../src/cheese-window.vala"
			result = TRUE;
#line 197 "../src/cheese-window.vala"
			__vala_GtkTreePath_free0 (path);
#line 197 "../src/cheese-window.vala"
			return result;
#line 712 "cheese-window.c"
		}
	} else {
		GdkEventType _tmp12_;
#line 200 "../src/cheese-window.vala"
		_tmp12_ = event->type;
#line 200 "../src/cheese-window.vala"
		if (_tmp12_ == GDK_2BUTTON_PRESS) {
#line 202 "../src/cheese-window.vala"
			cheese_main_window_on_file_open (self);
#line 203 "../src/cheese-window.vala"
			result = TRUE;
#line 203 "../src/cheese-window.vala"
			__vala_GtkTreePath_free0 (path);
#line 203 "../src/cheese-window.vala"
			return result;
#line 728 "cheese-window.c"
		}
	}
#line 206 "../src/cheese-window.vala"
	result = FALSE;
#line 206 "../src/cheese-window.vala"
	__vala_GtkTreePath_free0 (path);
#line 206 "../src/cheese-window.vala"
	return result;
#line 737 "cheese-window.c"
}

/**
   * Open an image associated with a thumbnail in the default application.
   */
static void
cheese_main_window_on_file_open (CheeseMainWindow* self)
{
	gchar* filename = NULL;
	gchar* uri = NULL;
	GdkScreen* screen = NULL;
	CheeseThumbView* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 212 "../src/cheese-window.vala"
	g_return_if_fail (self != NULL);
#line 217 "../src/cheese-window.vala"
	_tmp0_ = self->priv->thumb_view;
#line 217 "../src/cheese-window.vala"
	_tmp1_ = cheese_thumb_view_get_selected_image (_tmp0_);
#line 217 "../src/cheese-window.vala"
	_g_free0 (filename);
#line 217 "../src/cheese-window.vala"
	filename = _tmp1_;
#line 219 "../src/cheese-window.vala"
	_tmp2_ = filename;
#line 219 "../src/cheese-window.vala"
	if (_tmp2_ == NULL) {
#line 220 "../src/cheese-window.vala"
		_g_object_unref0 (screen);
#line 220 "../src/cheese-window.vala"
		_g_free0 (uri);
#line 220 "../src/cheese-window.vala"
		_g_free0 (filename);
#line 220 "../src/cheese-window.vala"
		return;
#line 775 "cheese-window.c"
	}
	{
		gchar* _tmp3_ = NULL;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		GdkScreen* _tmp7_;
		GdkScreen* _tmp8_;
		GdkScreen* _tmp9_;
		const gchar* _tmp10_;
#line 224 "../src/cheese-window.vala"
		_tmp4_ = filename;
#line 224 "../src/cheese-window.vala"
		_tmp5_ = g_filename_to_uri (_tmp4_, NULL, &_inner_error0_);
#line 224 "../src/cheese-window.vala"
		_tmp3_ = _tmp5_;
#line 224 "../src/cheese-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 794 "cheese-window.c"
			goto __catch5_g_error;
		}
#line 224 "../src/cheese-window.vala"
		_tmp6_ = _tmp3_;
#line 224 "../src/cheese-window.vala"
		_tmp3_ = NULL;
#line 224 "../src/cheese-window.vala"
		_g_free0 (uri);
#line 224 "../src/cheese-window.vala"
		uri = _tmp6_;
#line 225 "../src/cheese-window.vala"
		_tmp7_ = gtk_window_get_screen ((GtkWindow*) self);
#line 225 "../src/cheese-window.vala"
		_tmp8_ = _g_object_ref0 (_tmp7_);
#line 225 "../src/cheese-window.vala"
		_g_object_unref0 (screen);
#line 225 "../src/cheese-window.vala"
		screen = _tmp8_;
#line 226 "../src/cheese-window.vala"
		_tmp9_ = screen;
#line 226 "../src/cheese-window.vala"
		_tmp10_ = uri;
#line 226 "../src/cheese-window.vala"
		gtk_show_uri (_tmp9_, _tmp10_, gtk_get_current_event_time (), &_inner_error0_);
#line 226 "../src/cheese-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 226 "../src/cheese-window.vala"
			_g_free0 (_tmp3_);
#line 823 "cheese-window.c"
			goto __catch5_g_error;
		}
#line 222 "../src/cheese-window.vala"
		_g_free0 (_tmp3_);
#line 828 "cheese-window.c"
	}
	goto __finally5;
	__catch5_g_error:
	{
		GError* err = NULL;
		GtkMessageDialog* error_dialog = NULL;
		const gchar* _tmp11_;
		GtkMessageDialog* _tmp12_;
		GtkMessageDialog* _tmp13_;
		GtkMessageDialog* _tmp14_;
#line 222 "../src/cheese-window.vala"
		err = _inner_error0_;
#line 222 "../src/cheese-window.vala"
		_inner_error0_ = NULL;
#line 230 "../src/cheese-window.vala"
		_tmp11_ = filename;
#line 230 "../src/cheese-window.vala"
		_tmp12_ = (GtkMessageDialog*) gtk_message_dialog_new ((GtkWindow*) self, GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT, GTK_MESSAGE_ERROR, GTK_BUTTONS_OK, _ ("Could not open %s"), _tmp11_);
#line 230 "../src/cheese-window.vala"
		g_object_ref_sink (_tmp12_);
#line 230 "../src/cheese-window.vala"
		error_dialog = _tmp12_;
#line 238 "../src/cheese-window.vala"
		_tmp13_ = error_dialog;
#line 238 "../src/cheese-window.vala"
		gtk_dialog_run ((GtkDialog*) _tmp13_);
#line 239 "../src/cheese-window.vala"
		_tmp14_ = error_dialog;
#line 239 "../src/cheese-window.vala"
		gtk_widget_destroy ((GtkWidget*) _tmp14_);
#line 222 "../src/cheese-window.vala"
		_g_object_unref0 (error_dialog);
#line 222 "../src/cheese-window.vala"
		_g_error_free0 (err);
#line 863 "cheese-window.c"
	}
	__finally5:
#line 222 "../src/cheese-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 222 "../src/cheese-window.vala"
		_g_object_unref0 (screen);
#line 222 "../src/cheese-window.vala"
		_g_free0 (uri);
#line 222 "../src/cheese-window.vala"
		_g_free0 (filename);
#line 222 "../src/cheese-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 222 "../src/cheese-window.vala"
		g_clear_error (&_inner_error0_);
#line 222 "../src/cheese-window.vala"
		return;
#line 880 "cheese-window.c"
	}
#line 212 "../src/cheese-window.vala"
	_g_object_unref0 (screen);
#line 212 "../src/cheese-window.vala"
	_g_free0 (uri);
#line 212 "../src/cheese-window.vala"
	_g_free0 (filename);
#line 888 "cheese-window.c"
}

/**
   * Delete the requested image or images in the thumbview from storage.
   *
   * A confirmation dialog is shown to the user before deleting any files.
   */
static void
cheese_main_window_on_file_delete (CheeseMainWindow* self)
{
	gint response = 0;
	gint error_response = 0;
	gboolean skip_all_errors = FALSE;
	GList* files = NULL;
	CheeseThumbView* _tmp0_;
	GList* _tmp1_;
	guint files_length = 0U;
	GList* _tmp2_;
	GtkMessageDialog* confirmation_dialog = NULL;
	GtkMessageDialog* _tmp3_;
	GtkMessageDialog* _tmp4_;
	GtkMessageDialog* _tmp5_;
	GtkMessageDialog* _tmp6_;
	GtkMessageDialog* _tmp7_;
	GtkMessageDialog* _tmp24_;
	GError* _inner_error0_ = NULL;
#line 248 "../src/cheese-window.vala"
	g_return_if_fail (self != NULL);
#line 252 "../src/cheese-window.vala"
	skip_all_errors = FALSE;
#line 254 "../src/cheese-window.vala"
	_tmp0_ = self->priv->thumb_view;
#line 254 "../src/cheese-window.vala"
	_tmp1_ = cheese_thumb_view_get_selected_images_list (_tmp0_);
#line 254 "../src/cheese-window.vala"
	files = _tmp1_;
#line 255 "../src/cheese-window.vala"
	_tmp2_ = files;
#line 255 "../src/cheese-window.vala"
	files_length = g_list_length (_tmp2_);
#line 257 "../src/cheese-window.vala"
	_tmp3_ = (GtkMessageDialog*) gtk_message_dialog_new_with_markup ((GtkWindow*) self, GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT, GTK_MESSAGE_WARNING, GTK_BUTTONS_NONE, ngettext ("Are you sure you want to permanently delete the file?", "Are you sure you want to permanently delete %d files?", (gulong) files_length), files_length);
#line 257 "../src/cheese-window.vala"
	g_object_ref_sink (_tmp3_);
#line 257 "../src/cheese-window.vala"
	confirmation_dialog = _tmp3_;
#line 263 "../src/cheese-window.vala"
	_tmp4_ = confirmation_dialog;
#line 263 "../src/cheese-window.vala"
	gtk_dialog_add_button ((GtkDialog*) _tmp4_, _ ("_Cancel"), (gint) GTK_RESPONSE_CANCEL);
#line 264 "../src/cheese-window.vala"
	_tmp5_ = confirmation_dialog;
#line 264 "../src/cheese-window.vala"
	gtk_dialog_add_button ((GtkDialog*) _tmp5_, _ ("_Delete"), (gint) GTK_RESPONSE_ACCEPT);
#line 265 "../src/cheese-window.vala"
	_tmp6_ = confirmation_dialog;
#line 265 "../src/cheese-window.vala"
	gtk_message_dialog_format_secondary_text (_tmp6_, "%s", ngettext ("If you delete an item, it will be permanently lost", "If you delete the items, they will be permanently lost", (gulong) files_length));
#line 270 "../src/cheese-window.vala"
	_tmp7_ = confirmation_dialog;
#line 270 "../src/cheese-window.vala"
	response = gtk_dialog_run ((GtkDialog*) _tmp7_);
#line 271 "../src/cheese-window.vala"
	if (response == ((gint) GTK_RESPONSE_ACCEPT)) {
#line 953 "cheese-window.c"
		GList* _tmp8_;
#line 273 "../src/cheese-window.vala"
		_tmp8_ = files;
#line 957 "cheese-window.c"
		{
			GList* file_collection = NULL;
			GList* file_it = NULL;
#line 273 "../src/cheese-window.vala"
			file_collection = _tmp8_;
#line 273 "../src/cheese-window.vala"
			for (file_it = file_collection; file_it != NULL; file_it = file_it->next) {
#line 965 "cheese-window.c"
				GFile* _tmp9_;
				GFile* file = NULL;
#line 273 "../src/cheese-window.vala"
				_tmp9_ = _g_object_ref0 ((GFile*) file_it->data);
#line 273 "../src/cheese-window.vala"
				file = _tmp9_;
#line 972 "cheese-window.c"
				{
					GFile* _tmp10_;
#line 275 "../src/cheese-window.vala"
					_tmp10_ = file;
#line 275 "../src/cheese-window.vala"
					if (_tmp10_ == NULL) {
#line 276 "../src/cheese-window.vala"
						_g_object_unref0 (file);
#line 276 "../src/cheese-window.vala"
						_g_object_unref0 (confirmation_dialog);
#line 276 "../src/cheese-window.vala"
						(files == NULL) ? NULL : (files = (_g_list_free__g_object_unref0_ (files), NULL));
#line 276 "../src/cheese-window.vala"
						return;
#line 987 "cheese-window.c"
					}
					{
						GFile* _tmp11_;
#line 280 "../src/cheese-window.vala"
						_tmp11_ = file;
#line 280 "../src/cheese-window.vala"
						g_file_delete (_tmp11_, NULL, &_inner_error0_);
#line 280 "../src/cheese-window.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 997 "cheese-window.c"
							goto __catch6_g_error;
						}
					}
					goto __finally6;
					__catch6_g_error:
					{
						GError* err = NULL;
						GError* _tmp12_;
						const gchar* _tmp13_;
#line 278 "../src/cheese-window.vala"
						err = _inner_error0_;
#line 278 "../src/cheese-window.vala"
						_inner_error0_ = NULL;
#line 284 "../src/cheese-window.vala"
						_tmp12_ = err;
#line 284 "../src/cheese-window.vala"
						_tmp13_ = _tmp12_->message;
#line 284 "../src/cheese-window.vala"
						g_warning ("cheese-window.vala:284: Unable to delete file: %s", _tmp13_);
#line 286 "../src/cheese-window.vala"
						if (!skip_all_errors) {
#line 1019 "cheese-window.c"
							GtkMessageDialog* error_dialog = NULL;
							GFile* _tmp14_;
							gchar* _tmp15_;
							gchar* _tmp16_;
							GtkMessageDialog* _tmp17_;
							GtkMessageDialog* _tmp18_;
							GtkMessageDialog* _tmp19_;
							GtkMessageDialog* _tmp20_;
							GtkMessageDialog* _tmp21_;
							GtkMessageDialog* _tmp22_;
							GtkMessageDialog* _tmp23_;
#line 287 "../src/cheese-window.vala"
							_tmp14_ = file;
#line 287 "../src/cheese-window.vala"
							_tmp15_ = g_file_get_path (_tmp14_);
#line 287 "../src/cheese-window.vala"
							_tmp16_ = _tmp15_;
#line 287 "../src/cheese-window.vala"
							_tmp17_ = (GtkMessageDialog*) gtk_message_dialog_new ((GtkWindow*) self, GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT, GTK_MESSAGE_ERROR, GTK_BUTTONS_NONE, _ ("Could not delete %s"), _tmp16_);
#line 287 "../src/cheese-window.vala"
							g_object_ref_sink (_tmp17_);
#line 287 "../src/cheese-window.vala"
							_tmp18_ = _tmp17_;
#line 287 "../src/cheese-window.vala"
							_g_free0 (_tmp16_);
#line 287 "../src/cheese-window.vala"
							error_dialog = _tmp18_;
#line 292 "../src/cheese-window.vala"
							_tmp19_ = error_dialog;
#line 292 "../src/cheese-window.vala"
							gtk_dialog_add_button ((GtkDialog*) _tmp19_, _ ("_Cancel"), (gint) GTK_RESPONSE_CANCEL);
#line 293 "../src/cheese-window.vala"
							_tmp20_ = error_dialog;
#line 293 "../src/cheese-window.vala"
							gtk_dialog_add_button ((GtkDialog*) _tmp20_, _ ("Skip"), (gint) CHEESE_MAIN_WINDOW_DELETE_RESPONSE_SKIP);
#line 294 "../src/cheese-window.vala"
							_tmp21_ = error_dialog;
#line 294 "../src/cheese-window.vala"
							gtk_dialog_add_button ((GtkDialog*) _tmp21_, _ ("Skip all"), (gint) CHEESE_MAIN_WINDOW_DELETE_RESPONSE_SKIP_ALL);
#line 296 "../src/cheese-window.vala"
							_tmp22_ = error_dialog;
#line 296 "../src/cheese-window.vala"
							error_response = gtk_dialog_run ((GtkDialog*) _tmp22_);
#line 297 "../src/cheese-window.vala"
							if (error_response == ((gint) CHEESE_MAIN_WINDOW_DELETE_RESPONSE_SKIP_ALL)) {
#line 298 "../src/cheese-window.vala"
								skip_all_errors = TRUE;
#line 1067 "cheese-window.c"
							} else {
#line 299 "../src/cheese-window.vala"
								if (error_response == ((gint) GTK_RESPONSE_CANCEL)) {
#line 300 "../src/cheese-window.vala"
									_g_object_unref0 (error_dialog);
#line 300 "../src/cheese-window.vala"
									_g_error_free0 (err);
#line 300 "../src/cheese-window.vala"
									_g_object_unref0 (file);
#line 300 "../src/cheese-window.vala"
									break;
#line 1079 "cheese-window.c"
								}
							}
#line 303 "../src/cheese-window.vala"
							_tmp23_ = error_dialog;
#line 303 "../src/cheese-window.vala"
							gtk_widget_destroy ((GtkWidget*) _tmp23_);
#line 286 "../src/cheese-window.vala"
							_g_object_unref0 (error_dialog);
#line 1088 "cheese-window.c"
						}
#line 278 "../src/cheese-window.vala"
						_g_error_free0 (err);
#line 1092 "cheese-window.c"
					}
					__finally6:
#line 278 "../src/cheese-window.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 278 "../src/cheese-window.vala"
						_g_object_unref0 (file);
#line 278 "../src/cheese-window.vala"
						_g_object_unref0 (confirmation_dialog);
#line 278 "../src/cheese-window.vala"
						(files == NULL) ? NULL : (files = (_g_list_free__g_object_unref0_ (files), NULL));
#line 278 "../src/cheese-window.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 278 "../src/cheese-window.vala"
						g_clear_error (&_inner_error0_);
#line 278 "../src/cheese-window.vala"
						return;
#line 1109 "cheese-window.c"
					}
#line 273 "../src/cheese-window.vala"
					_g_object_unref0 (file);
#line 1113 "cheese-window.c"
				}
			}
		}
	}
#line 308 "../src/cheese-window.vala"
	_tmp24_ = confirmation_dialog;
#line 308 "../src/cheese-window.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp24_);
#line 248 "../src/cheese-window.vala"
	_g_object_unref0 (confirmation_dialog);
#line 248 "../src/cheese-window.vala"
	(files == NULL) ? NULL : (files = (_g_list_free__g_object_unref0_ (files), NULL));
#line 1126 "cheese-window.c"
}

/**
   * Move the requested image in the thumbview to the trash.
   *
   * A confirmation dialog is shown to the user before moving the file.
   */
static void
cheese_main_window_on_file_trash (CheeseMainWindow* self)
{
	GFile* file = NULL;
	GList* files = NULL;
	CheeseThumbView* _tmp0_;
	GList* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 316 "../src/cheese-window.vala"
	g_return_if_fail (self != NULL);
#line 320 "../src/cheese-window.vala"
	_tmp0_ = self->priv->thumb_view;
#line 320 "../src/cheese-window.vala"
	_tmp1_ = cheese_thumb_view_get_selected_images_list (_tmp0_);
#line 320 "../src/cheese-window.vala"
	files = _tmp1_;
#line 1150 "cheese-window.c"
	{
		gint i = 0;
#line 322 "../src/cheese-window.vala"
		i = 0;
#line 1155 "cheese-window.c"
		{
			gboolean _tmp2_ = FALSE;
#line 322 "../src/cheese-window.vala"
			_tmp2_ = TRUE;
#line 322 "../src/cheese-window.vala"
			while (TRUE) {
#line 1162 "cheese-window.c"
				GList* _tmp4_;
				GList* _tmp5_;
				GList* _tmp6_;
				gconstpointer _tmp7_;
				GFile* _tmp8_;
				GFile* _tmp9_;
#line 322 "../src/cheese-window.vala"
				if (!_tmp2_) {
#line 1171 "cheese-window.c"
					gint _tmp3_;
#line 322 "../src/cheese-window.vala"
					_tmp3_ = i;
#line 322 "../src/cheese-window.vala"
					i = _tmp3_ + 1;
#line 1177 "cheese-window.c"
				}
#line 322 "../src/cheese-window.vala"
				_tmp2_ = FALSE;
#line 322 "../src/cheese-window.vala"
				_tmp4_ = files;
#line 322 "../src/cheese-window.vala"
				if (!(((guint) i) < g_list_length (_tmp4_))) {
#line 322 "../src/cheese-window.vala"
					break;
#line 1187 "cheese-window.c"
				}
#line 324 "../src/cheese-window.vala"
				_tmp5_ = files;
#line 324 "../src/cheese-window.vala"
				_tmp6_ = g_list_nth (_tmp5_, (guint) i);
#line 324 "../src/cheese-window.vala"
				_tmp7_ = _tmp6_->data;
#line 324 "../src/cheese-window.vala"
				_tmp8_ = _g_object_ref0 ((GFile*) _tmp7_);
#line 324 "../src/cheese-window.vala"
				_g_object_unref0 (file);
#line 324 "../src/cheese-window.vala"
				file = _tmp8_;
#line 325 "../src/cheese-window.vala"
				_tmp9_ = file;
#line 325 "../src/cheese-window.vala"
				if (_tmp9_ == NULL) {
#line 326 "../src/cheese-window.vala"
					(files == NULL) ? NULL : (files = (_g_list_free__g_object_unref0_ (files), NULL));
#line 326 "../src/cheese-window.vala"
					_g_object_unref0 (file);
#line 326 "../src/cheese-window.vala"
					return;
#line 1211 "cheese-window.c"
				}
				{
					GFile* _tmp10_;
#line 330 "../src/cheese-window.vala"
					_tmp10_ = file;
#line 330 "../src/cheese-window.vala"
					g_file_trash (_tmp10_, NULL, &_inner_error0_);
#line 330 "../src/cheese-window.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1221 "cheese-window.c"
						goto __catch7_g_error;
					}
				}
				goto __finally7;
				__catch7_g_error:
				{
					GError* err = NULL;
					GtkMessageDialog* error_dialog = NULL;
					GFile* _tmp11_;
					gchar* _tmp12_;
					gchar* _tmp13_;
					GtkMessageDialog* _tmp14_;
					GtkMessageDialog* _tmp15_;
					GtkMessageDialog* _tmp16_;
					GtkMessageDialog* _tmp17_;
#line 328 "../src/cheese-window.vala"
					err = _inner_error0_;
#line 328 "../src/cheese-window.vala"
					_inner_error0_ = NULL;
#line 334 "../src/cheese-window.vala"
					_tmp11_ = file;
#line 334 "../src/cheese-window.vala"
					_tmp12_ = g_file_get_path (_tmp11_);
#line 334 "../src/cheese-window.vala"
					_tmp13_ = _tmp12_;
#line 334 "../src/cheese-window.vala"
					_tmp14_ = (GtkMessageDialog*) gtk_message_dialog_new ((GtkWindow*) self, GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT, GTK_MESSAGE_ERROR, GTK_BUTTONS_OK, _ ("Could not move %s to trash"), _tmp13_);
#line 334 "../src/cheese-window.vala"
					g_object_ref_sink (_tmp14_);
#line 334 "../src/cheese-window.vala"
					_tmp15_ = _tmp14_;
#line 334 "../src/cheese-window.vala"
					_g_free0 (_tmp13_);
#line 334 "../src/cheese-window.vala"
					error_dialog = _tmp15_;
#line 342 "../src/cheese-window.vala"
					_tmp16_ = error_dialog;
#line 342 "../src/cheese-window.vala"
					gtk_dialog_run ((GtkDialog*) _tmp16_);
#line 343 "../src/cheese-window.vala"
					_tmp17_ = error_dialog;
#line 343 "../src/cheese-window.vala"
					gtk_widget_destroy ((GtkWidget*) _tmp17_);
#line 328 "../src/cheese-window.vala"
					_g_object_unref0 (error_dialog);
#line 328 "../src/cheese-window.vala"
					_g_error_free0 (err);
#line 1269 "cheese-window.c"
				}
				__finally7:
#line 328 "../src/cheese-window.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 328 "../src/cheese-window.vala"
					(files == NULL) ? NULL : (files = (_g_list_free__g_object_unref0_ (files), NULL));
#line 328 "../src/cheese-window.vala"
					_g_object_unref0 (file);
#line 328 "../src/cheese-window.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 328 "../src/cheese-window.vala"
					g_clear_error (&_inner_error0_);
#line 328 "../src/cheese-window.vala"
					return;
#line 1284 "cheese-window.c"
				}
			}
		}
	}
#line 316 "../src/cheese-window.vala"
	(files == NULL) ? NULL : (files = (_g_list_free__g_object_unref0_ (files), NULL));
#line 316 "../src/cheese-window.vala"
	_g_object_unref0 (file);
#line 1293 "cheese-window.c"
}

/**
   * Save the selected file in the thumbview to an alternate storage location.
   *
   * A file chooser dialog is shown to the user, asking where the file should
   * be saved and the filename.
   */
static void
cheese_main_window_on_file_saveas (CheeseMainWindow* self)
{
	gchar* filename = NULL;
	gchar* basename = NULL;
	GtkFileChooserDialog* save_as_dialog = NULL;
	gint response = 0;
	CheeseThumbView* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	GtkFileChooserDialog* _tmp3_;
	GtkFileChooserDialog* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	GtkFileChooserDialog* _tmp7_;
	const gchar* _tmp8_;
	GtkFileChooserDialog* _tmp9_;
	const gchar* _tmp10_;
	GtkFileChooserDialog* _tmp11_;
	GtkFileChooserDialog* _tmp12_;
	GtkFileChooserDialog* _tmp25_;
	GError* _inner_error0_ = NULL;
#line 354 "../src/cheese-window.vala"
	g_return_if_fail (self != NULL);
#line 360 "../src/cheese-window.vala"
	_tmp0_ = self->priv->thumb_view;
#line 360 "../src/cheese-window.vala"
	_tmp1_ = cheese_thumb_view_get_selected_image (_tmp0_);
#line 360 "../src/cheese-window.vala"
	_g_free0 (filename);
#line 360 "../src/cheese-window.vala"
	filename = _tmp1_;
#line 361 "../src/cheese-window.vala"
	_tmp2_ = filename;
#line 361 "../src/cheese-window.vala"
	if (_tmp2_ == NULL) {
#line 362 "../src/cheese-window.vala"
		_g_object_unref0 (save_as_dialog);
#line 362 "../src/cheese-window.vala"
		_g_free0 (basename);
#line 362 "../src/cheese-window.vala"
		_g_free0 (filename);
#line 362 "../src/cheese-window.vala"
		return;
#line 1346 "cheese-window.c"
	}
#line 364 "../src/cheese-window.vala"
	_tmp3_ = (GtkFileChooserDialog*) gtk_file_chooser_dialog_new (_ ("Save File"), (GtkWindow*) self, GTK_FILE_CHOOSER_ACTION_SAVE, _ ("_Cancel"), GTK_RESPONSE_CANCEL, _ ("Save"), GTK_RESPONSE_ACCEPT, NULL, NULL);
#line 364 "../src/cheese-window.vala"
	g_object_ref_sink (_tmp3_);
#line 364 "../src/cheese-window.vala"
	_g_object_unref0 (save_as_dialog);
#line 364 "../src/cheese-window.vala"
	save_as_dialog = _tmp3_;
#line 371 "../src/cheese-window.vala"
	_tmp4_ = save_as_dialog;
#line 371 "../src/cheese-window.vala"
	gtk_file_chooser_set_do_overwrite_confirmation ((GtkFileChooser*) _tmp4_, TRUE);
#line 372 "../src/cheese-window.vala"
	_tmp5_ = filename;
#line 372 "../src/cheese-window.vala"
	_tmp6_ = g_filename_display_basename (_tmp5_);
#line 372 "../src/cheese-window.vala"
	_g_free0 (basename);
#line 372 "../src/cheese-window.vala"
	basename = _tmp6_;
#line 373 "../src/cheese-window.vala"
	_tmp7_ = save_as_dialog;
#line 373 "../src/cheese-window.vala"
	_tmp8_ = basename;
#line 373 "../src/cheese-window.vala"
	gtk_file_chooser_set_current_name ((GtkFileChooser*) _tmp7_, _tmp8_);
#line 374 "../src/cheese-window.vala"
	_tmp9_ = save_as_dialog;
#line 374 "../src/cheese-window.vala"
	_tmp10_ = g_get_home_dir ();
#line 374 "../src/cheese-window.vala"
	gtk_file_chooser_set_current_folder ((GtkFileChooser*) _tmp9_, _tmp10_);
#line 376 "../src/cheese-window.vala"
	_tmp11_ = save_as_dialog;
#line 376 "../src/cheese-window.vala"
	response = gtk_dialog_run ((GtkDialog*) _tmp11_);
#line 378 "../src/cheese-window.vala"
	_tmp12_ = save_as_dialog;
#line 378 "../src/cheese-window.vala"
	gtk_widget_hide ((GtkWidget*) _tmp12_);
#line 379 "../src/cheese-window.vala"
	if (response == ((gint) GTK_RESPONSE_ACCEPT)) {
#line 1390 "cheese-window.c"
		gchar* target_filename = NULL;
		GtkFileChooserDialog* _tmp13_;
		gchar* _tmp14_;
		GFile* src = NULL;
		const gchar* _tmp15_;
		GFile* _tmp16_;
		GFile* dest = NULL;
		const gchar* _tmp17_;
		GFile* _tmp18_;
#line 382 "../src/cheese-window.vala"
		_tmp13_ = save_as_dialog;
#line 382 "../src/cheese-window.vala"
		_tmp14_ = gtk_file_chooser_get_filename ((GtkFileChooser*) _tmp13_);
#line 382 "../src/cheese-window.vala"
		_g_free0 (target_filename);
#line 382 "../src/cheese-window.vala"
		target_filename = _tmp14_;
#line 384 "../src/cheese-window.vala"
		_tmp15_ = filename;
#line 384 "../src/cheese-window.vala"
		_tmp16_ = g_file_new_for_path (_tmp15_);
#line 384 "../src/cheese-window.vala"
		src = _tmp16_;
#line 385 "../src/cheese-window.vala"
		_tmp17_ = target_filename;
#line 385 "../src/cheese-window.vala"
		_tmp18_ = g_file_new_for_path (_tmp17_);
#line 385 "../src/cheese-window.vala"
		dest = _tmp18_;
#line 1420 "cheese-window.c"
		{
			GFile* _tmp19_;
			GFile* _tmp20_;
#line 389 "../src/cheese-window.vala"
			_tmp19_ = src;
#line 389 "../src/cheese-window.vala"
			_tmp20_ = dest;
#line 389 "../src/cheese-window.vala"
			g_file_copy (_tmp19_, _tmp20_, G_FILE_COPY_OVERWRITE, NULL, NULL, NULL, &_inner_error0_);
#line 389 "../src/cheese-window.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1432 "cheese-window.c"
				goto __catch8_g_error;
			}
		}
		goto __finally8;
		__catch8_g_error:
		{
			GError* err = NULL;
			GtkMessageDialog* error_dialog = NULL;
			const gchar* _tmp21_;
			GtkMessageDialog* _tmp22_;
			GtkMessageDialog* _tmp23_;
			GtkMessageDialog* _tmp24_;
#line 387 "../src/cheese-window.vala"
			err = _inner_error0_;
#line 387 "../src/cheese-window.vala"
			_inner_error0_ = NULL;
#line 393 "../src/cheese-window.vala"
			_tmp21_ = target_filename;
#line 393 "../src/cheese-window.vala"
			_tmp22_ = (GtkMessageDialog*) gtk_message_dialog_new ((GtkWindow*) self, GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT, GTK_MESSAGE_ERROR, GTK_BUTTONS_OK, _ ("Could not save %s"), _tmp21_);
#line 393 "../src/cheese-window.vala"
			g_object_ref_sink (_tmp22_);
#line 393 "../src/cheese-window.vala"
			error_dialog = _tmp22_;
#line 401 "../src/cheese-window.vala"
			_tmp23_ = error_dialog;
#line 401 "../src/cheese-window.vala"
			gtk_dialog_run ((GtkDialog*) _tmp23_);
#line 402 "../src/cheese-window.vala"
			_tmp24_ = error_dialog;
#line 402 "../src/cheese-window.vala"
			gtk_widget_destroy ((GtkWidget*) _tmp24_);
#line 387 "../src/cheese-window.vala"
			_g_object_unref0 (error_dialog);
#line 387 "../src/cheese-window.vala"
			_g_error_free0 (err);
#line 1469 "cheese-window.c"
		}
		__finally8:
#line 387 "../src/cheese-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 387 "../src/cheese-window.vala"
			_g_object_unref0 (dest);
#line 387 "../src/cheese-window.vala"
			_g_object_unref0 (src);
#line 387 "../src/cheese-window.vala"
			_g_free0 (target_filename);
#line 387 "../src/cheese-window.vala"
			_g_object_unref0 (save_as_dialog);
#line 387 "../src/cheese-window.vala"
			_g_free0 (basename);
#line 387 "../src/cheese-window.vala"
			_g_free0 (filename);
#line 387 "../src/cheese-window.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 387 "../src/cheese-window.vala"
			g_clear_error (&_inner_error0_);
#line 387 "../src/cheese-window.vala"
			return;
#line 1492 "cheese-window.c"
		}
#line 379 "../src/cheese-window.vala"
		_g_object_unref0 (dest);
#line 379 "../src/cheese-window.vala"
		_g_object_unref0 (src);
#line 379 "../src/cheese-window.vala"
		_g_free0 (target_filename);
#line 1500 "cheese-window.c"
	}
#line 405 "../src/cheese-window.vala"
	_tmp25_ = save_as_dialog;
#line 405 "../src/cheese-window.vala"
	gtk_widget_destroy ((GtkWidget*) _tmp25_);
#line 354 "../src/cheese-window.vala"
	_g_object_unref0 (save_as_dialog);
#line 354 "../src/cheese-window.vala"
	_g_free0 (basename);
#line 354 "../src/cheese-window.vala"
	_g_free0 (filename);
#line 1512 "cheese-window.c"
}

/**
     * Toggle fullscreen mode.
     *
     * @param fullscreen whether the window should be fullscreen
     */
void
cheese_main_window_set_fullscreen (CheeseMainWindow* self,
                                   gboolean fullscreen)
{
#line 413 "../src/cheese-window.vala"
	g_return_if_fail (self != NULL);
#line 415 "../src/cheese-window.vala"
	cheese_main_window_set_fullscreen_mode (self, fullscreen);
#line 1528 "cheese-window.c"
}

/**
     * Make the media capture mode actions sensitive.
     */
static void
cheese_main_window_enable_mode_change (CheeseMainWindow* self)
{
	GSimpleAction* mode = NULL;
	GtkApplication* _tmp0_;
	GtkApplication* _tmp1_;
	GAction* _tmp2_;
	GSimpleAction* _tmp3_;
	GSimpleAction* effects = NULL;
	GtkApplication* _tmp4_;
	GtkApplication* _tmp5_;
	GAction* _tmp6_;
	GSimpleAction* _tmp7_;
	GSimpleAction* preferences = NULL;
	GtkApplication* _tmp8_;
	GtkApplication* _tmp9_;
	GAction* _tmp10_;
	GSimpleAction* _tmp11_;
#line 421 "../src/cheese-window.vala"
	g_return_if_fail (self != NULL);
#line 423 "../src/cheese-window.vala"
	_tmp0_ = gtk_window_get_application ((GtkWindow*) self);
#line 423 "../src/cheese-window.vala"
	_tmp1_ = _tmp0_;
#line 423 "../src/cheese-window.vala"
	_tmp2_ = g_action_map_lookup_action ((GActionMap*) _tmp1_, "mode");
#line 423 "../src/cheese-window.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, g_simple_action_get_type ()) ? ((GSimpleAction*) _tmp2_) : NULL);
#line 423 "../src/cheese-window.vala"
	mode = _tmp3_;
#line 424 "../src/cheese-window.vala"
	g_simple_action_set_enabled (mode, TRUE);
#line 425 "../src/cheese-window.vala"
	_tmp4_ = gtk_window_get_application ((GtkWindow*) self);
#line 425 "../src/cheese-window.vala"
	_tmp5_ = _tmp4_;
#line 425 "../src/cheese-window.vala"
	_tmp6_ = g_action_map_lookup_action ((GActionMap*) _tmp5_, "effects");
#line 425 "../src/cheese-window.vala"
	_tmp7_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp6_, g_simple_action_get_type ()) ? ((GSimpleAction*) _tmp6_) : NULL);
#line 425 "../src/cheese-window.vala"
	effects = _tmp7_;
#line 426 "../src/cheese-window.vala"
	g_simple_action_set_enabled (effects, TRUE);
#line 427 "../src/cheese-window.vala"
	_tmp8_ = gtk_window_get_application ((GtkWindow*) self);
#line 427 "../src/cheese-window.vala"
	_tmp9_ = _tmp8_;
#line 427 "../src/cheese-window.vala"
	_tmp10_ = g_action_map_lookup_action ((GActionMap*) _tmp9_, "preferences");
#line 427 "../src/cheese-window.vala"
	_tmp11_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp10_, g_simple_action_get_type ()) ? ((GSimpleAction*) _tmp10_) : NULL);
#line 427 "../src/cheese-window.vala"
	preferences = _tmp11_;
#line 428 "../src/cheese-window.vala"
	g_simple_action_set_enabled (preferences, TRUE);
#line 421 "../src/cheese-window.vala"
	_g_object_unref0 (preferences);
#line 421 "../src/cheese-window.vala"
	_g_object_unref0 (effects);
#line 421 "../src/cheese-window.vala"
	_g_object_unref0 (mode);
#line 1596 "cheese-window.c"
}

/**
     * Make the media capture mode actions insensitive.
     */
static void
cheese_main_window_disable_mode_change (CheeseMainWindow* self)
{
	GSimpleAction* mode = NULL;
	GtkApplication* _tmp0_;
	GtkApplication* _tmp1_;
	GAction* _tmp2_;
	GSimpleAction* _tmp3_;
	GSimpleAction* effects = NULL;
	GtkApplication* _tmp4_;
	GtkApplication* _tmp5_;
	GAction* _tmp6_;
	GSimpleAction* _tmp7_;
	GSimpleAction* preferences = NULL;
	GtkApplication* _tmp8_;
	GtkApplication* _tmp9_;
	GAction* _tmp10_;
	GSimpleAction* _tmp11_;
#line 434 "../src/cheese-window.vala"
	g_return_if_fail (self != NULL);
#line 436 "../src/cheese-window.vala"
	_tmp0_ = gtk_window_get_application ((GtkWindow*) self);
#line 436 "../src/cheese-window.vala"
	_tmp1_ = _tmp0_;
#line 436 "../src/cheese-window.vala"
	_tmp2_ = g_action_map_lookup_action ((GActionMap*) _tmp1_, "mode");
#line 436 "../src/cheese-window.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, g_simple_action_get_type ()) ? ((GSimpleAction*) _tmp2_) : NULL);
#line 436 "../src/cheese-window.vala"
	mode = _tmp3_;
#line 437 "../src/cheese-window.vala"
	g_simple_action_set_enabled (mode, FALSE);
#line 438 "../src/cheese-window.vala"
	_tmp4_ = gtk_window_get_application ((GtkWindow*) self);
#line 438 "../src/cheese-window.vala"
	_tmp5_ = _tmp4_;
#line 438 "../src/cheese-window.vala"
	_tmp6_ = g_action_map_lookup_action ((GActionMap*) _tmp5_, "effects");
#line 438 "../src/cheese-window.vala"
	_tmp7_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp6_, g_simple_action_get_type ()) ? ((GSimpleAction*) _tmp6_) : NULL);
#line 438 "../src/cheese-window.vala"
	effects = _tmp7_;
#line 439 "../src/cheese-window.vala"
	g_simple_action_set_enabled (effects, FALSE);
#line 440 "../src/cheese-window.vala"
	_tmp8_ = gtk_window_get_application ((GtkWindow*) self);
#line 440 "../src/cheese-window.vala"
	_tmp9_ = _tmp8_;
#line 440 "../src/cheese-window.vala"
	_tmp10_ = g_action_map_lookup_action ((GActionMap*) _tmp9_, "preferences");
#line 440 "../src/cheese-window.vala"
	_tmp11_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp10_, g_simple_action_get_type ()) ? ((GSimpleAction*) _tmp10_) : NULL);
#line 440 "../src/cheese-window.vala"
	preferences = _tmp11_;
#line 441 "../src/cheese-window.vala"
	g_simple_action_set_enabled (preferences, FALSE);
#line 434 "../src/cheese-window.vala"
	_g_object_unref0 (preferences);
#line 434 "../src/cheese-window.vala"
	_g_object_unref0 (effects);
#line 434 "../src/cheese-window.vala"
	_g_object_unref0 (mode);
#line 1664 "cheese-window.c"
}

/**
   * Set the capture resolution, based on the current capture mode.
   *
   * @param mode the current capture mode (photo, video or burst)
   */
static void
cheese_main_window_set_resolution (CheeseMainWindow* self,
                                   CheeseMediaMode mode)
{
	CheeseCamera* _tmp0_;
	GList* formats = NULL;
	CheeseCamera* _tmp1_;
	GList* _tmp2_;
	GList* _tmp3_;
	CheeseVideoFormat* format = NULL;
	gint width = 0;
	gint height = 0;
#line 449 "../src/cheese-window.vala"
	g_return_if_fail (self != NULL);
#line 451 "../src/cheese-window.vala"
	_tmp0_ = self->priv->camera;
#line 451 "../src/cheese-window.vala"
	if (_tmp0_ == NULL) {
#line 452 "../src/cheese-window.vala"
		return;
#line 1692 "cheese-window.c"
	}
#line 454 "../src/cheese-window.vala"
	_tmp1_ = self->priv->camera;
#line 454 "../src/cheese-window.vala"
	_tmp2_ = cheese_camera_get_video_formats (_tmp1_);
#line 454 "../src/cheese-window.vala"
	formats = _tmp2_;
#line 456 "../src/cheese-window.vala"
	_tmp3_ = formats;
#line 456 "../src/cheese-window.vala"
	if (_tmp3_ == NULL) {
#line 457 "../src/cheese-window.vala"
		(formats == NULL) ? NULL : (formats = (g_list_free (formats), NULL));
#line 457 "../src/cheese-window.vala"
		return;
#line 1708 "cheese-window.c"
	}
#line 460 "../src/cheese-window.vala"
	width = 0;
#line 461 "../src/cheese-window.vala"
	height = 0;
#line 463 "../src/cheese-window.vala"
	switch (mode) {
#line 463 "../src/cheese-window.vala"
		case CHEESE_MEDIA_MODE_PHOTO:
#line 463 "../src/cheese-window.vala"
		case CHEESE_MEDIA_MODE_BURST:
#line 1720 "cheese-window.c"
		{
			GSettings* _tmp4_;
			GSettings* _tmp5_;
#line 467 "../src/cheese-window.vala"
			_tmp4_ = self->priv->settings;
#line 467 "../src/cheese-window.vala"
			width = g_settings_get_int (_tmp4_, "photo-x-resolution");
#line 468 "../src/cheese-window.vala"
			_tmp5_ = self->priv->settings;
#line 468 "../src/cheese-window.vala"
			height = g_settings_get_int (_tmp5_, "photo-y-resolution");
#line 469 "../src/cheese-window.vala"
			break;
#line 1734 "cheese-window.c"
		}
#line 463 "../src/cheese-window.vala"
		case CHEESE_MEDIA_MODE_VIDEO:
#line 1738 "cheese-window.c"
		{
			GSettings* _tmp6_;
			GSettings* _tmp7_;
#line 471 "../src/cheese-window.vala"
			_tmp6_ = self->priv->settings;
#line 471 "../src/cheese-window.vala"
			width = g_settings_get_int (_tmp6_, "video-x-resolution");
#line 472 "../src/cheese-window.vala"
			_tmp7_ = self->priv->settings;
#line 472 "../src/cheese-window.vala"
			height = g_settings_get_int (_tmp7_, "video-y-resolution");
#line 473 "../src/cheese-window.vala"
			break;
#line 1752 "cheese-window.c"
		}
		default:
#line 463 "../src/cheese-window.vala"
		break;
#line 1757 "cheese-window.c"
	}
	{
		gint i = 0;
#line 476 "../src/cheese-window.vala"
		i = 0;
#line 1763 "cheese-window.c"
		{
			gboolean _tmp8_ = FALSE;
#line 476 "../src/cheese-window.vala"
			_tmp8_ = TRUE;
#line 476 "../src/cheese-window.vala"
			while (TRUE) {
#line 1770 "cheese-window.c"
				GList* _tmp10_;
				GList* _tmp11_;
				GList* _tmp12_;
				gconstpointer _tmp13_;
				gboolean _tmp14_ = FALSE;
				CheeseVideoFormat* _tmp15_;
#line 476 "../src/cheese-window.vala"
				if (!_tmp8_) {
#line 1779 "cheese-window.c"
					gint _tmp9_;
#line 476 "../src/cheese-window.vala"
					_tmp9_ = i;
#line 476 "../src/cheese-window.vala"
					i = _tmp9_ + 1;
#line 1785 "cheese-window.c"
				}
#line 476 "../src/cheese-window.vala"
				_tmp8_ = FALSE;
#line 476 "../src/cheese-window.vala"
				_tmp10_ = formats;
#line 476 "../src/cheese-window.vala"
				if (!(((guint) i) < g_list_length (_tmp10_))) {
#line 476 "../src/cheese-window.vala"
					break;
#line 1795 "cheese-window.c"
				}
#line 478 "../src/cheese-window.vala"
				_tmp11_ = formats;
#line 478 "../src/cheese-window.vala"
				_tmp12_ = g_list_nth (_tmp11_, (guint) i);
#line 478 "../src/cheese-window.vala"
				_tmp13_ = _tmp12_->data;
#line 478 "../src/cheese-window.vala"
				format = (CheeseVideoFormat*) _tmp13_;
#line 479 "../src/cheese-window.vala"
				_tmp15_ = format;
#line 479 "../src/cheese-window.vala"
				if (width == _tmp15_->width) {
#line 1809 "cheese-window.c"
					CheeseVideoFormat* _tmp16_;
#line 479 "../src/cheese-window.vala"
					_tmp16_ = format;
#line 479 "../src/cheese-window.vala"
					_tmp14_ = height == _tmp16_->height;
#line 1815 "cheese-window.c"
				} else {
#line 479 "../src/cheese-window.vala"
					_tmp14_ = FALSE;
#line 1819 "cheese-window.c"
				}
#line 479 "../src/cheese-window.vala"
				if (_tmp14_) {
#line 1823 "cheese-window.c"
					CheeseCamera* _tmp17_;
					CheeseVideoFormat* _tmp18_;
#line 481 "../src/cheese-window.vala"
					_tmp17_ = self->priv->camera;
#line 481 "../src/cheese-window.vala"
					_tmp18_ = format;
#line 481 "../src/cheese-window.vala"
					cheese_camera_set_video_format (_tmp17_, _tmp18_);
#line 482 "../src/cheese-window.vala"
					break;
#line 1834 "cheese-window.c"
				}
			}
		}
	}
#line 449 "../src/cheese-window.vala"
	(formats == NULL) ? NULL : (formats = (g_list_free (formats), NULL));
#line 1841 "cheese-window.c"
}

/**
   * Clear the fullscreen activity timeout.
   */
static void
cheese_main_window_clear_fullscreen_timeout (CheeseMainWindow* self)
{
	GSource* _tmp0_;
#line 491 "../src/cheese-window.vala"
	g_return_if_fail (self != NULL);
#line 493 "../src/cheese-window.vala"
	_tmp0_ = self->priv->fullscreen_timeout;
#line 493 "../src/cheese-window.vala"
	if (_tmp0_ != NULL) {
#line 1857 "cheese-window.c"
		GSource* _tmp1_;
#line 495 "../src/cheese-window.vala"
		_tmp1_ = self->priv->fullscreen_timeout;
#line 495 "../src/cheese-window.vala"
		g_source_destroy (_tmp1_);
#line 496 "../src/cheese-window.vala"
		_g_source_unref0 (self->priv->fullscreen_timeout);
#line 496 "../src/cheese-window.vala"
		self->priv->fullscreen_timeout = NULL;
#line 1867 "cheese-window.c"
	}
}

/**
   * Set the fullscreen timeout, for hiding the UI if there is no mouse
   * movement.
   */
static gboolean
__lambda4_ (CheeseMainWindow* self)
{
	GtkWidget* _tmp0_;
	gboolean result = FALSE;
#line 508 "../src/cheese-window.vala"
	_tmp0_ = self->priv->buttons_area;
#line 508 "../src/cheese-window.vala"
	gtk_widget_hide (_tmp0_);
#line 509 "../src/cheese-window.vala"
	cheese_main_window_clear_fullscreen_timeout (self);
#line 510 "../src/cheese-window.vala"
	gtk_window_fullscreen ((GtkWindow*) self);
#line 511 "../src/cheese-window.vala"
	result = TRUE;
#line 511 "../src/cheese-window.vala"
	return result;
#line 1892 "cheese-window.c"
}

static gboolean
___lambda4__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda4_ ((CheeseMainWindow*) self);
#line 508 "../src/cheese-window.vala"
	return result;
#line 1902 "cheese-window.c"
}

static void
cheese_main_window_set_fullscreen_timeout (CheeseMainWindow* self)
{
	GSource* _tmp0_;
	GSource* _tmp1_;
	GSource* _tmp2_;
#line 504 "../src/cheese-window.vala"
	g_return_if_fail (self != NULL);
#line 506 "../src/cheese-window.vala"
	_tmp0_ = g_timeout_source_new ((guint) FULLSCREEN_TIMEOUT_INTERVAL);
#line 506 "../src/cheese-window.vala"
	_g_source_unref0 (self->priv->fullscreen_timeout);
#line 506 "../src/cheese-window.vala"
	self->priv->fullscreen_timeout = _tmp0_;
#line 507 "../src/cheese-window.vala"
	_tmp1_ = self->priv->fullscreen_timeout;
#line 507 "../src/cheese-window.vala"
	g_source_attach (_tmp1_, NULL);
#line 508 "../src/cheese-window.vala"
	_tmp2_ = self->priv->fullscreen_timeout;
#line 508 "../src/cheese-window.vala"
	g_source_set_callback (_tmp2_, ___lambda4__gsource_func, g_object_ref (self), g_object_unref);
#line 1927 "cheese-window.c"
}

/**
     * Show the UI in fullscreen if there is any mouse activity.
     *
     * Start a new timeout at the end of every mouse pointer movement. All
     * timeouts will be cancelled, except one created during the last movement
     * event. Show() is called even if the button is not hidden.
     *
     * @param viewport the widget to check for mouse activity on
     * @param e the (unused) event
     */
static gboolean
cheese_main_window_fullscreen_motion_notify_callback (CheeseMainWindow* self,
                                                      GtkWidget* viewport,
                                                      GdkEventMotion* e)
{
	GtkWidget* _tmp0_;
	gboolean result = FALSE;
#line 524 "../src/cheese-window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 524 "../src/cheese-window.vala"
	g_return_val_if_fail (viewport != NULL, FALSE);
#line 524 "../src/cheese-window.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 527 "../src/cheese-window.vala"
	cheese_main_window_clear_fullscreen_timeout (self);
#line 528 "../src/cheese-window.vala"
	gtk_window_unfullscreen ((GtkWindow*) self);
#line 529 "../src/cheese-window.vala"
	gtk_window_maximize ((GtkWindow*) self);
#line 530 "../src/cheese-window.vala"
	_tmp0_ = self->priv->buttons_area;
#line 530 "../src/cheese-window.vala"
	gtk_widget_show (_tmp0_);
#line 531 "../src/cheese-window.vala"
	cheese_main_window_set_fullscreen_timeout (self);
#line 532 "../src/cheese-window.vala"
	result = TRUE;
#line 532 "../src/cheese-window.vala"
	return result;
#line 1969 "cheese-window.c"
}

/**
   * Enable or disable fullscreen mode to the requested state.
   *
   * @param fullscreen_mode whether to enable or disable fullscreen mode
   */
static gboolean
_cheese_main_window_fullscreen_motion_notify_callback_gtk_widget_motion_notify_event (GtkWidget* _sender,
                                                                                      GdkEventMotion* event,
                                                                                      gpointer self)
{
	gboolean result;
	result = cheese_main_window_fullscreen_motion_notify_callback ((CheeseMainWindow*) self, _sender, event);
#line 564 "../src/cheese-window.vala"
	return result;
#line 1986 "cheese-window.c"
}

static void
cheese_main_window_set_fullscreen_mode (CheeseMainWindow* self,
                                        gboolean fullscreen)
{
#line 540 "../src/cheese-window.vala"
	g_return_if_fail (self != NULL);
#line 547 "../src/cheese-window.vala"
	self->priv->is_fullscreen = fullscreen;
#line 548 "../src/cheese-window.vala"
	if (fullscreen) {
#line 1999 "cheese-window.c"
		GtkWidget* _tmp2_;
		GtkWidget* _tmp3_;
		GtkClutterEmbed* _tmp4_;
#line 550 "../src/cheese-window.vala"
		g_signal_connect_object ((GtkWidget*) self, "window-state-event", (GCallback) _cheese_main_window_on_window_state_change_event_gtk_widget_window_state_event, self, 0);
#line 552 "../src/cheese-window.vala"
		if (self->priv->is_wide_mode) {
#line 2007 "cheese-window.c"
			GtkBox* _tmp0_;
#line 554 "../src/cheese-window.vala"
			_tmp0_ = self->priv->thumbnails_right;
#line 554 "../src/cheese-window.vala"
			gtk_widget_hide ((GtkWidget*) _tmp0_);
#line 2013 "cheese-window.c"
		} else {
			GtkBox* _tmp1_;
#line 558 "../src/cheese-window.vala"
			_tmp1_ = self->priv->thumbnails_bottom;
#line 558 "../src/cheese-window.vala"
			gtk_widget_hide ((GtkWidget*) _tmp1_);
#line 2020 "cheese-window.c"
		}
#line 560 "../src/cheese-window.vala"
		_tmp2_ = self->priv->leave_fullscreen_button_box;
#line 560 "../src/cheese-window.vala"
		gtk_widget_set_no_show_all (_tmp2_, FALSE);
#line 561 "../src/cheese-window.vala"
		_tmp3_ = self->priv->leave_fullscreen_button_box;
#line 561 "../src/cheese-window.vala"
		gtk_widget_show_all (_tmp3_);
#line 563 "../src/cheese-window.vala"
		gtk_window_fullscreen ((GtkWindow*) self);
#line 564 "../src/cheese-window.vala"
		_tmp4_ = self->priv->viewport_widget;
#line 564 "../src/cheese-window.vala"
		g_signal_connect_object ((GtkWidget*) _tmp4_, "motion-notify-event", (GCallback) _cheese_main_window_fullscreen_motion_notify_callback_gtk_widget_motion_notify_event, self, 0);
#line 565 "../src/cheese-window.vala"
		cheese_main_window_set_fullscreen_timeout (self);
#line 2038 "cheese-window.c"
	} else {
		GtkWidget* _tmp7_;
		GtkWidget* _tmp8_;
		GtkClutterEmbed* _tmp9_;
		guint _tmp10_;
#line 569 "../src/cheese-window.vala"
		if (self->priv->is_wide_mode) {
#line 2046 "cheese-window.c"
			GtkBox* _tmp5_;
#line 571 "../src/cheese-window.vala"
			_tmp5_ = self->priv->thumbnails_right;
#line 571 "../src/cheese-window.vala"
			gtk_widget_show_all ((GtkWidget*) _tmp5_);
#line 2052 "cheese-window.c"
		} else {
			GtkBox* _tmp6_;
#line 575 "../src/cheese-window.vala"
			_tmp6_ = self->priv->thumbnails_bottom;
#line 575 "../src/cheese-window.vala"
			gtk_widget_show_all ((GtkWidget*) _tmp6_);
#line 2059 "cheese-window.c"
		}
#line 577 "../src/cheese-window.vala"
		_tmp7_ = self->priv->leave_fullscreen_button_box;
#line 577 "../src/cheese-window.vala"
		gtk_widget_hide (_tmp7_);
#line 581 "../src/cheese-window.vala"
		cheese_main_window_clear_fullscreen_timeout (self);
#line 583 "../src/cheese-window.vala"
		_tmp8_ = self->priv->buttons_area;
#line 583 "../src/cheese-window.vala"
		gtk_widget_show (_tmp8_);
#line 584 "../src/cheese-window.vala"
		_tmp9_ = self->priv->viewport_widget;
#line 584 "../src/cheese-window.vala"
		g_signal_parse_name ("motion-notify-event", gtk_widget_get_type (), &_tmp10_, NULL, FALSE);
#line 584 "../src/cheese-window.vala"
		g_signal_handlers_disconnect_matched ((GtkWidget*) _tmp9_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp10_, 0, NULL, (GCallback) _cheese_main_window_fullscreen_motion_notify_callback_gtk_widget_motion_notify_event, self);
#line 585 "../src/cheese-window.vala"
		gtk_window_unfullscreen ((GtkWindow*) self);
#line 587 "../src/cheese-window.vala"
		if (self->priv->was_maximized) {
#line 589 "../src/cheese-window.vala"
			gtk_window_maximize ((GtkWindow*) self);
#line 2083 "cheese-window.c"
		} else {
#line 593 "../src/cheese-window.vala"
			gtk_window_unmaximize ((GtkWindow*) self);
#line 2087 "cheese-window.c"
		}
	}
}

/**
   * Enable or disable wide mode to the requested state.
   *
   * @param wide_mode whether to enable or disable wide mode
   */
void
cheese_main_window_set_wide_mode (CheeseMainWindow* self,
                                  gboolean wide_mode)
{
	GtkAllocation alloc = {0};
	GtkClutterEmbed* _tmp0_;
	GtkAllocation _tmp1_ = {0};
	GtkClutterEmbed* _tmp2_;
	GtkAllocation _tmp3_;
	GtkAllocation _tmp4_;
	GtkRequisition req = {0};
	GtkRequisition _tmp29_ = {0};
	GtkRequisition _tmp30_ = {0};
	GtkRequisition _tmp31_;
	GtkRequisition _tmp32_;
	GtkClutterEmbed* _tmp33_;
#line 603 "../src/cheese-window.vala"
	g_return_if_fail (self != NULL);
#line 605 "../src/cheese-window.vala"
	self->priv->is_wide_mode = wide_mode;
#line 611 "../src/cheese-window.vala"
	_tmp0_ = self->priv->viewport_widget;
#line 611 "../src/cheese-window.vala"
	gtk_widget_get_allocation ((GtkWidget*) _tmp0_, &_tmp1_);
#line 611 "../src/cheese-window.vala"
	alloc = _tmp1_;
#line 612 "../src/cheese-window.vala"
	_tmp2_ = self->priv->viewport_widget;
#line 612 "../src/cheese-window.vala"
	_tmp3_ = alloc;
#line 612 "../src/cheese-window.vala"
	_tmp4_ = alloc;
#line 612 "../src/cheese-window.vala"
	gtk_widget_set_size_request ((GtkWidget*) _tmp2_, _tmp3_.width, _tmp4_.height);
#line 614 "../src/cheese-window.vala"
	if (self->priv->is_wide_mode) {
#line 2133 "cheese-window.c"
		CheeseThumbView* _tmp5_;
		EogThumbNav* _tmp6_;
		GtkBox* _tmp7_;
		GList* _tmp8_;
		GList* _tmp9_;
		gboolean _tmp10_;
		GtkBox* _tmp13_;
		EogThumbNav* _tmp14_;
#line 616 "../src/cheese-window.vala"
		_tmp5_ = self->priv->thumb_view;
#line 616 "../src/cheese-window.vala"
		cheese_thumb_view_set_vertical (_tmp5_, TRUE);
#line 617 "../src/cheese-window.vala"
		_tmp6_ = self->priv->thumb_nav;
#line 617 "../src/cheese-window.vala"
		eog_thumb_nav_set_vertical (_tmp6_, TRUE);
#line 618 "../src/cheese-window.vala"
		_tmp7_ = self->priv->thumbnails_bottom;
#line 618 "../src/cheese-window.vala"
		_tmp8_ = gtk_container_get_children ((GtkContainer*) _tmp7_);
#line 618 "../src/cheese-window.vala"
		_tmp9_ = _tmp8_;
#line 618 "../src/cheese-window.vala"
		_tmp10_ = _tmp9_ != NULL;
#line 618 "../src/cheese-window.vala"
		(_tmp9_ == NULL) ? NULL : (_tmp9_ = (g_list_free (_tmp9_), NULL));
#line 618 "../src/cheese-window.vala"
		if (_tmp10_) {
#line 2162 "cheese-window.c"
			GtkBox* _tmp11_;
			EogThumbNav* _tmp12_;
#line 620 "../src/cheese-window.vala"
			_tmp11_ = self->priv->thumbnails_bottom;
#line 620 "../src/cheese-window.vala"
			_tmp12_ = self->priv->thumb_nav;
#line 620 "../src/cheese-window.vala"
			gtk_container_remove ((GtkContainer*) _tmp11_, (GtkWidget*) _tmp12_);
#line 2171 "cheese-window.c"
		}
#line 622 "../src/cheese-window.vala"
		_tmp13_ = self->priv->thumbnails_right;
#line 622 "../src/cheese-window.vala"
		_tmp14_ = self->priv->thumb_nav;
#line 622 "../src/cheese-window.vala"
		gtk_container_add ((GtkContainer*) _tmp13_, (GtkWidget*) _tmp14_);
#line 624 "../src/cheese-window.vala"
		if (!self->priv->is_fullscreen) {
#line 2181 "cheese-window.c"
			GtkBox* _tmp15_;
			GtkBox* _tmp16_;
#line 626 "../src/cheese-window.vala"
			_tmp15_ = self->priv->thumbnails_right;
#line 626 "../src/cheese-window.vala"
			gtk_widget_show_all ((GtkWidget*) _tmp15_);
#line 627 "../src/cheese-window.vala"
			_tmp16_ = self->priv->thumbnails_bottom;
#line 627 "../src/cheese-window.vala"
			gtk_widget_hide ((GtkWidget*) _tmp16_);
#line 2192 "cheese-window.c"
		}
	} else {
		CheeseThumbView* _tmp17_;
		EogThumbNav* _tmp18_;
		GtkBox* _tmp19_;
		GList* _tmp20_;
		GList* _tmp21_;
		gboolean _tmp22_;
		GtkBox* _tmp25_;
		EogThumbNav* _tmp26_;
#line 632 "../src/cheese-window.vala"
		_tmp17_ = self->priv->thumb_view;
#line 632 "../src/cheese-window.vala"
		cheese_thumb_view_set_vertical (_tmp17_, FALSE);
#line 633 "../src/cheese-window.vala"
		_tmp18_ = self->priv->thumb_nav;
#line 633 "../src/cheese-window.vala"
		eog_thumb_nav_set_vertical (_tmp18_, FALSE);
#line 634 "../src/cheese-window.vala"
		_tmp19_ = self->priv->thumbnails_right;
#line 634 "../src/cheese-window.vala"
		_tmp20_ = gtk_container_get_children ((GtkContainer*) _tmp19_);
#line 634 "../src/cheese-window.vala"
		_tmp21_ = _tmp20_;
#line 634 "../src/cheese-window.vala"
		_tmp22_ = _tmp21_ != NULL;
#line 634 "../src/cheese-window.vala"
		(_tmp21_ == NULL) ? NULL : (_tmp21_ = (g_list_free (_tmp21_), NULL));
#line 634 "../src/cheese-window.vala"
		if (_tmp22_) {
#line 2223 "cheese-window.c"
			GtkBox* _tmp23_;
			EogThumbNav* _tmp24_;
#line 636 "../src/cheese-window.vala"
			_tmp23_ = self->priv->thumbnails_right;
#line 636 "../src/cheese-window.vala"
			_tmp24_ = self->priv->thumb_nav;
#line 636 "../src/cheese-window.vala"
			gtk_container_remove ((GtkContainer*) _tmp23_, (GtkWidget*) _tmp24_);
#line 2232 "cheese-window.c"
		}
#line 638 "../src/cheese-window.vala"
		_tmp25_ = self->priv->thumbnails_bottom;
#line 638 "../src/cheese-window.vala"
		_tmp26_ = self->priv->thumb_nav;
#line 638 "../src/cheese-window.vala"
		gtk_container_add ((GtkContainer*) _tmp25_, (GtkWidget*) _tmp26_);
#line 640 "../src/cheese-window.vala"
		if (!self->priv->is_fullscreen) {
#line 2242 "cheese-window.c"
			GtkBox* _tmp27_;
			GtkBox* _tmp28_;
#line 642 "../src/cheese-window.vala"
			_tmp27_ = self->priv->thumbnails_bottom;
#line 642 "../src/cheese-window.vala"
			gtk_widget_show_all ((GtkWidget*) _tmp27_);
#line 643 "../src/cheese-window.vala"
			_tmp28_ = self->priv->thumbnails_right;
#line 643 "../src/cheese-window.vala"
			gtk_widget_hide ((GtkWidget*) _tmp28_);
#line 2253 "cheese-window.c"
		}
	}
#line 653 "../src/cheese-window.vala"
	gtk_widget_get_preferred_size ((GtkWidget*) self, &_tmp29_, &_tmp30_);
#line 653 "../src/cheese-window.vala"
	req = _tmp29_;
#line 653 "../src/cheese-window.vala"
	req = _tmp30_;
#line 654 "../src/cheese-window.vala"
	_tmp31_ = req;
#line 654 "../src/cheese-window.vala"
	_tmp32_ = req;
#line 654 "../src/cheese-window.vala"
	gtk_window_resize ((GtkWindow*) self, _tmp31_.width, _tmp32_.height);
#line 655 "../src/cheese-window.vala"
	_tmp33_ = self->priv->viewport_widget;
#line 655 "../src/cheese-window.vala"
	gtk_widget_set_size_request ((GtkWidget*) _tmp33_, -1, -1);
#line 2272 "cheese-window.c"
}

/**
   * Make sure that the layout manager manages the entire stage.
   *
   * @param actor unused
   * @param box unused
   * @param flags unused
   */
void
cheese_main_window_on_stage_resize (CheeseMainWindow* self,
                                    ClutterActor* actor,
                                    ClutterActorBox* box,
                                    ClutterAllocationFlags flags)
{
	ClutterActor* _tmp0_;
	ClutterStage* _tmp1_;
	gfloat _tmp2_;
	gfloat _tmp3_;
	ClutterStage* _tmp4_;
	gfloat _tmp5_;
	gfloat _tmp6_;
	ClutterActor* _tmp7_;
	ClutterStage* _tmp8_;
	gfloat _tmp9_;
	gfloat _tmp10_;
	ClutterStage* _tmp11_;
	gfloat _tmp12_;
	gfloat _tmp13_;
	ClutterText* _tmp14_;
	ClutterActor* _tmp15_;
	gfloat _tmp16_;
	gfloat _tmp17_;
	ClutterStage* _tmp18_;
	gfloat _tmp19_;
	gfloat _tmp20_;
	ClutterStage* _tmp21_;
	gfloat _tmp22_;
	gfloat _tmp23_;
#line 665 "../src/cheese-window.vala"
	g_return_if_fail (self != NULL);
#line 665 "../src/cheese-window.vala"
	g_return_if_fail (actor != NULL);
#line 665 "../src/cheese-window.vala"
	g_return_if_fail (box != NULL);
#line 669 "../src/cheese-window.vala"
	_tmp0_ = self->priv->viewport_layout;
#line 669 "../src/cheese-window.vala"
	_tmp1_ = self->priv->viewport;
#line 669 "../src/cheese-window.vala"
	_tmp2_ = clutter_actor_get_width ((ClutterActor*) _tmp1_);
#line 669 "../src/cheese-window.vala"
	_tmp3_ = _tmp2_;
#line 669 "../src/cheese-window.vala"
	_tmp4_ = self->priv->viewport;
#line 669 "../src/cheese-window.vala"
	_tmp5_ = clutter_actor_get_height ((ClutterActor*) _tmp4_);
#line 669 "../src/cheese-window.vala"
	_tmp6_ = _tmp5_;
#line 669 "../src/cheese-window.vala"
	clutter_actor_set_size (_tmp0_, _tmp3_, _tmp6_);
#line 670 "../src/cheese-window.vala"
	_tmp7_ = self->priv->background_layer;
#line 670 "../src/cheese-window.vala"
	_tmp8_ = self->priv->viewport;
#line 670 "../src/cheese-window.vala"
	_tmp9_ = clutter_actor_get_width ((ClutterActor*) _tmp8_);
#line 670 "../src/cheese-window.vala"
	_tmp10_ = _tmp9_;
#line 670 "../src/cheese-window.vala"
	_tmp11_ = self->priv->viewport;
#line 670 "../src/cheese-window.vala"
	_tmp12_ = clutter_actor_get_height ((ClutterActor*) _tmp11_);
#line 670 "../src/cheese-window.vala"
	_tmp13_ = _tmp12_;
#line 670 "../src/cheese-window.vala"
	clutter_actor_set_size (_tmp7_, _tmp10_, _tmp13_);
#line 671 "../src/cheese-window.vala"
	_tmp14_ = self->priv->timeout_layer;
#line 671 "../src/cheese-window.vala"
	_tmp15_ = self->priv->video_preview;
#line 671 "../src/cheese-window.vala"
	_tmp16_ = clutter_actor_get_width (_tmp15_);
#line 671 "../src/cheese-window.vala"
	_tmp17_ = _tmp16_;
#line 671 "../src/cheese-window.vala"
	_tmp18_ = self->priv->viewport;
#line 671 "../src/cheese-window.vala"
	_tmp19_ = clutter_actor_get_width ((ClutterActor*) _tmp18_);
#line 671 "../src/cheese-window.vala"
	_tmp20_ = _tmp19_;
#line 671 "../src/cheese-window.vala"
	_tmp21_ = self->priv->viewport;
#line 671 "../src/cheese-window.vala"
	_tmp22_ = clutter_actor_get_height ((ClutterActor*) _tmp21_);
#line 671 "../src/cheese-window.vala"
	_tmp23_ = _tmp22_;
#line 671 "../src/cheese-window.vala"
	clutter_actor_set_position ((ClutterActor*) _tmp14_, (_tmp17_ / 3) + (_tmp20_ / 2), _tmp23_ - 20);
#line 2372 "cheese-window.c"
}

/**
   * The method to call when the countdown is finished.
   */
static void
cheese_main_window_finish_countdown_callback (CheeseMainWindow* self)
{
	CheeseMediaMode _tmp8_;
#line 678 "../src/cheese-window.vala"
	g_return_if_fail (self != NULL);
#line 680 "../src/cheese-window.vala"
	if (self->priv->action_cancelled == FALSE) {
#line 2386 "cheese-window.c"
		gchar* file_name = NULL;
		CheeseFileUtil* _tmp0_;
		CheeseMediaMode _tmp1_;
		gchar* _tmp2_;
		GSettings* _tmp3_;
		GtkWidget* _tmp5_;
		CheeseCamera* _tmp6_;
		const gchar* _tmp7_;
#line 682 "../src/cheese-window.vala"
		_tmp0_ = self->priv->fileutil;
#line 682 "../src/cheese-window.vala"
		_tmp1_ = self->priv->current_mode;
#line 682 "../src/cheese-window.vala"
		_tmp2_ = cheese_fileutil_get_new_media_filename (_tmp0_, _tmp1_);
#line 682 "../src/cheese-window.vala"
		file_name = _tmp2_;
#line 684 "../src/cheese-window.vala"
		_tmp3_ = self->priv->settings;
#line 684 "../src/cheese-window.vala"
		if (g_settings_get_boolean (_tmp3_, "flash")) {
#line 2407 "cheese-window.c"
			CheeseFlash* _tmp4_;
#line 686 "../src/cheese-window.vala"
			_tmp4_ = self->priv->flash;
#line 686 "../src/cheese-window.vala"
			cheese_flash_fire (_tmp4_);
#line 2413 "cheese-window.c"
		}
#line 688 "../src/cheese-window.vala"
		_tmp5_ = self->priv->main_vbox;
#line 688 "../src/cheese-window.vala"
		ca_gtk_play_for_widget (_tmp5_, (guint32) 0, CA_PROP_EVENT_ID, "camera-shutter", CA_PROP_MEDIA_ROLE, "event", CA_PROP_EVENT_DESCRIPTION, _ ("Shutter sound"), NULL, NULL);
#line 693 "../src/cheese-window.vala"
		_tmp6_ = self->priv->camera;
#line 693 "../src/cheese-window.vala"
		_tmp7_ = file_name;
#line 693 "../src/cheese-window.vala"
		cheese_camera_take_photo (_tmp6_, _tmp7_);
#line 680 "../src/cheese-window.vala"
		_g_free0 (file_name);
#line 2427 "cheese-window.c"
	}
#line 696 "../src/cheese-window.vala"
	_tmp8_ = self->priv->current_mode;
#line 696 "../src/cheese-window.vala"
	if (_tmp8_ == CHEESE_MEDIA_MODE_PHOTO) {
#line 698 "../src/cheese-window.vala"
		cheese_main_window_enable_mode_change (self);
#line 2435 "cheese-window.c"
	}
}

/**
   * Start to take a photo, starting a countdown if it is enabled.
   */
static void
_cheese_main_window_finish_countdown_callback_cheese_countdown_countdown_callback (gpointer self)
{
#line 716 "../src/cheese-window.vala"
	cheese_main_window_finish_countdown_callback ((CheeseMainWindow*) self);
#line 2447 "cheese-window.c"
}

void
cheese_main_window_take_photo (CheeseMainWindow* self)
{
	GSettings* _tmp0_;
#line 706 "../src/cheese-window.vala"
	g_return_if_fail (self != NULL);
#line 708 "../src/cheese-window.vala"
	_tmp0_ = self->priv->settings;
#line 708 "../src/cheese-window.vala"
	if (g_settings_get_boolean (_tmp0_, "countdown")) {
#line 2460 "cheese-window.c"
		CheeseMediaMode _tmp1_;
		ClutterText* _tmp2_;
		CheeseCountdown* _tmp3_;
		CheeseCountdown* _tmp4_;
#line 710 "../src/cheese-window.vala"
		_tmp1_ = self->priv->current_mode;
#line 710 "../src/cheese-window.vala"
		if (_tmp1_ == CHEESE_MEDIA_MODE_PHOTO) {
#line 712 "../src/cheese-window.vala"
			cheese_main_window_disable_mode_change (self);
#line 2471 "cheese-window.c"
		}
#line 715 "../src/cheese-window.vala"
		_tmp2_ = self->priv->countdown_layer;
#line 715 "../src/cheese-window.vala"
		_tmp3_ = cheese_countdown_new (_tmp2_);
#line 715 "../src/cheese-window.vala"
		_g_object_unref0 (self->priv->current_countdown);
#line 715 "../src/cheese-window.vala"
		self->priv->current_countdown = _tmp3_;
#line 716 "../src/cheese-window.vala"
		_tmp4_ = self->priv->current_countdown;
#line 716 "../src/cheese-window.vala"
		cheese_countdown_start (_tmp4_, _cheese_main_window_finish_countdown_callback_cheese_countdown_countdown_callback, self);
#line 2485 "cheese-window.c"
	} else {
#line 720 "../src/cheese-window.vala"
		cheese_main_window_finish_countdown_callback (self);
#line 2489 "cheese-window.c"
	}
}

/**
   * Take a photo during burst mode, and increment the burst count.
   *
   * @return true if there are more photos to be taken in the current burst,
   * false otherwise
   */
static gboolean
cheese_main_window_burst_take_photo (CheeseMainWindow* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean result = FALSE;
#line 733 "../src/cheese-window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 735 "../src/cheese-window.vala"
	if (self->priv->is_bursting) {
#line 2508 "cheese-window.c"
		GSettings* _tmp1_;
#line 735 "../src/cheese-window.vala"
		_tmp1_ = self->priv->settings;
#line 735 "../src/cheese-window.vala"
		_tmp0_ = self->priv->burst_count < g_settings_get_int (_tmp1_, "burst-repeat");
#line 2514 "cheese-window.c"
	} else {
#line 735 "../src/cheese-window.vala"
		_tmp0_ = FALSE;
#line 2518 "cheese-window.c"
	}
#line 735 "../src/cheese-window.vala"
	if (_tmp0_) {
#line 2522 "cheese-window.c"
		gint _tmp2_;
#line 737 "../src/cheese-window.vala"
		cheese_main_window_take_photo (self);
#line 738 "../src/cheese-window.vala"
		_tmp2_ = self->priv->burst_count;
#line 738 "../src/cheese-window.vala"
		self->priv->burst_count = _tmp2_ + 1;
#line 739 "../src/cheese-window.vala"
		result = TRUE;
#line 739 "../src/cheese-window.vala"
		return result;
#line 2534 "cheese-window.c"
	} else {
#line 743 "../src/cheese-window.vala"
		cheese_main_window_toggle_photo_bursting (self, FALSE);
#line 744 "../src/cheese-window.vala"
		result = FALSE;
#line 744 "../src/cheese-window.vala"
		return result;
#line 2542 "cheese-window.c"
	}
}

/**
     * Cancel the current action (if any)
     */
static gboolean
cheese_main_window_cancel_running_action (CheeseMainWindow* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	CheeseCountdown* _tmp3_;
	gboolean result = FALSE;
#line 751 "../src/cheese-window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 753 "../src/cheese-window.vala"
	_tmp3_ = self->priv->current_countdown;
#line 753 "../src/cheese-window.vala"
	if (_tmp3_ != NULL) {
#line 2563 "cheese-window.c"
		CheeseCountdown* _tmp4_;
#line 753 "../src/cheese-window.vala"
		_tmp4_ = self->priv->current_countdown;
#line 753 "../src/cheese-window.vala"
		_tmp2_ = _tmp4_->running;
#line 2569 "cheese-window.c"
	} else {
#line 753 "../src/cheese-window.vala"
		_tmp2_ = FALSE;
#line 2573 "cheese-window.c"
	}
#line 753 "../src/cheese-window.vala"
	if (_tmp2_) {
#line 753 "../src/cheese-window.vala"
		_tmp1_ = TRUE;
#line 2579 "cheese-window.c"
	} else {
#line 754 "../src/cheese-window.vala"
		_tmp1_ = self->priv->is_bursting;
#line 2583 "cheese-window.c"
	}
#line 753 "../src/cheese-window.vala"
	if (_tmp1_) {
#line 753 "../src/cheese-window.vala"
		_tmp0_ = TRUE;
#line 2589 "cheese-window.c"
	} else {
#line 754 "../src/cheese-window.vala"
		_tmp0_ = self->priv->is_recording;
#line 2593 "cheese-window.c"
	}
#line 753 "../src/cheese-window.vala"
	if (_tmp0_) {
#line 2597 "cheese-window.c"
		CheeseMediaMode _tmp5_;
#line 756 "../src/cheese-window.vala"
		self->priv->action_cancelled = TRUE;
#line 758 "../src/cheese-window.vala"
		_tmp5_ = self->priv->current_mode;
#line 758 "../src/cheese-window.vala"
		switch (_tmp5_) {
#line 758 "../src/cheese-window.vala"
			case CHEESE_MEDIA_MODE_PHOTO:
#line 2607 "cheese-window.c"
			{
				CheeseCountdown* _tmp6_;
#line 761 "../src/cheese-window.vala"
				_tmp6_ = self->priv->current_countdown;
#line 761 "../src/cheese-window.vala"
				cheese_countdown_stop (_tmp6_);
#line 762 "../src/cheese-window.vala"
				cheese_main_window_finish_countdown_callback (self);
#line 763 "../src/cheese-window.vala"
				break;
#line 2618 "cheese-window.c"
			}
#line 758 "../src/cheese-window.vala"
			case CHEESE_MEDIA_MODE_BURST:
#line 2622 "cheese-window.c"
			{
#line 765 "../src/cheese-window.vala"
				cheese_main_window_toggle_photo_bursting (self, FALSE);
#line 766 "../src/cheese-window.vala"
				break;
#line 2628 "cheese-window.c"
			}
#line 758 "../src/cheese-window.vala"
			case CHEESE_MEDIA_MODE_VIDEO:
#line 2632 "cheese-window.c"
			{
#line 768 "../src/cheese-window.vala"
				cheese_main_window_toggle_video_recording (self, FALSE);
#line 769 "../src/cheese-window.vala"
				break;
#line 2638 "cheese-window.c"
			}
			default:
#line 758 "../src/cheese-window.vala"
			break;
#line 2643 "cheese-window.c"
		}
#line 772 "../src/cheese-window.vala"
		self->priv->action_cancelled = FALSE;
#line 774 "../src/cheese-window.vala"
		result = TRUE;
#line 774 "../src/cheese-window.vala"
		return result;
#line 2651 "cheese-window.c"
	}
#line 777 "../src/cheese-window.vala"
	result = FALSE;
#line 777 "../src/cheese-window.vala"
	return result;
#line 2657 "cheese-window.c"
}

/**
   * Cancel the current activity if the escape key is pressed.
   *
   * @param event the key event, to check which key was pressed
   * @return false, to allow further processing of the event
   */
static gboolean
cheese_main_window_on_key_release (CheeseMainWindow* self,
                                   GdkEventKey* event)
{
	gchar* key = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GCompareFunc _tmp2_;
	const gchar* _tmp3_;
	gboolean result = FALSE;
#line 786 "../src/cheese-window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 786 "../src/cheese-window.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 790 "../src/cheese-window.vala"
	_tmp0_ = gdk_keyval_name (event->keyval);
#line 790 "../src/cheese-window.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 790 "../src/cheese-window.vala"
	_g_free0 (key);
#line 790 "../src/cheese-window.vala"
	key = _tmp1_;
#line 791 "../src/cheese-window.vala"
	_tmp2_ = ((GCompareFunc) g_strcmp0);
#line 791 "../src/cheese-window.vala"
	_tmp3_ = key;
#line 791 "../src/cheese-window.vala"
	if (_tmp2_ (_tmp3_, "Escape") == 0) {
#line 793 "../src/cheese-window.vala"
		if (cheese_main_window_cancel_running_action (self)) {
#line 795 "../src/cheese-window.vala"
			result = FALSE;
#line 795 "../src/cheese-window.vala"
			_g_free0 (key);
#line 795 "../src/cheese-window.vala"
			return result;
#line 2702 "cheese-window.c"
		} else {
#line 797 "../src/cheese-window.vala"
			if (self->priv->is_effects_selector_active) {
#line 2706 "cheese-window.c"
				GtkToggleButton* _tmp4_;
#line 799 "../src/cheese-window.vala"
				_tmp4_ = self->priv->effects_toggle_button;
#line 799 "../src/cheese-window.vala"
				gtk_toggle_button_set_active (_tmp4_, FALSE);
#line 2712 "cheese-window.c"
			}
		}
	}
#line 802 "../src/cheese-window.vala"
	result = FALSE;
#line 802 "../src/cheese-window.vala"
	_g_free0 (key);
#line 802 "../src/cheese-window.vala"
	return result;
#line 2722 "cheese-window.c"
}

/**
   * Toggle whether video recording is active.
   *
   * @param is_start whether to start video recording
   */
static gboolean
_cheese_main_window_update_timeout_layer_gsource_func (gpointer self)
{
	gboolean result;
	result = cheese_main_window_update_timeout_layer ((CheeseMainWindow*) self);
#line 818 "../src/cheese-window.vala"
	return result;
#line 2737 "cheese-window.c"
}

void
cheese_main_window_toggle_video_recording (CheeseMainWindow* self,
                                           gboolean is_start)
{
#line 810 "../src/cheese-window.vala"
	g_return_if_fail (self != NULL);
#line 812 "../src/cheese-window.vala"
	if (is_start) {
#line 2748 "cheese-window.c"
		CheeseCamera* _tmp0_;
		CheeseFileUtil* _tmp1_;
		CheeseMediaMode _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GtkButton* _tmp5_;
		GtkImage* _tmp6_;
#line 814 "../src/cheese-window.vala"
		_tmp0_ = self->priv->camera;
#line 814 "../src/cheese-window.vala"
		_tmp1_ = self->priv->fileutil;
#line 814 "../src/cheese-window.vala"
		_tmp2_ = self->priv->current_mode;
#line 814 "../src/cheese-window.vala"
		_tmp3_ = cheese_fileutil_get_new_media_filename (_tmp1_, _tmp2_);
#line 814 "../src/cheese-window.vala"
		_tmp4_ = _tmp3_;
#line 814 "../src/cheese-window.vala"
		cheese_camera_start_video_recording (_tmp0_, _tmp4_);
#line 814 "../src/cheese-window.vala"
		_g_free0 (_tmp4_);
#line 818 "../src/cheese-window.vala"
		g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 1, _cheese_main_window_update_timeout_layer_gsource_func, g_object_ref (self), g_object_unref);
#line 819 "../src/cheese-window.vala"
		_tmp5_ = self->priv->take_action_button;
#line 819 "../src/cheese-window.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) _tmp5_, _ ("Stop recording"));
#line 820 "../src/cheese-window.vala"
		_tmp6_ = self->priv->take_action_button_image;
#line 820 "../src/cheese-window.vala"
		gtk_image_set_from_icon_name (_tmp6_, "media-playback-stop-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
#line 821 "../src/cheese-window.vala"
		self->priv->is_recording = TRUE;
#line 822 "../src/cheese-window.vala"
		cheese_main_window_disable_mode_change (self);
#line 2784 "cheese-window.c"
	} else {
		CheeseCamera* _tmp7_;
		ClutterText* _tmp8_;
		GtkButton* _tmp9_;
		GtkImage* _tmp10_;
#line 826 "../src/cheese-window.vala"
		_tmp7_ = self->priv->camera;
#line 826 "../src/cheese-window.vala"
		cheese_camera_stop_video_recording (_tmp7_);
#line 833 "../src/cheese-window.vala"
		_tmp8_ = self->priv->timeout_layer;
#line 833 "../src/cheese-window.vala"
		clutter_text_set_text (_tmp8_, "00:00:00");
#line 834 "../src/cheese-window.vala"
		_tmp9_ = self->priv->take_action_button;
#line 834 "../src/cheese-window.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) _tmp9_, _ ("Record a video"));
#line 835 "../src/cheese-window.vala"
		_tmp10_ = self->priv->take_action_button_image;
#line 835 "../src/cheese-window.vala"
		gtk_image_set_from_icon_name (_tmp10_, "camera-web-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
#line 836 "../src/cheese-window.vala"
		self->priv->is_recording = FALSE;
#line 837 "../src/cheese-window.vala"
		cheese_main_window_enable_mode_change (self);
#line 2810 "cheese-window.c"
	}
}

/**
   * Update the timeout layer displayed timer.
   *
   * @return false, if the source, Timeout.add_seconds (used
   * in the toogle_video_recording method), should be removed.
   */
static gboolean
cheese_main_window_update_timeout_layer (CheeseMainWindow* self)
{
	gboolean result = FALSE;
#line 847 "../src/cheese-window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 849 "../src/cheese-window.vala"
	if (self->priv->is_recording) {
#line 2828 "cheese-window.c"
		ClutterText* _tmp0_;
		CheeseCamera* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 850 "../src/cheese-window.vala"
		_tmp0_ = self->priv->timeout_layer;
#line 850 "../src/cheese-window.vala"
		_tmp1_ = self->priv->camera;
#line 850 "../src/cheese-window.vala"
		_tmp2_ = cheese_camera_get_recorded_time (_tmp1_);
#line 850 "../src/cheese-window.vala"
		_tmp3_ = _tmp2_;
#line 850 "../src/cheese-window.vala"
		clutter_text_set_text (_tmp0_, _tmp3_);
#line 850 "../src/cheese-window.vala"
		_g_free0 (_tmp3_);
#line 851 "../src/cheese-window.vala"
		result = TRUE;
#line 851 "../src/cheese-window.vala"
		return result;
#line 2849 "cheese-window.c"
	} else {
#line 854 "../src/cheese-window.vala"
		result = FALSE;
#line 854 "../src/cheese-window.vala"
		return result;
#line 2855 "cheese-window.c"
	}
}

/**
   * Toggle whether photo bursting is active.
   *
   * @param is_start whether to start capturing a photo burst
   */
static gboolean
_cheese_main_window_burst_take_photo_gsource_func (gpointer self)
{
	gboolean result;
	result = cheese_main_window_burst_take_photo ((CheeseMainWindow*) self);
#line 878 "../src/cheese-window.vala"
	return result;
#line 2871 "cheese-window.c"
}

void
cheese_main_window_toggle_photo_bursting (CheeseMainWindow* self,
                                          gboolean is_start)
{
#line 862 "../src/cheese-window.vala"
	g_return_if_fail (self != NULL);
#line 864 "../src/cheese-window.vala"
	if (is_start) {
#line 2882 "cheese-window.c"
		GtkButton* _tmp0_;
		gint burst_delay = 0;
		GSettings* _tmp1_;
		gint countdown_duration = 0;
		GSettings* _tmp2_;
		gboolean _tmp3_ = FALSE;
#line 866 "../src/cheese-window.vala"
		self->priv->is_bursting = TRUE;
#line 867 "../src/cheese-window.vala"
		cheese_main_window_disable_mode_change (self);
#line 869 "../src/cheese-window.vala"
		_tmp0_ = self->priv->take_action_button;
#line 869 "../src/cheese-window.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) _tmp0_, _ ("Stop taking pictures"));
#line 870 "../src/cheese-window.vala"
		cheese_main_window_burst_take_photo (self);
#line 874 "../src/cheese-window.vala"
		_tmp1_ = self->priv->settings;
#line 874 "../src/cheese-window.vala"
		burst_delay = g_settings_get_int (_tmp1_, "burst-delay");
#line 875 "../src/cheese-window.vala"
		_tmp2_ = self->priv->settings;
#line 875 "../src/cheese-window.vala"
		countdown_duration = 500 + (g_settings_get_int (_tmp2_, "countdown-duration") * 1000);
#line 876 "../src/cheese-window.vala"
		if ((burst_delay - countdown_duration) < 1000) {
#line 2909 "cheese-window.c"
			GSettings* _tmp4_;
#line 876 "../src/cheese-window.vala"
			_tmp4_ = self->priv->settings;
#line 876 "../src/cheese-window.vala"
			_tmp3_ = g_settings_get_boolean (_tmp4_, "countdown");
#line 2915 "cheese-window.c"
		} else {
#line 876 "../src/cheese-window.vala"
			_tmp3_ = FALSE;
#line 2919 "cheese-window.c"
		}
#line 876 "../src/cheese-window.vala"
		if (_tmp3_) {
#line 878 "../src/cheese-window.vala"
			self->priv->burst_callback_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) countdown_duration, _cheese_main_window_burst_take_photo_gsource_func, g_object_ref (self), g_object_unref);
#line 2925 "cheese-window.c"
		} else {
#line 882 "../src/cheese-window.vala"
			self->priv->burst_callback_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) burst_delay, _cheese_main_window_burst_take_photo_gsource_func, g_object_ref (self), g_object_unref);
#line 2929 "cheese-window.c"
		}
	} else {
		gboolean _tmp5_ = FALSE;
		CheeseCountdown* _tmp6_;
		GtkButton* _tmp9_;
		CheeseFileUtil* _tmp10_;
#line 887 "../src/cheese-window.vala"
		_tmp6_ = self->priv->current_countdown;
#line 887 "../src/cheese-window.vala"
		if (_tmp6_ != NULL) {
#line 2940 "cheese-window.c"
			CheeseCountdown* _tmp7_;
#line 887 "../src/cheese-window.vala"
			_tmp7_ = self->priv->current_countdown;
#line 887 "../src/cheese-window.vala"
			_tmp5_ = _tmp7_->running;
#line 2946 "cheese-window.c"
		} else {
#line 887 "../src/cheese-window.vala"
			_tmp5_ = FALSE;
#line 2950 "cheese-window.c"
		}
#line 887 "../src/cheese-window.vala"
		if (_tmp5_) {
#line 2954 "cheese-window.c"
			CheeseCountdown* _tmp8_;
#line 888 "../src/cheese-window.vala"
			_tmp8_ = self->priv->current_countdown;
#line 888 "../src/cheese-window.vala"
			cheese_countdown_stop (_tmp8_);
#line 2960 "cheese-window.c"
		}
#line 890 "../src/cheese-window.vala"
		self->priv->is_bursting = FALSE;
#line 891 "../src/cheese-window.vala"
		cheese_main_window_enable_mode_change (self);
#line 892 "../src/cheese-window.vala"
		_tmp9_ = self->priv->take_action_button;
#line 892 "../src/cheese-window.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) _tmp9_, _ ("Take multiple photos"));
#line 893 "../src/cheese-window.vala"
		self->priv->burst_count = 0;
#line 894 "../src/cheese-window.vala"
		_tmp10_ = self->priv->fileutil;
#line 894 "../src/cheese-window.vala"
		cheese_fileutil_reset_burst (_tmp10_);
#line 895 "../src/cheese-window.vala"
		g_source_remove (self->priv->burst_callback_id);
#line 2978 "cheese-window.c"
	}
}

/**
     * Take a photo or burst of photos, or record a video, based on the current
     * capture mode.
     */
void
cheese_main_window_shoot (CheeseMainWindow* self)
{
	CheeseMediaMode _tmp0_;
#line 903 "../src/cheese-window.vala"
	g_return_if_fail (self != NULL);
#line 905 "../src/cheese-window.vala"
	_tmp0_ = self->priv->current_mode;
#line 905 "../src/cheese-window.vala"
	switch (_tmp0_) {
#line 905 "../src/cheese-window.vala"
		case CHEESE_MEDIA_MODE_PHOTO:
#line 2998 "cheese-window.c"
		{
#line 908 "../src/cheese-window.vala"
			cheese_main_window_take_photo (self);
#line 909 "../src/cheese-window.vala"
			break;
#line 3004 "cheese-window.c"
		}
#line 905 "../src/cheese-window.vala"
		case CHEESE_MEDIA_MODE_VIDEO:
#line 3008 "cheese-window.c"
		{
#line 911 "../src/cheese-window.vala"
			cheese_main_window_toggle_video_recording (self, !self->priv->is_recording);
#line 912 "../src/cheese-window.vala"
			break;
#line 3014 "cheese-window.c"
		}
#line 905 "../src/cheese-window.vala"
		case CHEESE_MEDIA_MODE_BURST:
#line 3018 "cheese-window.c"
		{
#line 914 "../src/cheese-window.vala"
			cheese_main_window_toggle_photo_bursting (self, !self->priv->is_bursting);
#line 915 "../src/cheese-window.vala"
			break;
#line 3024 "cheese-window.c"
		}
		default:
		{
#line 917 "../src/cheese-window.vala"
			g_assert_not_reached ();
#line 3030 "cheese-window.c"
		}
	}
}

/**
     * Show an error.
     *
     * @param error the error to display, or null to hide the error layer
     */
void
cheese_main_window_show_error (CheeseMainWindow* self,
                               const gchar* _error_)
{
#line 926 "../src/cheese-window.vala"
	g_return_if_fail (self != NULL);
#line 928 "../src/cheese-window.vala"
	if (_error_ != NULL) {
#line 3048 "cheese-window.c"
		ClutterActor* _tmp0_;
		ClutterActor* _tmp1_;
		ClutterText* _tmp2_;
		ClutterText* _tmp3_;
#line 930 "../src/cheese-window.vala"
		_tmp0_ = self->priv->current_effects_grid;
#line 930 "../src/cheese-window.vala"
		clutter_actor_hide (_tmp0_);
#line 931 "../src/cheese-window.vala"
		_tmp1_ = self->priv->video_preview;
#line 931 "../src/cheese-window.vala"
		clutter_actor_hide (_tmp1_);
#line 932 "../src/cheese-window.vala"
		_tmp2_ = self->priv->error_layer;
#line 932 "../src/cheese-window.vala"
		clutter_text_set_text (_tmp2_, _error_);
#line 933 "../src/cheese-window.vala"
		_tmp3_ = self->priv->error_layer;
#line 933 "../src/cheese-window.vala"
		clutter_actor_show ((ClutterActor*) _tmp3_);
#line 3069 "cheese-window.c"
	} else {
		ClutterText* _tmp4_;
#line 937 "../src/cheese-window.vala"
		_tmp4_ = self->priv->error_layer;
#line 937 "../src/cheese-window.vala"
		clutter_actor_hide ((ClutterActor*) _tmp4_);
#line 939 "../src/cheese-window.vala"
		if (self->priv->is_effects_selector_active) {
#line 3078 "cheese-window.c"
			ClutterActor* _tmp5_;
#line 941 "../src/cheese-window.vala"
			_tmp5_ = self->priv->current_effects_grid;
#line 941 "../src/cheese-window.vala"
			clutter_actor_show (_tmp5_);
#line 3084 "cheese-window.c"
		} else {
			ClutterActor* _tmp6_;
#line 945 "../src/cheese-window.vala"
			_tmp6_ = self->priv->video_preview;
#line 945 "../src/cheese-window.vala"
			clutter_actor_show (_tmp6_);
#line 3091 "cheese-window.c"
		}
	}
}

/**
     * Toggle the display of the effect selector.
     *
     * @param effects whether effects should be enabled
     */
void
cheese_main_window_set_effects (CheeseMainWindow* self,
                                gboolean effects)
{
#line 955 "../src/cheese-window.vala"
	g_return_if_fail (self != NULL);
#line 957 "../src/cheese-window.vala"
	cheese_main_window_toggle_effects_selector (self, effects);
#line 3109 "cheese-window.c"
}

/**
   * Change the selected effect, as a new one was selected.
   *
   * @param tap unused
   * @param source the actor (with associated effect) that was selected
   */
void
cheese_main_window_on_selected_effect_change (CheeseMainWindow* self,
                                              ClutterTapAction* tap,
                                              ClutterActor* source)
{
	GtkToggleButton* _tmp0_;
	gconstpointer _tmp1_;
	CheeseEffect* _tmp2_;
	CheeseCamera* _tmp3_;
	CheeseEffect* _tmp4_;
	GSettings* _tmp5_;
	CheeseEffect* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
#line 966 "../src/cheese-window.vala"
	g_return_if_fail (self != NULL);
#line 966 "../src/cheese-window.vala"
	g_return_if_fail (tap != NULL);
#line 966 "../src/cheese-window.vala"
	g_return_if_fail (source != NULL);
#line 970 "../src/cheese-window.vala"
	_tmp0_ = self->priv->effects_toggle_button;
#line 970 "../src/cheese-window.vala"
	gtk_toggle_button_set_active (_tmp0_, FALSE);
#line 972 "../src/cheese-window.vala"
	_tmp1_ = g_object_get_data ((GObject*) source, "effect");
#line 972 "../src/cheese-window.vala"
	_tmp2_ = _g_object_ref0 ((CheeseEffect*) _tmp1_);
#line 972 "../src/cheese-window.vala"
	_g_object_unref0 (self->priv->selected_effect);
#line 972 "../src/cheese-window.vala"
	self->priv->selected_effect = _tmp2_;
#line 973 "../src/cheese-window.vala"
	_tmp3_ = self->priv->camera;
#line 973 "../src/cheese-window.vala"
	_tmp4_ = self->priv->selected_effect;
#line 973 "../src/cheese-window.vala"
	cheese_camera_set_effect (_tmp3_, _tmp4_);
#line 974 "../src/cheese-window.vala"
	_tmp5_ = self->priv->settings;
#line 974 "../src/cheese-window.vala"
	_tmp6_ = self->priv->selected_effect;
#line 974 "../src/cheese-window.vala"
	_tmp7_ = cheese_effect_get_name (_tmp6_);
#line 974 "../src/cheese-window.vala"
	_tmp8_ = _tmp7_;
#line 974 "../src/cheese-window.vala"
	g_settings_set_string (_tmp5_, "selected-effect", _tmp8_);
#line 3166 "cheese-window.c"
}

/**
     * Navigate back one page of effects.
     */
static void
cheese_main_window_on_effects_previous (CheeseMainWindow* self)
{
#line 980 "../src/cheese-window.vala"
	g_return_if_fail (self != NULL);
#line 982 "../src/cheese-window.vala"
	if (cheese_main_window_is_previous_effects_page (self)) {
#line 984 "../src/cheese-window.vala"
		cheese_main_window_activate_effects_page (self, ((gint) self->priv->current_effects_page) - 1);
#line 3181 "cheese-window.c"
	}
}

/**
     * Navigate forward one page of effects.
     */
static void
cheese_main_window_on_effects_next (CheeseMainWindow* self)
{
#line 991 "../src/cheese-window.vala"
	g_return_if_fail (self != NULL);
#line 993 "../src/cheese-window.vala"
	if (cheese_main_window_is_next_effects_page (self)) {
#line 995 "../src/cheese-window.vala"
		cheese_main_window_activate_effects_page (self, ((gint) self->priv->current_effects_page) + 1);
#line 3197 "cheese-window.c"
	}
}

/**
   * Switch to the supplied page of effects.
   *
   * @param number the effects page to switch to
   */
static void
cheese_main_window_activate_effects_page (CheeseMainWindow* self,
                                          gint number)
{
	ClutterActor* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	ClutterActor* _tmp3_;
	gboolean _tmp4_;
	GList* _tmp7_;
	gconstpointer _tmp8_;
	ClutterActor* _tmp9_;
	ClutterActor* _tmp10_;
	ClutterActor* _tmp11_;
	ClutterActor* _tmp12_;
	ClutterActor* _tmp13_;
	ClutterActor* _tmp14_;
	ClutterActor* _tmp15_;
	ClutterActor* _tmp16_;
	ClutterActor* _tmp17_;
	guint i = 0U;
	CheeseEffectsManager* _tmp18_;
	GList* _tmp19_;
#line 1004 "../src/cheese-window.vala"
	g_return_if_fail (self != NULL);
#line 1006 "../src/cheese-window.vala"
	if (!self->priv->is_effects_selector_active) {
#line 1007 "../src/cheese-window.vala"
		return;
#line 3235 "cheese-window.c"
	}
#line 1008 "../src/cheese-window.vala"
	self->priv->current_effects_page = (guint) number;
#line 1009 "../src/cheese-window.vala"
	_tmp0_ = self->priv->viewport_layout;
#line 1009 "../src/cheese-window.vala"
	_tmp1_ = clutter_actor_get_children (_tmp0_);
#line 1009 "../src/cheese-window.vala"
	_tmp2_ = _tmp1_;
#line 1009 "../src/cheese-window.vala"
	_tmp3_ = self->priv->current_effects_grid;
#line 1009 "../src/cheese-window.vala"
	_tmp4_ = g_list_index (_tmp2_, _tmp3_) != -1;
#line 1009 "../src/cheese-window.vala"
	(_tmp2_ == NULL) ? NULL : (_tmp2_ = (g_list_free (_tmp2_), NULL));
#line 1009 "../src/cheese-window.vala"
	if (_tmp4_) {
#line 3253 "cheese-window.c"
		ClutterActor* _tmp5_;
		ClutterActor* _tmp6_;
#line 1011 "../src/cheese-window.vala"
		_tmp5_ = self->priv->viewport_layout;
#line 1011 "../src/cheese-window.vala"
		_tmp6_ = self->priv->current_effects_grid;
#line 1011 "../src/cheese-window.vala"
		clutter_actor_remove_child (_tmp5_, _tmp6_);
#line 3262 "cheese-window.c"
	}
#line 1013 "../src/cheese-window.vala"
	_tmp7_ = self->priv->effects_grids;
#line 1013 "../src/cheese-window.vala"
	_tmp8_ = g_list_nth_data (_tmp7_, (guint) number);
#line 1013 "../src/cheese-window.vala"
	_tmp9_ = _g_object_ref0 ((ClutterActor*) _tmp8_);
#line 1013 "../src/cheese-window.vala"
	_g_object_unref0 (self->priv->current_effects_grid);
#line 1013 "../src/cheese-window.vala"
	self->priv->current_effects_grid = _tmp9_;
#line 1014 "../src/cheese-window.vala"
	_tmp10_ = self->priv->current_effects_grid;
#line 1014 "../src/cheese-window.vala"
	clutter_actor_set_opacity (_tmp10_, (guint) 0);
#line 1015 "../src/cheese-window.vala"
	_tmp11_ = self->priv->viewport_layout;
#line 1015 "../src/cheese-window.vala"
	_tmp12_ = self->priv->current_effects_grid;
#line 1015 "../src/cheese-window.vala"
	clutter_actor_add_child (_tmp11_, _tmp12_);
#line 1016 "../src/cheese-window.vala"
	_tmp13_ = self->priv->current_effects_grid;
#line 1016 "../src/cheese-window.vala"
	clutter_actor_save_easing_state (_tmp13_);
#line 1017 "../src/cheese-window.vala"
	_tmp14_ = self->priv->current_effects_grid;
#line 1017 "../src/cheese-window.vala"
	clutter_actor_set_easing_mode (_tmp14_, CLUTTER_LINEAR);
#line 1018 "../src/cheese-window.vala"
	_tmp15_ = self->priv->current_effects_grid;
#line 1018 "../src/cheese-window.vala"
	clutter_actor_set_easing_duration (_tmp15_, (guint) 500);
#line 1019 "../src/cheese-window.vala"
	_tmp16_ = self->priv->current_effects_grid;
#line 1019 "../src/cheese-window.vala"
	clutter_actor_set_opacity (_tmp16_, (guint) 255);
#line 1020 "../src/cheese-window.vala"
	_tmp17_ = self->priv->current_effects_grid;
#line 1020 "../src/cheese-window.vala"
	clutter_actor_restore_easing_state (_tmp17_);
#line 1023 "../src/cheese-window.vala"
	i = (guint) 0;
#line 1024 "../src/cheese-window.vala"
	_tmp18_ = self->priv->effects_manager;
#line 1024 "../src/cheese-window.vala"
	_tmp19_ = _tmp18_->effects;
#line 3310 "cheese-window.c"
	{
		GList* effect_collection = NULL;
		GList* effect_it = NULL;
#line 1024 "../src/cheese-window.vala"
		effect_collection = _tmp19_;
#line 1024 "../src/cheese-window.vala"
		for (effect_it = effect_collection; effect_it != NULL; effect_it = effect_it->next) {
#line 3318 "cheese-window.c"
			CheeseEffect* _tmp20_;
			CheeseEffect* effect = NULL;
#line 1024 "../src/cheese-window.vala"
			_tmp20_ = _g_object_ref0 ((CheeseEffect*) effect_it->data);
#line 1024 "../src/cheese-window.vala"
			effect = _tmp20_;
#line 3325 "cheese-window.c"
			{
				guint page_nr = 0U;
				guint _tmp31_;
#line 1026 "../src/cheese-window.vala"
				page_nr = i / EFFECTS_PER_PAGE;
#line 1027 "../src/cheese-window.vala"
				if (page_nr == ((guint) number)) {
#line 3333 "cheese-window.c"
					CheeseEffect* _tmp21_;
					CheeseEffect* _tmp28_;
#line 1029 "../src/cheese-window.vala"
					_tmp21_ = effect;
#line 1029 "../src/cheese-window.vala"
					if (!cheese_effect_is_preview_connected (_tmp21_)) {
#line 3340 "cheese-window.c"
						ClutterActor* texture = NULL;
						CheeseEffect* _tmp22_;
						gconstpointer _tmp23_;
						ClutterActor* _tmp24_;
						CheeseCamera* _tmp25_;
						CheeseEffect* _tmp26_;
						ClutterActor* _tmp27_;
#line 1031 "../src/cheese-window.vala"
						_tmp22_ = effect;
#line 1031 "../src/cheese-window.vala"
						_tmp23_ = g_object_get_data ((GObject*) _tmp22_, "texture");
#line 1031 "../src/cheese-window.vala"
						_tmp24_ = _g_object_ref0 ((ClutterActor*) _tmp23_);
#line 1031 "../src/cheese-window.vala"
						texture = _tmp24_;
#line 1032 "../src/cheese-window.vala"
						_tmp25_ = self->priv->camera;
#line 1032 "../src/cheese-window.vala"
						_tmp26_ = effect;
#line 1032 "../src/cheese-window.vala"
						_tmp27_ = texture;
#line 1032 "../src/cheese-window.vala"
						cheese_camera_connect_effect_texture (_tmp25_, _tmp26_, _tmp27_);
#line 1029 "../src/cheese-window.vala"
						_g_object_unref0 (texture);
#line 3366 "cheese-window.c"
					}
#line 1034 "../src/cheese-window.vala"
					_tmp28_ = effect;
#line 1034 "../src/cheese-window.vala"
					cheese_effect_enable_preview (_tmp28_);
#line 3372 "cheese-window.c"
				} else {
					CheeseEffect* _tmp29_;
#line 1038 "../src/cheese-window.vala"
					_tmp29_ = effect;
#line 1038 "../src/cheese-window.vala"
					if (cheese_effect_is_preview_connected (_tmp29_)) {
#line 3379 "cheese-window.c"
						CheeseEffect* _tmp30_;
#line 1040 "../src/cheese-window.vala"
						_tmp30_ = effect;
#line 1040 "../src/cheese-window.vala"
						cheese_effect_disable_preview (_tmp30_);
#line 3385 "cheese-window.c"
					}
				}
#line 1044 "../src/cheese-window.vala"
				_tmp31_ = i;
#line 1044 "../src/cheese-window.vala"
				i = _tmp31_ + 1;
#line 1024 "../src/cheese-window.vala"
				_g_object_unref0 (effect);
#line 3394 "cheese-window.c"
			}
		}
	}
#line 1047 "../src/cheese-window.vala"
	cheese_main_window_setup_effects_page_switch_sensitivity (self);
#line 3400 "cheese-window.c"
}

/**
     * Control the sensitivity of the effects page navigation buttons.
     */
static void
cheese_main_window_setup_effects_page_switch_sensitivity (CheeseMainWindow* self)
{
	GSimpleAction* effects_next = NULL;
	GAction* _tmp0_;
	GSimpleAction* _tmp1_;
	GSimpleAction* effects_previous = NULL;
	GAction* _tmp2_;
	GSimpleAction* _tmp3_;
	gboolean _tmp4_ = FALSE;
	GSimpleAction* _tmp5_;
	gboolean _tmp6_ = FALSE;
	GSimpleAction* _tmp7_;
#line 1053 "../src/cheese-window.vala"
	g_return_if_fail (self != NULL);
#line 1055 "../src/cheese-window.vala"
	_tmp0_ = g_action_map_lookup_action ((GActionMap*) self, "effects-next");
#line 1055 "../src/cheese-window.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, g_simple_action_get_type ()) ? ((GSimpleAction*) _tmp0_) : NULL);
#line 1055 "../src/cheese-window.vala"
	effects_next = _tmp1_;
#line 1056 "../src/cheese-window.vala"
	_tmp2_ = g_action_map_lookup_action ((GActionMap*) self, "effects-previous");
#line 1056 "../src/cheese-window.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, g_simple_action_get_type ()) ? ((GSimpleAction*) _tmp2_) : NULL);
#line 1056 "../src/cheese-window.vala"
	effects_previous = _tmp3_;
#line 1058 "../src/cheese-window.vala"
	if (self->priv->is_effects_selector_active) {
#line 1059 "../src/cheese-window.vala"
		_tmp4_ = cheese_main_window_is_next_effects_page (self);
#line 3437 "cheese-window.c"
	} else {
#line 1058 "../src/cheese-window.vala"
		_tmp4_ = FALSE;
#line 3441 "cheese-window.c"
	}
#line 1058 "../src/cheese-window.vala"
	_tmp5_ = effects_next;
#line 1058 "../src/cheese-window.vala"
	g_simple_action_set_enabled (_tmp5_, _tmp4_);
#line 1060 "../src/cheese-window.vala"
	if (self->priv->is_effects_selector_active) {
#line 1061 "../src/cheese-window.vala"
		_tmp6_ = cheese_main_window_is_previous_effects_page (self);
#line 3451 "cheese-window.c"
	} else {
#line 1060 "../src/cheese-window.vala"
		_tmp6_ = FALSE;
#line 3455 "cheese-window.c"
	}
#line 1060 "../src/cheese-window.vala"
	_tmp7_ = effects_previous;
#line 1060 "../src/cheese-window.vala"
	g_simple_action_set_enabled (_tmp7_, _tmp6_);
#line 1053 "../src/cheese-window.vala"
	_g_object_unref0 (effects_previous);
#line 1053 "../src/cheese-window.vala"
	_g_object_unref0 (effects_next);
#line 3465 "cheese-window.c"
}

static gboolean
cheese_main_window_is_next_effects_page (CheeseMainWindow* self)
{
	CheeseEffectsManager* _tmp0_;
	GList* _tmp1_;
	gboolean result = FALSE;
#line 1064 "../src/cheese-window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1067 "../src/cheese-window.vala"
	_tmp0_ = self->priv->effects_manager;
#line 1067 "../src/cheese-window.vala"
	_tmp1_ = _tmp0_->effects;
#line 1067 "../src/cheese-window.vala"
	result = ((self->priv->current_effects_page + 1) * EFFECTS_PER_PAGE) < g_list_length (_tmp1_);
#line 1067 "../src/cheese-window.vala"
	return result;
#line 3484 "cheese-window.c"
}

static gboolean
cheese_main_window_is_previous_effects_page (CheeseMainWindow* self)
{
	gboolean result = FALSE;
#line 1070 "../src/cheese-window.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1072 "../src/cheese-window.vala"
	result = self->priv->current_effects_page != ((guint) 0);
#line 1072 "../src/cheese-window.vala"
	return result;
#line 3497 "cheese-window.c"
}

/**
     * Toggle the visibility of the effects selector.
     *
     * @param active whether the selector should be active
     */
static void
cheese_main_window_toggle_effects_selector (CheeseMainWindow* self,
                                            gboolean active)
{
	GList* _tmp0_;
	CheeseCamera* _tmp6_;
#line 1080 "../src/cheese-window.vala"
	g_return_if_fail (self != NULL);
#line 1082 "../src/cheese-window.vala"
	self->priv->is_effects_selector_active = active;
#line 1084 "../src/cheese-window.vala"
	_tmp0_ = self->priv->effects_grids;
#line 1084 "../src/cheese-window.vala"
	if (g_list_length (_tmp0_) == ((guint) 0)) {
#line 3519 "cheese-window.c"
		const gchar* _tmp1_ = NULL;
#line 1086 "../src/cheese-window.vala"
		if (active) {
#line 1086 "../src/cheese-window.vala"
			_tmp1_ = _ ("No effects found");
#line 3525 "cheese-window.c"
		} else {
#line 1086 "../src/cheese-window.vala"
			_tmp1_ = NULL;
#line 3529 "cheese-window.c"
		}
#line 1086 "../src/cheese-window.vala"
		cheese_main_window_show_error (self, _tmp1_);
#line 3533 "cheese-window.c"
	} else {
#line 1088 "../src/cheese-window.vala"
		if (active) {
#line 3537 "cheese-window.c"
			ClutterActor* _tmp2_;
			ClutterActor* _tmp3_;
#line 1090 "../src/cheese-window.vala"
			_tmp2_ = self->priv->video_preview;
#line 1090 "../src/cheese-window.vala"
			clutter_actor_hide (_tmp2_);
#line 1091 "../src/cheese-window.vala"
			_tmp3_ = self->priv->current_effects_grid;
#line 1091 "../src/cheese-window.vala"
			clutter_actor_show (_tmp3_);
#line 1092 "../src/cheese-window.vala"
			cheese_main_window_activate_effects_page (self, (gint) self->priv->current_effects_page);
#line 3550 "cheese-window.c"
		} else {
			ClutterActor* _tmp4_;
			ClutterActor* _tmp5_;
#line 1096 "../src/cheese-window.vala"
			_tmp4_ = self->priv->current_effects_grid;
#line 1096 "../src/cheese-window.vala"
			clutter_actor_hide (_tmp4_);
#line 1097 "../src/cheese-window.vala"
			_tmp5_ = self->priv->video_preview;
#line 1097 "../src/cheese-window.vala"
			clutter_actor_show (_tmp5_);
#line 3562 "cheese-window.c"
		}
	}
#line 1100 "../src/cheese-window.vala"
	_tmp6_ = self->priv->camera;
#line 1100 "../src/cheese-window.vala"
	cheese_camera_toggle_effects_pipeline (_tmp6_, active);
#line 1101 "../src/cheese-window.vala"
	cheese_main_window_setup_effects_page_switch_sensitivity (self);
#line 1102 "../src/cheese-window.vala"
	cheese_main_window_update_header_bar_title (self);
#line 3573 "cheese-window.c"
}

/**
   * Create the effects selector.
   */
static void
_cheese_main_window_on_selected_effect_change_clutter_tap_action_tap (ClutterTapAction* _sender,
                                                                      ClutterActor* actor,
                                                                      gpointer self)
{
#line 1155 "../src/cheese-window.vala"
	cheese_main_window_on_selected_effect_change ((CheeseMainWindow*) self, _sender, actor);
#line 3586 "cheese-window.c"
}

static void
cheese_main_window_setup_effects_selector (CheeseMainWindow* self)
{
	ClutterActor* _tmp0_;
#line 1108 "../src/cheese-window.vala"
	g_return_if_fail (self != NULL);
#line 1110 "../src/cheese-window.vala"
	_tmp0_ = self->priv->current_effects_grid;
#line 1110 "../src/cheese-window.vala"
	if (_tmp0_ == NULL) {
#line 3599 "cheese-window.c"
		CheeseEffectsManager* _tmp1_;
		CheeseEffectsManager* _tmp2_;
		CheeseEffectsManager* _tmp3_;
		GList* _tmp4_;
		CheeseEffectsManager* _tmp5_;
		GList* _tmp6_;
		guint i = 0U;
		CheeseEffectsManager* _tmp16_;
		GList* _tmp17_;
		GList* _tmp75_;
		gconstpointer _tmp76_;
		ClutterActor* _tmp77_;
#line 1112 "../src/cheese-window.vala"
		_tmp1_ = cheese_effects_manager_new ();
#line 1112 "../src/cheese-window.vala"
		_g_object_unref0 (self->priv->effects_manager);
#line 1112 "../src/cheese-window.vala"
		self->priv->effects_manager = _tmp1_;
#line 1113 "../src/cheese-window.vala"
		_tmp2_ = self->priv->effects_manager;
#line 1113 "../src/cheese-window.vala"
		cheese_effects_manager_load_effects (_tmp2_);
#line 1116 "../src/cheese-window.vala"
		(self->priv->effects_grids == NULL) ? NULL : (self->priv->effects_grids = (_g_list_free__g_object_unref0_ (self->priv->effects_grids), NULL));
#line 1116 "../src/cheese-window.vala"
		self->priv->effects_grids = NULL;
#line 1118 "../src/cheese-window.vala"
		_tmp3_ = self->priv->effects_manager;
#line 1118 "../src/cheese-window.vala"
		_tmp4_ = _tmp3_->effects;
#line 1118 "../src/cheese-window.vala"
		if (g_list_length (_tmp4_) == ((guint) 0)) {
#line 1120 "../src/cheese-window.vala"
			g_warning ("cheese-window.vala:1120: gnome-video-effects is not installed.");
#line 1121 "../src/cheese-window.vala"
			return;
#line 3636 "cheese-window.c"
		}
#line 1124 "../src/cheese-window.vala"
		_tmp5_ = self->priv->effects_manager;
#line 1124 "../src/cheese-window.vala"
		_tmp6_ = _tmp5_->effects;
#line 3642 "cheese-window.c"
		{
			GList* effect_collection = NULL;
			GList* effect_it = NULL;
#line 1124 "../src/cheese-window.vala"
			effect_collection = _tmp6_;
#line 1124 "../src/cheese-window.vala"
			for (effect_it = effect_collection; effect_it != NULL; effect_it = effect_it->next) {
#line 3650 "cheese-window.c"
				CheeseEffect* _tmp7_;
				CheeseEffect* effect = NULL;
#line 1124 "../src/cheese-window.vala"
				_tmp7_ = _g_object_ref0 ((CheeseEffect*) effect_it->data);
#line 1124 "../src/cheese-window.vala"
				effect = _tmp7_;
#line 3657 "cheese-window.c"
				{
					ClutterGridLayout* grid_layout = NULL;
					ClutterGridLayout* _tmp8_;
					ClutterActor* grid = NULL;
					ClutterActor* _tmp9_;
					ClutterActor* _tmp10_;
					ClutterGridLayout* _tmp11_;
					ClutterActor* _tmp12_;
					ClutterActor* _tmp13_;
					ClutterGridLayout* _tmp14_;
					ClutterGridLayout* _tmp15_;
#line 1126 "../src/cheese-window.vala"
					_tmp8_ = (ClutterGridLayout*) clutter_grid_layout_new ();
#line 1126 "../src/cheese-window.vala"
					g_object_ref_sink (_tmp8_);
#line 1126 "../src/cheese-window.vala"
					grid_layout = _tmp8_;
#line 1127 "../src/cheese-window.vala"
					_tmp9_ = clutter_actor_new ();
#line 1127 "../src/cheese-window.vala"
					g_object_ref_sink (_tmp9_);
#line 1127 "../src/cheese-window.vala"
					grid = _tmp9_;
#line 1128 "../src/cheese-window.vala"
					_tmp10_ = grid;
#line 1128 "../src/cheese-window.vala"
					_tmp11_ = grid_layout;
#line 1128 "../src/cheese-window.vala"
					clutter_actor_set_layout_manager (_tmp10_, (ClutterLayoutManager*) _tmp11_);
#line 1129 "../src/cheese-window.vala"
					_tmp12_ = grid;
#line 1129 "../src/cheese-window.vala"
					_tmp13_ = _g_object_ref0 (_tmp12_);
#line 1129 "../src/cheese-window.vala"
					self->priv->effects_grids = g_list_append (self->priv->effects_grids, _tmp13_);
#line 1130 "../src/cheese-window.vala"
					_tmp14_ = grid_layout;
#line 1130 "../src/cheese-window.vala"
					clutter_grid_layout_set_column_spacing (_tmp14_, (guint) 10);
#line 1131 "../src/cheese-window.vala"
					_tmp15_ = grid_layout;
#line 1131 "../src/cheese-window.vala"
					clutter_grid_layout_set_row_spacing (_tmp15_, (guint) 10);
#line 1124 "../src/cheese-window.vala"
					_g_object_unref0 (grid);
#line 1124 "../src/cheese-window.vala"
					_g_object_unref0 (grid_layout);
#line 1124 "../src/cheese-window.vala"
					_g_object_unref0 (effect);
#line 3707 "cheese-window.c"
				}
			}
		}
#line 1134 "../src/cheese-window.vala"
		i = (guint) 0;
#line 1135 "../src/cheese-window.vala"
		_tmp16_ = self->priv->effects_manager;
#line 1135 "../src/cheese-window.vala"
		_tmp17_ = _tmp16_->effects;
#line 3717 "cheese-window.c"
		{
			GList* effect_collection = NULL;
			GList* effect_it = NULL;
#line 1135 "../src/cheese-window.vala"
			effect_collection = _tmp17_;
#line 1135 "../src/cheese-window.vala"
			for (effect_it = effect_collection; effect_it != NULL; effect_it = effect_it->next) {
#line 3725 "cheese-window.c"
				CheeseEffect* _tmp18_;
				CheeseEffect* effect = NULL;
#line 1135 "../src/cheese-window.vala"
				_tmp18_ = _g_object_ref0 ((CheeseEffect*) effect_it->data);
#line 1135 "../src/cheese-window.vala"
				effect = _tmp18_;
#line 3732 "cheese-window.c"
				{
					ClutterActor* texture = NULL;
					ClutterActor* _tmp19_;
					ClutterBinLayout* layout = NULL;
					ClutterBinLayout* _tmp20_;
					ClutterActor* box = NULL;
					ClutterActor* _tmp21_;
					ClutterActor* _tmp22_;
					ClutterBinLayout* _tmp23_;
					ClutterText* text = NULL;
					ClutterText* _tmp24_;
					ClutterActor* rect = NULL;
					ClutterActor* _tmp25_;
					ClutterActor* _tmp26_;
					ClutterActor* _tmp27_;
					ClutterColor _tmp28_ = {0};
					ClutterActor* _tmp29_;
					ClutterActor* _tmp30_;
					ClutterActor* _tmp31_;
					ClutterActor* _tmp32_;
					ClutterActor* _tmp33_;
					ClutterActor* _tmp34_;
					ClutterTapAction* tap = NULL;
					ClutterTapAction* _tmp35_;
					ClutterActor* _tmp36_;
					ClutterTapAction* _tmp37_;
					ClutterTapAction* _tmp38_;
					ClutterActor* _tmp39_;
					CheeseEffect* _tmp40_;
					CheeseEffect* _tmp41_;
					CheeseEffect* _tmp42_;
					ClutterActor* _tmp43_;
					ClutterActor* _tmp44_;
					ClutterText* _tmp45_;
					CheeseEffect* _tmp46_;
					const gchar* _tmp47_;
					const gchar* _tmp48_;
					ClutterText* _tmp49_;
					ClutterColor _tmp50_ = {0};
					ClutterActor* _tmp51_;
					ClutterText* _tmp52_;
					gfloat _tmp53_;
					gfloat _tmp54_;
					ClutterActor* _tmp55_;
					ClutterActor* _tmp56_;
					ClutterActor* _tmp57_;
					ClutterActor* _tmp58_;
					ClutterActor* _tmp59_;
					ClutterActor* _tmp60_;
					ClutterText* _tmp61_;
					ClutterText* _tmp62_;
					ClutterText* _tmp63_;
					ClutterText* _tmp64_;
					ClutterActor* _tmp65_;
					ClutterText* _tmp66_;
					ClutterGridLayout* grid_layout = NULL;
					GList* _tmp67_;
					gconstpointer _tmp68_;
					ClutterLayoutManager* _tmp69_;
					ClutterLayoutManager* _tmp70_;
					ClutterGridLayout* _tmp71_;
					ClutterGridLayout* _tmp72_;
					ClutterActor* _tmp73_;
					guint _tmp74_;
#line 1137 "../src/cheese-window.vala"
					_tmp19_ = clutter_actor_new ();
#line 1137 "../src/cheese-window.vala"
					g_object_ref_sink (_tmp19_);
#line 1137 "../src/cheese-window.vala"
					texture = _tmp19_;
#line 1138 "../src/cheese-window.vala"
					_tmp20_ = (ClutterBinLayout*) clutter_bin_layout_new (CLUTTER_BIN_ALIGNMENT_CENTER, CLUTTER_BIN_ALIGNMENT_CENTER);
#line 1138 "../src/cheese-window.vala"
					g_object_ref_sink (_tmp20_);
#line 1138 "../src/cheese-window.vala"
					layout = _tmp20_;
#line 1140 "../src/cheese-window.vala"
					_tmp21_ = clutter_actor_new ();
#line 1140 "../src/cheese-window.vala"
					g_object_ref_sink (_tmp21_);
#line 1140 "../src/cheese-window.vala"
					box = _tmp21_;
#line 1141 "../src/cheese-window.vala"
					_tmp22_ = box;
#line 1141 "../src/cheese-window.vala"
					_tmp23_ = layout;
#line 1141 "../src/cheese-window.vala"
					clutter_actor_set_layout_manager (_tmp22_, (ClutterLayoutManager*) _tmp23_);
#line 1142 "../src/cheese-window.vala"
					_tmp24_ = (ClutterText*) clutter_text_new ();
#line 1142 "../src/cheese-window.vala"
					g_object_ref_sink (_tmp24_);
#line 1142 "../src/cheese-window.vala"
					text = _tmp24_;
#line 1143 "../src/cheese-window.vala"
					_tmp25_ = clutter_actor_new ();
#line 1143 "../src/cheese-window.vala"
					g_object_ref_sink (_tmp25_);
#line 1143 "../src/cheese-window.vala"
					rect = _tmp25_;
#line 1145 "../src/cheese-window.vala"
					_tmp26_ = rect;
#line 1145 "../src/cheese-window.vala"
					clutter_actor_set_opacity (_tmp26_, (guint) 128);
#line 1146 "../src/cheese-window.vala"
					_tmp27_ = rect;
#line 1146 "../src/cheese-window.vala"
					clutter_color_from_string (&_tmp28_, "black");
#line 1146 "../src/cheese-window.vala"
					clutter_actor_set_background_color (_tmp27_, &_tmp28_);
#line 1148 "../src/cheese-window.vala"
					_tmp29_ = texture;
#line 1148 "../src/cheese-window.vala"
					clutter_actor_set_content_gravity (_tmp29_, CLUTTER_CONTENT_GRAVITY_RESIZE_ASPECT);
#line 1149 "../src/cheese-window.vala"
					_tmp30_ = box;
#line 1149 "../src/cheese-window.vala"
					_tmp31_ = texture;
#line 1149 "../src/cheese-window.vala"
					clutter_actor_add_child (_tmp30_, _tmp31_);
#line 1150 "../src/cheese-window.vala"
					_tmp32_ = box;
#line 1150 "../src/cheese-window.vala"
					clutter_actor_set_reactive (_tmp32_, TRUE);
#line 1151 "../src/cheese-window.vala"
					_tmp33_ = box;
#line 1151 "../src/cheese-window.vala"
					g_object_set (_tmp33_, "min-height", (gfloat) 40, NULL);
#line 1152 "../src/cheese-window.vala"
					_tmp34_ = box;
#line 1152 "../src/cheese-window.vala"
					g_object_set (_tmp34_, "min-width", (gfloat) 50, NULL);
#line 1153 "../src/cheese-window.vala"
					_tmp35_ = (ClutterTapAction*) clutter_tap_action_new ();
#line 1153 "../src/cheese-window.vala"
					g_object_ref_sink (_tmp35_);
#line 1153 "../src/cheese-window.vala"
					tap = _tmp35_;
#line 1154 "../src/cheese-window.vala"
					_tmp36_ = box;
#line 1154 "../src/cheese-window.vala"
					_tmp37_ = tap;
#line 1154 "../src/cheese-window.vala"
					clutter_actor_add_action (_tmp36_, (ClutterAction*) _tmp37_);
#line 1155 "../src/cheese-window.vala"
					_tmp38_ = tap;
#line 1155 "../src/cheese-window.vala"
					g_signal_connect_object (_tmp38_, "tap", (GCallback) _cheese_main_window_on_selected_effect_change_clutter_tap_action_tap, self, 0);
#line 1156 "../src/cheese-window.vala"
					_tmp39_ = box;
#line 1156 "../src/cheese-window.vala"
					_tmp40_ = effect;
#line 1156 "../src/cheese-window.vala"
					_tmp41_ = _g_object_ref0 (_tmp40_);
#line 1156 "../src/cheese-window.vala"
					g_object_set_data_full ((GObject*) _tmp39_, "effect", _tmp41_, g_object_unref);
#line 1157 "../src/cheese-window.vala"
					_tmp42_ = effect;
#line 1157 "../src/cheese-window.vala"
					_tmp43_ = texture;
#line 1157 "../src/cheese-window.vala"
					_tmp44_ = _g_object_ref0 (_tmp43_);
#line 1157 "../src/cheese-window.vala"
					g_object_set_data_full ((GObject*) _tmp42_, "texture", _tmp44_, g_object_unref);
#line 1159 "../src/cheese-window.vala"
					_tmp45_ = text;
#line 1159 "../src/cheese-window.vala"
					_tmp46_ = effect;
#line 1159 "../src/cheese-window.vala"
					_tmp47_ = cheese_effect_get_name (_tmp46_);
#line 1159 "../src/cheese-window.vala"
					_tmp48_ = _tmp47_;
#line 1159 "../src/cheese-window.vala"
					clutter_text_set_text (_tmp45_, _tmp48_);
#line 1160 "../src/cheese-window.vala"
					_tmp49_ = text;
#line 1160 "../src/cheese-window.vala"
					clutter_color_from_string (&_tmp50_, "white");
#line 1160 "../src/cheese-window.vala"
					clutter_text_set_color (_tmp49_, &_tmp50_);
#line 1162 "../src/cheese-window.vala"
					_tmp51_ = rect;
#line 1162 "../src/cheese-window.vala"
					_tmp52_ = text;
#line 1162 "../src/cheese-window.vala"
					_tmp53_ = clutter_actor_get_height ((ClutterActor*) _tmp52_);
#line 1162 "../src/cheese-window.vala"
					_tmp54_ = _tmp53_;
#line 1162 "../src/cheese-window.vala"
					clutter_actor_set_height (_tmp51_, _tmp54_ + 5);
#line 1163 "../src/cheese-window.vala"
					_tmp55_ = rect;
#line 1163 "../src/cheese-window.vala"
					clutter_actor_set_x_align (_tmp55_, CLUTTER_ACTOR_ALIGN_FILL);
#line 1164 "../src/cheese-window.vala"
					_tmp56_ = rect;
#line 1164 "../src/cheese-window.vala"
					clutter_actor_set_y_align (_tmp56_, CLUTTER_ACTOR_ALIGN_END);
#line 1165 "../src/cheese-window.vala"
					_tmp57_ = rect;
#line 1165 "../src/cheese-window.vala"
					clutter_actor_set_x_expand (_tmp57_, TRUE);
#line 1166 "../src/cheese-window.vala"
					_tmp58_ = rect;
#line 1166 "../src/cheese-window.vala"
					clutter_actor_set_y_expand (_tmp58_, TRUE);
#line 1167 "../src/cheese-window.vala"
					_tmp59_ = box;
#line 1167 "../src/cheese-window.vala"
					_tmp60_ = rect;
#line 1167 "../src/cheese-window.vala"
					clutter_actor_add_child (_tmp59_, _tmp60_);
#line 1169 "../src/cheese-window.vala"
					_tmp61_ = text;
#line 1169 "../src/cheese-window.vala"
					clutter_actor_set_x_align ((ClutterActor*) _tmp61_, CLUTTER_ACTOR_ALIGN_CENTER);
#line 1170 "../src/cheese-window.vala"
					_tmp62_ = text;
#line 1170 "../src/cheese-window.vala"
					clutter_actor_set_y_align ((ClutterActor*) _tmp62_, CLUTTER_ACTOR_ALIGN_END);
#line 1171 "../src/cheese-window.vala"
					_tmp63_ = text;
#line 1171 "../src/cheese-window.vala"
					clutter_actor_set_x_expand ((ClutterActor*) _tmp63_, TRUE);
#line 1172 "../src/cheese-window.vala"
					_tmp64_ = text;
#line 1172 "../src/cheese-window.vala"
					clutter_actor_set_y_expand ((ClutterActor*) _tmp64_, TRUE);
#line 1173 "../src/cheese-window.vala"
					_tmp65_ = box;
#line 1173 "../src/cheese-window.vala"
					_tmp66_ = text;
#line 1173 "../src/cheese-window.vala"
					clutter_actor_add_child (_tmp65_, (ClutterActor*) _tmp66_);
#line 1175 "../src/cheese-window.vala"
					_tmp67_ = self->priv->effects_grids;
#line 1175 "../src/cheese-window.vala"
					_tmp68_ = g_list_nth_data (_tmp67_, i / EFFECTS_PER_PAGE);
#line 1175 "../src/cheese-window.vala"
					_tmp69_ = clutter_actor_get_layout_manager ((ClutterActor*) _tmp68_);
#line 1175 "../src/cheese-window.vala"
					_tmp70_ = _tmp69_;
#line 1175 "../src/cheese-window.vala"
					_tmp71_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp70_, clutter_grid_layout_get_type ()) ? ((ClutterGridLayout*) _tmp70_) : NULL);
#line 1175 "../src/cheese-window.vala"
					grid_layout = _tmp71_;
#line 1176 "../src/cheese-window.vala"
					_tmp72_ = grid_layout;
#line 1176 "../src/cheese-window.vala"
					_tmp73_ = box;
#line 1176 "../src/cheese-window.vala"
					clutter_grid_layout_attach (_tmp72_, _tmp73_, ((gint) (i % EFFECTS_PER_PAGE)) % 3, ((gint) (i % EFFECTS_PER_PAGE)) / 3, 1, 1);
#line 1179 "../src/cheese-window.vala"
					_tmp74_ = i;
#line 1179 "../src/cheese-window.vala"
					i = _tmp74_ + 1;
#line 1135 "../src/cheese-window.vala"
					_g_object_unref0 (grid_layout);
#line 1135 "../src/cheese-window.vala"
					_g_object_unref0 (tap);
#line 1135 "../src/cheese-window.vala"
					_g_object_unref0 (rect);
#line 1135 "../src/cheese-window.vala"
					_g_object_unref0 (text);
#line 1135 "../src/cheese-window.vala"
					_g_object_unref0 (box);
#line 1135 "../src/cheese-window.vala"
					_g_object_unref0 (layout);
#line 1135 "../src/cheese-window.vala"
					_g_object_unref0 (texture);
#line 1135 "../src/cheese-window.vala"
					_g_object_unref0 (effect);
#line 4005 "cheese-window.c"
				}
			}
		}
#line 1182 "../src/cheese-window.vala"
		cheese_main_window_setup_effects_page_switch_sensitivity (self);
#line 1183 "../src/cheese-window.vala"
		_tmp75_ = self->priv->effects_grids;
#line 1183 "../src/cheese-window.vala"
		_tmp76_ = g_list_nth_data (_tmp75_, (guint) 0);
#line 1183 "../src/cheese-window.vala"
		_tmp77_ = _g_object_ref0 ((ClutterActor*) _tmp76_);
#line 1183 "../src/cheese-window.vala"
		_g_object_unref0 (self->priv->current_effects_grid);
#line 1183 "../src/cheese-window.vala"
		self->priv->current_effects_grid = _tmp77_;
#line 4021 "cheese-window.c"
	}
}

/**
     * Update the UI when the camera starts playing.
     */
void
cheese_main_window_camera_state_change_playing (CheeseMainWindow* self)
{
	CheeseEffect* effect = NULL;
	CheeseEffectsManager* _tmp0_;
	GSettings* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	CheeseEffect* _tmp4_;
	CheeseEffect* _tmp5_;
	CheeseEffect* _tmp6_;
#line 1190 "../src/cheese-window.vala"
	g_return_if_fail (self != NULL);
#line 1192 "../src/cheese-window.vala"
	cheese_main_window_show_error (self, NULL);
#line 1194 "../src/cheese-window.vala"
	_tmp0_ = self->priv->effects_manager;
#line 1194 "../src/cheese-window.vala"
	_tmp1_ = self->priv->settings;
#line 1194 "../src/cheese-window.vala"
	_tmp2_ = g_settings_get_string (_tmp1_, "selected-effect");
#line 1194 "../src/cheese-window.vala"
	_tmp3_ = _tmp2_;
#line 1194 "../src/cheese-window.vala"
	_tmp4_ = cheese_effects_manager_get_effect (_tmp0_, _tmp3_);
#line 1194 "../src/cheese-window.vala"
	_tmp5_ = _tmp4_;
#line 1194 "../src/cheese-window.vala"
	_g_free0 (_tmp3_);
#line 1194 "../src/cheese-window.vala"
	effect = _tmp5_;
#line 1195 "../src/cheese-window.vala"
	_tmp6_ = effect;
#line 1195 "../src/cheese-window.vala"
	if (_tmp6_ != NULL) {
#line 4063 "cheese-window.c"
		CheeseCamera* _tmp7_;
		CheeseEffect* _tmp8_;
#line 1197 "../src/cheese-window.vala"
		_tmp7_ = self->priv->camera;
#line 1197 "../src/cheese-window.vala"
		_tmp8_ = effect;
#line 1197 "../src/cheese-window.vala"
		cheese_camera_set_effect (_tmp7_, _tmp8_);
#line 4072 "cheese-window.c"
	}
#line 1190 "../src/cheese-window.vala"
	_g_object_unref0 (effect);
#line 4076 "cheese-window.c"
}

/**
     * Report an error as the camerabin switched to the NULL state.
     */
void
cheese_main_window_camera_state_change_null (CheeseMainWindow* self)
{
	ClutterText* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 1204 "../src/cheese-window.vala"
	g_return_if_fail (self != NULL);
#line 1206 "../src/cheese-window.vala"
	cheese_main_window_cancel_running_action (self);
#line 1208 "../src/cheese-window.vala"
	_tmp0_ = self->priv->error_layer;
#line 1208 "../src/cheese-window.vala"
	g_object_get ((ClutterActor*) _tmp0_, "visible", &_tmp1_, NULL);
#line 1208 "../src/cheese-window.vala"
	_tmp2_ = _tmp1_;
#line 1208 "../src/cheese-window.vala"
	if (!_tmp2_) {
#line 1210 "../src/cheese-window.vala"
		cheese_main_window_show_error (self, _ ("There was an error playing video from the webcam"));
#line 4102 "cheese-window.c"
	}
}

/**
   * Select next camera in list and activate it.
   */
static gpointer
_g_ptr_array_ref0 (gpointer self)
{
#line 1236 "../src/cheese-window.vala"
	return self ? g_ptr_array_ref (self) : NULL;
#line 4114 "cheese-window.c"
}

void
cheese_main_window_on_switch_camera_clicked (CheeseMainWindow* self)
{
	CheeseCameraDevice* selected = NULL;
	CheeseCameraDevice* next = NULL;
	GPtrArray* cameras = NULL;
	guint i = 0U;
	CheeseCamera* _tmp0_;
	CheeseCamera* _tmp1_;
	CheeseCameraDevice* _tmp2_;
	CheeseCameraDevice* _tmp3_;
	CheeseCameraDevice* _tmp4_;
	CheeseCamera* _tmp5_;
	GPtrArray* _tmp6_;
	GPtrArray* _tmp7_;
	GPtrArray* _tmp16_;
	CheeseCameraDevice* _tmp23_;
	CheeseCameraDevice* _tmp24_;
	CheeseCamera* _tmp25_;
	CheeseCameraDevice* _tmp26_;
	CheeseCamera* _tmp27_;
#line 1217 "../src/cheese-window.vala"
	g_return_if_fail (self != NULL);
#line 1220 "../src/cheese-window.vala"
	next = NULL;
#line 1224 "../src/cheese-window.vala"
	_tmp0_ = self->priv->camera;
#line 1224 "../src/cheese-window.vala"
	if (_tmp0_ == NULL) {
#line 1226 "../src/cheese-window.vala"
		_g_ptr_array_unref0 (cameras);
#line 1226 "../src/cheese-window.vala"
		_g_object_unref0 (next);
#line 1226 "../src/cheese-window.vala"
		_g_object_unref0 (selected);
#line 1226 "../src/cheese-window.vala"
		return;
#line 4154 "cheese-window.c"
	}
#line 1229 "../src/cheese-window.vala"
	_tmp1_ = self->priv->camera;
#line 1229 "../src/cheese-window.vala"
	_tmp2_ = cheese_camera_get_selected_device (_tmp1_);
#line 1229 "../src/cheese-window.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 1229 "../src/cheese-window.vala"
	_g_object_unref0 (selected);
#line 1229 "../src/cheese-window.vala"
	selected = _tmp3_;
#line 1231 "../src/cheese-window.vala"
	_tmp4_ = selected;
#line 1231 "../src/cheese-window.vala"
	if (_tmp4_ == NULL) {
#line 1233 "../src/cheese-window.vala"
		_g_ptr_array_unref0 (cameras);
#line 1233 "../src/cheese-window.vala"
		_g_object_unref0 (next);
#line 1233 "../src/cheese-window.vala"
		_g_object_unref0 (selected);
#line 1233 "../src/cheese-window.vala"
		return;
#line 4178 "cheese-window.c"
	}
#line 1236 "../src/cheese-window.vala"
	_tmp5_ = self->priv->camera;
#line 1236 "../src/cheese-window.vala"
	_tmp6_ = cheese_camera_get_camera_devices (_tmp5_);
#line 1236 "../src/cheese-window.vala"
	_tmp7_ = _g_ptr_array_ref0 (_tmp6_);
#line 1236 "../src/cheese-window.vala"
	_g_ptr_array_unref0 (cameras);
#line 1236 "../src/cheese-window.vala"
	cameras = _tmp7_;
#line 4190 "cheese-window.c"
	{
		gboolean _tmp8_ = FALSE;
#line 1238 "../src/cheese-window.vala"
		i = (guint) 0;
#line 1238 "../src/cheese-window.vala"
		_tmp8_ = TRUE;
#line 1238 "../src/cheese-window.vala"
		while (TRUE) {
#line 4199 "cheese-window.c"
			GPtrArray* _tmp10_;
			GPtrArray* _tmp11_;
			void* _tmp12_;
			CheeseCameraDevice* _tmp13_;
			CheeseCameraDevice* _tmp14_;
			CheeseCameraDevice* _tmp15_;
#line 1238 "../src/cheese-window.vala"
			if (!_tmp8_) {
#line 4208 "cheese-window.c"
				guint _tmp9_;
#line 1238 "../src/cheese-window.vala"
				_tmp9_ = i;
#line 1238 "../src/cheese-window.vala"
				i = _tmp9_ + 1;
#line 4214 "cheese-window.c"
			}
#line 1238 "../src/cheese-window.vala"
			_tmp8_ = FALSE;
#line 1238 "../src/cheese-window.vala"
			_tmp10_ = cameras;
#line 1238 "../src/cheese-window.vala"
			if (!(i < _tmp10_->len)) {
#line 1238 "../src/cheese-window.vala"
				break;
#line 4224 "cheese-window.c"
			}
#line 1240 "../src/cheese-window.vala"
			_tmp11_ = cameras;
#line 1240 "../src/cheese-window.vala"
			_tmp12_ = g_ptr_array_index (_tmp11_, i);
#line 1240 "../src/cheese-window.vala"
			_tmp13_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, CHEESE_TYPE_CAMERA_DEVICE, CheeseCameraDevice));
#line 1240 "../src/cheese-window.vala"
			_g_object_unref0 (next);
#line 1240 "../src/cheese-window.vala"
			next = _tmp13_;
#line 1242 "../src/cheese-window.vala"
			_tmp14_ = next;
#line 1242 "../src/cheese-window.vala"
			_tmp15_ = selected;
#line 1242 "../src/cheese-window.vala"
			if (_tmp14_ == _tmp15_) {
#line 1244 "../src/cheese-window.vala"
				break;
#line 4244 "cheese-window.c"
			}
		}
	}
#line 1248 "../src/cheese-window.vala"
	_tmp16_ = cameras;
#line 1248 "../src/cheese-window.vala"
	if ((i + 1) < _tmp16_->len) {
#line 4252 "cheese-window.c"
		GPtrArray* _tmp17_;
		void* _tmp18_;
		CheeseCameraDevice* _tmp19_;
#line 1250 "../src/cheese-window.vala"
		_tmp17_ = cameras;
#line 1250 "../src/cheese-window.vala"
		_tmp18_ = g_ptr_array_index (_tmp17_, i + 1);
#line 1250 "../src/cheese-window.vala"
		_tmp19_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, CHEESE_TYPE_CAMERA_DEVICE, CheeseCameraDevice));
#line 1250 "../src/cheese-window.vala"
		_g_object_unref0 (next);
#line 1250 "../src/cheese-window.vala"
		next = _tmp19_;
#line 4266 "cheese-window.c"
	} else {
		GPtrArray* _tmp20_;
		void* _tmp21_;
		CheeseCameraDevice* _tmp22_;
#line 1254 "../src/cheese-window.vala"
		_tmp20_ = cameras;
#line 1254 "../src/cheese-window.vala"
		_tmp21_ = g_ptr_array_index (_tmp20_, (guint) 0);
#line 1254 "../src/cheese-window.vala"
		_tmp22_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, CHEESE_TYPE_CAMERA_DEVICE, CheeseCameraDevice));
#line 1254 "../src/cheese-window.vala"
		_g_object_unref0 (next);
#line 1254 "../src/cheese-window.vala"
		next = _tmp22_;
#line 4281 "cheese-window.c"
	}
#line 1257 "../src/cheese-window.vala"
	_tmp23_ = next;
#line 1257 "../src/cheese-window.vala"
	_tmp24_ = selected;
#line 1257 "../src/cheese-window.vala"
	if (_tmp23_ == _tmp24_) {
#line 1260 "../src/cheese-window.vala"
		_g_ptr_array_unref0 (cameras);
#line 1260 "../src/cheese-window.vala"
		_g_object_unref0 (next);
#line 1260 "../src/cheese-window.vala"
		_g_object_unref0 (selected);
#line 1260 "../src/cheese-window.vala"
		return;
#line 4297 "cheese-window.c"
	}
#line 1263 "../src/cheese-window.vala"
	_tmp25_ = self->priv->camera;
#line 1263 "../src/cheese-window.vala"
	_tmp26_ = next;
#line 1263 "../src/cheese-window.vala"
	cheese_camera_set_device (_tmp25_, _tmp26_);
#line 1264 "../src/cheese-window.vala"
	_tmp27_ = self->priv->camera;
#line 1264 "../src/cheese-window.vala"
	cheese_camera_switch_camera_device (_tmp27_);
#line 1217 "../src/cheese-window.vala"
	_g_ptr_array_unref0 (cameras);
#line 1217 "../src/cheese-window.vala"
	_g_object_unref0 (next);
#line 1217 "../src/cheese-window.vala"
	_g_object_unref0 (selected);
#line 4315 "cheese-window.c"
}

/**
   * Set switch camera buttons visible state.
   */
void
cheese_main_window_set_switch_camera_button_state (CheeseMainWindow* self)
{
	CheeseCameraDevice* selected = NULL;
	GPtrArray* cameras = NULL;
	CheeseCamera* _tmp0_;
	CheeseCamera* _tmp2_;
	CheeseCameraDevice* _tmp3_;
	CheeseCameraDevice* _tmp4_;
	CheeseCameraDevice* _tmp5_;
	CheeseCamera* _tmp7_;
	GPtrArray* _tmp8_;
	GPtrArray* _tmp9_;
	GPtrArray* _tmp10_;
	GtkButton* _tmp12_;
#line 1270 "../src/cheese-window.vala"
	g_return_if_fail (self != NULL);
#line 1275 "../src/cheese-window.vala"
	_tmp0_ = self->priv->camera;
#line 1275 "../src/cheese-window.vala"
	if (_tmp0_ == NULL) {
#line 4342 "cheese-window.c"
		GtkButton* _tmp1_;
#line 1277 "../src/cheese-window.vala"
		_tmp1_ = self->priv->switch_camera_button;
#line 1277 "../src/cheese-window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp1_, FALSE);
#line 1278 "../src/cheese-window.vala"
		_g_ptr_array_unref0 (cameras);
#line 1278 "../src/cheese-window.vala"
		_g_object_unref0 (selected);
#line 1278 "../src/cheese-window.vala"
		return;
#line 4354 "cheese-window.c"
	}
#line 1281 "../src/cheese-window.vala"
	_tmp2_ = self->priv->camera;
#line 1281 "../src/cheese-window.vala"
	_tmp3_ = cheese_camera_get_selected_device (_tmp2_);
#line 1281 "../src/cheese-window.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 1281 "../src/cheese-window.vala"
	_g_object_unref0 (selected);
#line 1281 "../src/cheese-window.vala"
	selected = _tmp4_;
#line 1283 "../src/cheese-window.vala"
	_tmp5_ = selected;
#line 1283 "../src/cheese-window.vala"
	if (_tmp5_ == NULL) {
#line 4370 "cheese-window.c"
		GtkButton* _tmp6_;
#line 1285 "../src/cheese-window.vala"
		_tmp6_ = self->priv->switch_camera_button;
#line 1285 "../src/cheese-window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp6_, FALSE);
#line 1286 "../src/cheese-window.vala"
		_g_ptr_array_unref0 (cameras);
#line 1286 "../src/cheese-window.vala"
		_g_object_unref0 (selected);
#line 1286 "../src/cheese-window.vala"
		return;
#line 4382 "cheese-window.c"
	}
#line 1289 "../src/cheese-window.vala"
	_tmp7_ = self->priv->camera;
#line 1289 "../src/cheese-window.vala"
	_tmp8_ = cheese_camera_get_camera_devices (_tmp7_);
#line 1289 "../src/cheese-window.vala"
	_tmp9_ = _g_ptr_array_ref0 (_tmp8_);
#line 1289 "../src/cheese-window.vala"
	_g_ptr_array_unref0 (cameras);
#line 1289 "../src/cheese-window.vala"
	cameras = _tmp9_;
#line 1291 "../src/cheese-window.vala"
	_tmp10_ = cameras;
#line 1291 "../src/cheese-window.vala"
	if (_tmp10_->len > ((guint) 1)) {
#line 4398 "cheese-window.c"
		GtkButton* _tmp11_;
#line 1293 "../src/cheese-window.vala"
		_tmp11_ = self->priv->switch_camera_button;
#line 1293 "../src/cheese-window.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp11_, TRUE);
#line 1294 "../src/cheese-window.vala"
		_g_ptr_array_unref0 (cameras);
#line 1294 "../src/cheese-window.vala"
		_g_object_unref0 (selected);
#line 1294 "../src/cheese-window.vala"
		return;
#line 4410 "cheese-window.c"
	}
#line 1297 "../src/cheese-window.vala"
	_tmp12_ = self->priv->switch_camera_button;
#line 1297 "../src/cheese-window.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp12_, FALSE);
#line 1270 "../src/cheese-window.vala"
	_g_ptr_array_unref0 (cameras);
#line 1270 "../src/cheese-window.vala"
	_g_object_unref0 (selected);
#line 4420 "cheese-window.c"
}

/**
   * Load the UI from the GtkBuilder description.
   */
static void
_cheese_main_window_on_stage_resize_clutter_actor_allocation_changed (ClutterActor* _sender,
                                                                      ClutterActorBox* box,
                                                                      ClutterAllocationFlags flags,
                                                                      gpointer self)
{
#line 1348 "../src/cheese-window.vala"
	cheese_main_window_on_stage_resize ((CheeseMainWindow*) self, _sender, box, flags);
#line 4434 "cheese-window.c"
}

static gboolean
_cheese_main_window_on_thumb_view_popup_menu_gtk_widget_popup_menu (GtkWidget* _sender,
                                                                    gpointer self)
{
	gboolean result;
	result = cheese_main_window_on_thumb_view_popup_menu ((CheeseMainWindow*) self);
#line 1353 "../src/cheese-window.vala"
	return result;
#line 4445 "cheese-window.c"
}

static gboolean
_cheese_main_window_on_thumbnail_button_press_event_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                                   GdkEventButton* event,
                                                                                   gpointer self)
{
	gboolean result;
	result = cheese_main_window_on_thumbnail_button_press_event ((CheeseMainWindow*) self, _sender, event);
#line 1370 "../src/cheese-window.vala"
	return result;
#line 4457 "cheese-window.c"
}

static void
_cheese_main_window_on_switch_camera_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                 gpointer self)
{
#line 1372 "../src/cheese-window.vala"
	cheese_main_window_on_switch_camera_clicked ((CheeseMainWindow*) self);
#line 4466 "cheese-window.c"
}

static gboolean
_cheese_main_window_on_key_release_gtk_widget_key_release_event (GtkWidget* _sender,
                                                                 GdkEventKey* event,
                                                                 gpointer self)
{
	gboolean result;
	result = cheese_main_window_on_key_release ((CheeseMainWindow*) self, event);
#line 1382 "../src/cheese-window.vala"
	return result;
#line 4478 "cheese-window.c"
}

void
cheese_main_window_setup_ui (CheeseMainWindow* self)
{
	ClutterScript* _tmp0_;
	CheeseFileUtil* _tmp1_;
	CheeseFlash* _tmp2_;
	GSettings* _tmp3_;
	GMenu* menu = NULL;
	GtkApplication* _tmp4_;
	GtkApplication* _tmp5_;
	GMenu* _tmp6_;
	GMenu* _tmp7_;
	GtkMenu* _tmp8_;
	GtkApplication* _tmp9_;
	GtkApplication* _tmp10_;
	gchar* _tmp11_;
	gchar** _tmp12_;
	gchar** _tmp13_;
	gint _tmp13__length1;
	GtkApplication* _tmp14_;
	GtkApplication* _tmp15_;
	gchar* _tmp16_;
	gchar** _tmp17_;
	gchar** _tmp18_;
	gint _tmp18__length1;
	GtkApplication* _tmp19_;
	GtkApplication* _tmp20_;
	gchar* _tmp21_;
	gchar** _tmp22_;
	gchar** _tmp23_;
	gint _tmp23__length1;
	GtkApplication* _tmp24_;
	GtkApplication* _tmp25_;
	gchar* _tmp26_;
	gchar** _tmp27_;
	gchar** _tmp28_;
	gint _tmp28__length1;
	GtkApplication* _tmp29_;
	GtkApplication* _tmp30_;
	gchar* _tmp31_;
	gchar** _tmp32_;
	gchar** _tmp33_;
	gint _tmp33__length1;
	GtkApplication* _tmp34_;
	GtkApplication* _tmp35_;
	gchar* _tmp36_;
	gchar** _tmp37_;
	gchar** _tmp38_;
	gint _tmp38__length1;
	GtkClutterEmbed* _tmp41_;
	ClutterActor* _tmp42_;
	ClutterStage* _tmp43_;
	ClutterScript* _tmp44_;
	GObject* _tmp45_;
	ClutterActor* _tmp46_;
	ClutterScript* _tmp47_;
	GObject* _tmp48_;
	ClutterActor* _tmp49_;
	ClutterScript* _tmp50_;
	GObject* _tmp51_;
	ClutterBinLayout* _tmp52_;
	ClutterScript* _tmp53_;
	GObject* _tmp54_;
	ClutterText* _tmp55_;
	ClutterScript* _tmp56_;
	GObject* _tmp57_;
	ClutterActor* _tmp58_;
	ClutterScript* _tmp59_;
	GObject* _tmp60_;
	ClutterText* _tmp61_;
	ClutterScript* _tmp62_;
	GObject* _tmp63_;
	ClutterText* _tmp64_;
	ClutterActor* _tmp65_;
	ClutterStage* _tmp66_;
	ClutterActor* _tmp67_;
	ClutterActor* _tmp68_;
	ClutterBinLayout* _tmp69_;
	ClutterStage* _tmp70_;
	ClutterActor* _tmp71_;
	ClutterStage* _tmp72_;
	ClutterText* _tmp73_;
	ClutterStage* _tmp74_;
	CheeseThumbView* _tmp75_;
	CheeseThumbView* _tmp76_;
	EogThumbNav* _tmp77_;
	GtkMenu* _tmp78_;
	CheeseThumbView* _tmp79_;
	CheeseThumbView* _tmp80_;
	GtkCssProvider* css = NULL;
	GdkScreen* _tmp84_;
	GdkScreen* _tmp85_;
	CheeseThumbView* _tmp86_;
	GtkButton* _tmp87_;
	GtkClutterEmbed* _tmp88_;
	GError* _inner_error0_ = NULL;
#line 1303 "../src/cheese-window.vala"
	g_return_if_fail (self != NULL);
#line 1305 "../src/cheese-window.vala"
	_tmp0_ = clutter_script_new ();
#line 1305 "../src/cheese-window.vala"
	_g_object_unref0 (self->priv->clutter_builder);
#line 1305 "../src/cheese-window.vala"
	self->priv->clutter_builder = _tmp0_;
#line 1306 "../src/cheese-window.vala"
	_tmp1_ = cheese_fileutil_new ();
#line 1306 "../src/cheese-window.vala"
	_g_object_unref0 (self->priv->fileutil);
#line 1306 "../src/cheese-window.vala"
	self->priv->fileutil = _tmp1_;
#line 1307 "../src/cheese-window.vala"
	_tmp2_ = cheese_flash_new ((GtkWidget*) self);
#line 1307 "../src/cheese-window.vala"
	g_object_ref_sink (_tmp2_);
#line 1307 "../src/cheese-window.vala"
	_g_object_unref0 (self->priv->flash);
#line 1307 "../src/cheese-window.vala"
	self->priv->flash = _tmp2_;
#line 1308 "../src/cheese-window.vala"
	_tmp3_ = g_settings_new ("org.gnome.Cheese");
#line 1308 "../src/cheese-window.vala"
	_g_object_unref0 (self->priv->settings);
#line 1308 "../src/cheese-window.vala"
	self->priv->settings = _tmp3_;
#line 1310 "../src/cheese-window.vala"
	_tmp4_ = gtk_window_get_application ((GtkWindow*) self);
#line 1310 "../src/cheese-window.vala"
	_tmp5_ = _tmp4_;
#line 1310 "../src/cheese-window.vala"
	_tmp6_ = gtk_application_get_menu_by_id (_tmp5_, "thumbview-menu");
#line 1310 "../src/cheese-window.vala"
	_tmp7_ = _g_object_ref0 (_tmp6_);
#line 1310 "../src/cheese-window.vala"
	menu = _tmp7_;
#line 1311 "../src/cheese-window.vala"
	_tmp8_ = (GtkMenu*) gtk_menu_new_from_model ((GMenuModel*) menu);
#line 1311 "../src/cheese-window.vala"
	g_object_ref_sink (_tmp8_);
#line 1311 "../src/cheese-window.vala"
	_g_object_unref0 (self->priv->thumbnail_popup);
#line 1311 "../src/cheese-window.vala"
	self->priv->thumbnail_popup = _tmp8_;
#line 1313 "../src/cheese-window.vala"
	_tmp9_ = gtk_window_get_application ((GtkWindow*) self);
#line 1313 "../src/cheese-window.vala"
	_tmp10_ = _tmp9_;
#line 1313 "../src/cheese-window.vala"
	_tmp11_ = g_strdup ("<Primary>q");
#line 1313 "../src/cheese-window.vala"
	_tmp12_ = g_new0 (gchar*, 1 + 1);
#line 1313 "../src/cheese-window.vala"
	_tmp12_[0] = _tmp11_;
#line 1313 "../src/cheese-window.vala"
	_tmp13_ = _tmp12_;
#line 1313 "../src/cheese-window.vala"
	_tmp13__length1 = 1;
#line 1313 "../src/cheese-window.vala"
	gtk_application_set_accels_for_action (_tmp10_, "app.quit", _tmp13_);
#line 1313 "../src/cheese-window.vala"
	_tmp13_ = (_vala_array_free (_tmp13_, _tmp13__length1, (GDestroyNotify) g_free), NULL);
#line 1314 "../src/cheese-window.vala"
	_tmp14_ = gtk_window_get_application ((GtkWindow*) self);
#line 1314 "../src/cheese-window.vala"
	_tmp15_ = _tmp14_;
#line 1314 "../src/cheese-window.vala"
	_tmp16_ = g_strdup ("F11");
#line 1314 "../src/cheese-window.vala"
	_tmp17_ = g_new0 (gchar*, 1 + 1);
#line 1314 "../src/cheese-window.vala"
	_tmp17_[0] = _tmp16_;
#line 1314 "../src/cheese-window.vala"
	_tmp18_ = _tmp17_;
#line 1314 "../src/cheese-window.vala"
	_tmp18__length1 = 1;
#line 1314 "../src/cheese-window.vala"
	gtk_application_set_accels_for_action (_tmp15_, "app.fullscreen", _tmp18_);
#line 1314 "../src/cheese-window.vala"
	_tmp18_ = (_vala_array_free (_tmp18_, _tmp18__length1, (GDestroyNotify) g_free), NULL);
#line 1315 "../src/cheese-window.vala"
	_tmp19_ = gtk_window_get_application ((GtkWindow*) self);
#line 1315 "../src/cheese-window.vala"
	_tmp20_ = _tmp19_;
#line 1315 "../src/cheese-window.vala"
	_tmp21_ = g_strdup ("<Primary>o");
#line 1315 "../src/cheese-window.vala"
	_tmp22_ = g_new0 (gchar*, 1 + 1);
#line 1315 "../src/cheese-window.vala"
	_tmp22_[0] = _tmp21_;
#line 1315 "../src/cheese-window.vala"
	_tmp23_ = _tmp22_;
#line 1315 "../src/cheese-window.vala"
	_tmp23__length1 = 1;
#line 1315 "../src/cheese-window.vala"
	gtk_application_set_accels_for_action (_tmp20_, "win.file-open", _tmp23_);
#line 1315 "../src/cheese-window.vala"
	_tmp23_ = (_vala_array_free (_tmp23_, _tmp23__length1, (GDestroyNotify) g_free), NULL);
#line 1316 "../src/cheese-window.vala"
	_tmp24_ = gtk_window_get_application ((GtkWindow*) self);
#line 1316 "../src/cheese-window.vala"
	_tmp25_ = _tmp24_;
#line 1316 "../src/cheese-window.vala"
	_tmp26_ = g_strdup ("<Primary>s");
#line 1316 "../src/cheese-window.vala"
	_tmp27_ = g_new0 (gchar*, 1 + 1);
#line 1316 "../src/cheese-window.vala"
	_tmp27_[0] = _tmp26_;
#line 1316 "../src/cheese-window.vala"
	_tmp28_ = _tmp27_;
#line 1316 "../src/cheese-window.vala"
	_tmp28__length1 = 1;
#line 1316 "../src/cheese-window.vala"
	gtk_application_set_accels_for_action (_tmp25_, "win.file-saveas", _tmp28_);
#line 1316 "../src/cheese-window.vala"
	_tmp28_ = (_vala_array_free (_tmp28_, _tmp28__length1, (GDestroyNotify) g_free), NULL);
#line 1317 "../src/cheese-window.vala"
	_tmp29_ = gtk_window_get_application ((GtkWindow*) self);
#line 1317 "../src/cheese-window.vala"
	_tmp30_ = _tmp29_;
#line 1317 "../src/cheese-window.vala"
	_tmp31_ = g_strdup ("Delete");
#line 1317 "../src/cheese-window.vala"
	_tmp32_ = g_new0 (gchar*, 1 + 1);
#line 1317 "../src/cheese-window.vala"
	_tmp32_[0] = _tmp31_;
#line 1317 "../src/cheese-window.vala"
	_tmp33_ = _tmp32_;
#line 1317 "../src/cheese-window.vala"
	_tmp33__length1 = 1;
#line 1317 "../src/cheese-window.vala"
	gtk_application_set_accels_for_action (_tmp30_, "win.file-trash", _tmp33_);
#line 1317 "../src/cheese-window.vala"
	_tmp33_ = (_vala_array_free (_tmp33_, _tmp33__length1, (GDestroyNotify) g_free), NULL);
#line 1318 "../src/cheese-window.vala"
	_tmp34_ = gtk_window_get_application ((GtkWindow*) self);
#line 1318 "../src/cheese-window.vala"
	_tmp35_ = _tmp34_;
#line 1318 "../src/cheese-window.vala"
	_tmp36_ = g_strdup ("<Shift>Delete");
#line 1318 "../src/cheese-window.vala"
	_tmp37_ = g_new0 (gchar*, 1 + 1);
#line 1318 "../src/cheese-window.vala"
	_tmp37_[0] = _tmp36_;
#line 1318 "../src/cheese-window.vala"
	_tmp38_ = _tmp37_;
#line 1318 "../src/cheese-window.vala"
	_tmp38__length1 = 1;
#line 1318 "../src/cheese-window.vala"
	gtk_application_set_accels_for_action (_tmp35_, "win.file-delete", _tmp38_);
#line 1318 "../src/cheese-window.vala"
	_tmp38_ = (_vala_array_free (_tmp38_, _tmp38__length1, (GDestroyNotify) g_free), NULL);
#line 1320 "../src/cheese-window.vala"
	g_action_map_add_action_entries ((GActionMap*) self, CHEESE_MAIN_WINDOW_actions, (gint) G_N_ELEMENTS (CHEESE_MAIN_WINDOW_actions), self);
#line 4733 "cheese-window.c"
	{
		ClutterScript* _tmp39_;
#line 1324 "../src/cheese-window.vala"
		_tmp39_ = self->priv->clutter_builder;
#line 1324 "../src/cheese-window.vala"
		clutter_script_load_from_resource (_tmp39_, "/org/gnome/Cheese/cheese-viewport.json", &_inner_error0_);
#line 1324 "../src/cheese-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4742 "cheese-window.c"
			goto __catch9_g_error;
		}
	}
	goto __finally9;
	__catch9_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp40_;
#line 1322 "../src/cheese-window.vala"
		err = _inner_error0_;
#line 1322 "../src/cheese-window.vala"
		_inner_error0_ = NULL;
#line 1328 "../src/cheese-window.vala"
		_tmp40_ = err->message;
#line 1328 "../src/cheese-window.vala"
		g_error ("cheese-window.vala:1328: Error: %s", _tmp40_);
#line 1322 "../src/cheese-window.vala"
		_g_error_free0 (err);
#line 4761 "cheese-window.c"
	}
	__finally9:
#line 1322 "../src/cheese-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1322 "../src/cheese-window.vala"
		_g_object_unref0 (menu);
#line 1322 "../src/cheese-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1322 "../src/cheese-window.vala"
		g_clear_error (&_inner_error0_);
#line 1322 "../src/cheese-window.vala"
		return;
#line 4774 "cheese-window.c"
	}
#line 1331 "../src/cheese-window.vala"
	_tmp41_ = self->priv->viewport_widget;
#line 1331 "../src/cheese-window.vala"
	_tmp42_ = gtk_clutter_embed_get_stage (_tmp41_);
#line 1331 "../src/cheese-window.vala"
	_tmp43_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp42_, clutter_stage_get_type ()) ? ((ClutterStage*) _tmp42_) : NULL);
#line 1331 "../src/cheese-window.vala"
	_g_object_unref0 (self->priv->viewport);
#line 1331 "../src/cheese-window.vala"
	self->priv->viewport = _tmp43_;
#line 1333 "../src/cheese-window.vala"
	_tmp44_ = self->priv->clutter_builder;
#line 1333 "../src/cheese-window.vala"
	_tmp45_ = clutter_script_get_object (_tmp44_, "video_preview");
#line 1333 "../src/cheese-window.vala"
	_tmp46_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp45_, clutter_actor_get_type ()) ? ((ClutterActor*) _tmp45_) : NULL);
#line 1333 "../src/cheese-window.vala"
	_g_object_unref0 (self->priv->video_preview);
#line 1333 "../src/cheese-window.vala"
	self->priv->video_preview = _tmp46_;
#line 1334 "../src/cheese-window.vala"
	_tmp47_ = self->priv->clutter_builder;
#line 1334 "../src/cheese-window.vala"
	_tmp48_ = clutter_script_get_object (_tmp47_, "viewport_layout");
#line 1334 "../src/cheese-window.vala"
	_tmp49_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp48_, clutter_actor_get_type ()) ? ((ClutterActor*) _tmp48_) : NULL);
#line 1334 "../src/cheese-window.vala"
	_g_object_unref0 (self->priv->viewport_layout);
#line 1334 "../src/cheese-window.vala"
	self->priv->viewport_layout = _tmp49_;
#line 1335 "../src/cheese-window.vala"
	_tmp50_ = self->priv->clutter_builder;
#line 1335 "../src/cheese-window.vala"
	_tmp51_ = clutter_script_get_object (_tmp50_, "viewport_layout_manager");
#line 1335 "../src/cheese-window.vala"
	_tmp52_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp51_, clutter_bin_layout_get_type ()) ? ((ClutterBinLayout*) _tmp51_) : NULL);
#line 1335 "../src/cheese-window.vala"
	_g_object_unref0 (self->priv->viewport_layout_manager);
#line 1335 "../src/cheese-window.vala"
	self->priv->viewport_layout_manager = _tmp52_;
#line 1336 "../src/cheese-window.vala"
	_tmp53_ = self->priv->clutter_builder;
#line 1336 "../src/cheese-window.vala"
	_tmp54_ = clutter_script_get_object (_tmp53_, "countdown_layer");
#line 1336 "../src/cheese-window.vala"
	_tmp55_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp54_, clutter_text_get_type ()) ? ((ClutterText*) _tmp54_) : NULL);
#line 1336 "../src/cheese-window.vala"
	_g_object_unref0 (self->priv->countdown_layer);
#line 1336 "../src/cheese-window.vala"
	self->priv->countdown_layer = _tmp55_;
#line 1337 "../src/cheese-window.vala"
	_tmp56_ = self->priv->clutter_builder;
#line 1337 "../src/cheese-window.vala"
	_tmp57_ = clutter_script_get_object (_tmp56_, "background");
#line 1337 "../src/cheese-window.vala"
	_tmp58_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp57_, clutter_actor_get_type ()) ? ((ClutterActor*) _tmp57_) : NULL);
#line 1337 "../src/cheese-window.vala"
	_g_object_unref0 (self->priv->background_layer);
#line 1337 "../src/cheese-window.vala"
	self->priv->background_layer = _tmp58_;
#line 1338 "../src/cheese-window.vala"
	_tmp59_ = self->priv->clutter_builder;
#line 1338 "../src/cheese-window.vala"
	_tmp60_ = clutter_script_get_object (_tmp59_, "error_layer");
#line 1338 "../src/cheese-window.vala"
	_tmp61_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp60_, clutter_text_get_type ()) ? ((ClutterText*) _tmp60_) : NULL);
#line 1338 "../src/cheese-window.vala"
	_g_object_unref0 (self->priv->error_layer);
#line 1338 "../src/cheese-window.vala"
	self->priv->error_layer = _tmp61_;
#line 1339 "../src/cheese-window.vala"
	_tmp62_ = self->priv->clutter_builder;
#line 1339 "../src/cheese-window.vala"
	_tmp63_ = clutter_script_get_object (_tmp62_, "timeout_layer");
#line 1339 "../src/cheese-window.vala"
	_tmp64_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp63_, clutter_text_get_type ()) ? ((ClutterText*) _tmp63_) : NULL);
#line 1339 "../src/cheese-window.vala"
	_g_object_unref0 (self->priv->timeout_layer);
#line 1339 "../src/cheese-window.vala"
	self->priv->timeout_layer = _tmp64_;
#line 1341 "../src/cheese-window.vala"
	_tmp65_ = self->priv->video_preview;
#line 1341 "../src/cheese-window.vala"
	clutter_actor_set_request_mode (_tmp65_, CLUTTER_REQUEST_HEIGHT_FOR_WIDTH);
#line 1342 "../src/cheese-window.vala"
	_tmp66_ = self->priv->viewport;
#line 1342 "../src/cheese-window.vala"
	_tmp67_ = self->priv->background_layer;
#line 1342 "../src/cheese-window.vala"
	clutter_actor_add_child ((ClutterActor*) _tmp66_, _tmp67_);
#line 1343 "../src/cheese-window.vala"
	_tmp68_ = self->priv->viewport_layout;
#line 1343 "../src/cheese-window.vala"
	_tmp69_ = self->priv->viewport_layout_manager;
#line 1343 "../src/cheese-window.vala"
	clutter_actor_set_layout_manager (_tmp68_, (ClutterLayoutManager*) _tmp69_);
#line 1345 "../src/cheese-window.vala"
	_tmp70_ = self->priv->viewport;
#line 1345 "../src/cheese-window.vala"
	_tmp71_ = self->priv->viewport_layout;
#line 1345 "../src/cheese-window.vala"
	clutter_actor_add_child ((ClutterActor*) _tmp70_, _tmp71_);
#line 1346 "../src/cheese-window.vala"
	_tmp72_ = self->priv->viewport;
#line 1346 "../src/cheese-window.vala"
	_tmp73_ = self->priv->timeout_layer;
#line 1346 "../src/cheese-window.vala"
	clutter_actor_add_child ((ClutterActor*) _tmp72_, (ClutterActor*) _tmp73_);
#line 1348 "../src/cheese-window.vala"
	_tmp74_ = self->priv->viewport;
#line 1348 "../src/cheese-window.vala"
	g_signal_connect_object ((ClutterActor*) _tmp74_, "allocation-changed", (GCallback) _cheese_main_window_on_stage_resize_clutter_actor_allocation_changed, self, 0);
#line 1350 "../src/cheese-window.vala"
	_tmp75_ = cheese_thumb_view_new ();
#line 1350 "../src/cheese-window.vala"
	g_object_ref_sink (_tmp75_);
#line 1350 "../src/cheese-window.vala"
	_g_object_unref0 (self->priv->thumb_view);
#line 1350 "../src/cheese-window.vala"
	self->priv->thumb_view = _tmp75_;
#line 1351 "../src/cheese-window.vala"
	_tmp76_ = self->priv->thumb_view;
#line 1351 "../src/cheese-window.vala"
	_tmp77_ = eog_thumb_nav_new ((GtkWidget*) _tmp76_, FALSE);
#line 1351 "../src/cheese-window.vala"
	g_object_ref_sink (_tmp77_);
#line 1351 "../src/cheese-window.vala"
	_g_object_unref0 (self->priv->thumb_nav);
#line 1351 "../src/cheese-window.vala"
	self->priv->thumb_nav = _tmp77_;
#line 1352 "../src/cheese-window.vala"
	_tmp78_ = self->priv->thumbnail_popup;
#line 1352 "../src/cheese-window.vala"
	_tmp79_ = self->priv->thumb_view;
#line 1352 "../src/cheese-window.vala"
	gtk_menu_attach_to_widget (_tmp78_, (GtkWidget*) _tmp79_, NULL);
#line 1353 "../src/cheese-window.vala"
	_tmp80_ = self->priv->thumb_view;
#line 1353 "../src/cheese-window.vala"
	g_signal_connect_object ((GtkWidget*) _tmp80_, "popup-menu", (GCallback) _cheese_main_window_on_thumb_view_popup_menu_gtk_widget_popup_menu, self, 0);
#line 4916 "cheese-window.c"
	{
		GFile* file = NULL;
		GFile* _tmp81_;
		GtkCssProvider* _tmp82_;
#line 1358 "../src/cheese-window.vala"
		_tmp81_ = g_file_new_for_uri ("resource:///org/gnome/Cheese/cheese.css");
#line 1358 "../src/cheese-window.vala"
		file = _tmp81_;
#line 1359 "../src/cheese-window.vala"
		_tmp82_ = gtk_css_provider_new ();
#line 1359 "../src/cheese-window.vala"
		_g_object_unref0 (css);
#line 1359 "../src/cheese-window.vala"
		css = _tmp82_;
#line 1360 "../src/cheese-window.vala"
		gtk_css_provider_load_from_file (css, file, &_inner_error0_);
#line 1360 "../src/cheese-window.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1360 "../src/cheese-window.vala"
			_g_object_unref0 (file);
#line 4937 "cheese-window.c"
			goto __catch10_g_error;
		}
#line 1356 "../src/cheese-window.vala"
		_g_object_unref0 (file);
#line 4942 "cheese-window.c"
	}
	goto __finally10;
	__catch10_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp83_;
#line 1356 "../src/cheese-window.vala"
		e = _inner_error0_;
#line 1356 "../src/cheese-window.vala"
		_inner_error0_ = NULL;
#line 1365 "../src/cheese-window.vala"
		_tmp83_ = e->message;
#line 1365 "../src/cheese-window.vala"
		g_error ("cheese-window.vala:1365: Error parsing CSS: %s\n", _tmp83_);
#line 1356 "../src/cheese-window.vala"
		_g_error_free0 (e);
#line 4959 "cheese-window.c"
	}
	__finally10:
#line 1356 "../src/cheese-window.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1356 "../src/cheese-window.vala"
		_g_object_unref0 (css);
#line 1356 "../src/cheese-window.vala"
		_g_object_unref0 (menu);
#line 1356 "../src/cheese-window.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1356 "../src/cheese-window.vala"
		g_clear_error (&_inner_error0_);
#line 1356 "../src/cheese-window.vala"
		return;
#line 4974 "cheese-window.c"
	}
#line 1368 "../src/cheese-window.vala"
	_tmp84_ = gtk_window_get_screen ((GtkWindow*) self);
#line 1368 "../src/cheese-window.vala"
	_tmp85_ = _tmp84_;
#line 1368 "../src/cheese-window.vala"
	gtk_style_context_add_provider_for_screen (_tmp85_, (GtkStyleProvider*) css, (guint) GTK_STYLE_PROVIDER_PRIORITY_USER);
#line 1370 "../src/cheese-window.vala"
	_tmp86_ = self->priv->thumb_view;
#line 1370 "../src/cheese-window.vala"
	g_signal_connect_object ((GtkWidget*) _tmp86_, "button-press-event", (GCallback) _cheese_main_window_on_thumbnail_button_press_event_gtk_widget_button_press_event, self, 0);
#line 1372 "../src/cheese-window.vala"
	_tmp87_ = self->priv->switch_camera_button;
#line 1372 "../src/cheese-window.vala"
	g_signal_connect_object (_tmp87_, "clicked", (GCallback) _cheese_main_window_on_switch_camera_clicked_gtk_button_clicked, self, 0);
#line 1376 "../src/cheese-window.vala"
	_tmp88_ = self->priv->viewport_widget;
#line 1376 "../src/cheese-window.vala"
	gtk_widget_realize ((GtkWidget*) _tmp88_);
#line 1378 "../src/cheese-window.vala"
	cheese_main_window_set_wide_mode (self, FALSE);
#line 1380 "../src/cheese-window.vala"
	cheese_main_window_setup_effects_selector (self);
#line 1382 "../src/cheese-window.vala"
	g_signal_connect_object ((GtkWidget*) self, "key-release-event", (GCallback) _cheese_main_window_on_key_release_gtk_widget_key_release_event, self, 0);
#line 1303 "../src/cheese-window.vala"
	_g_object_unref0 (css);
#line 1303 "../src/cheese-window.vala"
	_g_object_unref0 (menu);
#line 5004 "cheese-window.c"
}

ClutterActor*
cheese_main_window_get_video_preview (CheeseMainWindow* self)
{
	ClutterActor* _tmp0_;
	ClutterActor* _tmp1_;
	ClutterActor* result = NULL;
#line 1385 "../src/cheese-window.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1387 "../src/cheese-window.vala"
	_tmp0_ = self->priv->video_preview;
#line 1387 "../src/cheese-window.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 1387 "../src/cheese-window.vala"
	result = _tmp1_;
#line 1387 "../src/cheese-window.vala"
	return result;
#line 5023 "cheese-window.c"
}

/**
   * Setup the thumbview thumbnail monitors.
   */
void
cheese_main_window_start_thumbview_monitors (CheeseMainWindow* self)
{
	CheeseThumbView* _tmp0_;
	CheeseFileUtil* _tmp1_;
	const gchar* _tmp2_;
	CheeseThumbView* _tmp3_;
	CheeseFileUtil* _tmp4_;
	const gchar* _tmp5_;
#line 1393 "../src/cheese-window.vala"
	g_return_if_fail (self != NULL);
#line 1395 "../src/cheese-window.vala"
	_tmp0_ = self->priv->thumb_view;
#line 1395 "../src/cheese-window.vala"
	_tmp1_ = self->priv->fileutil;
#line 1395 "../src/cheese-window.vala"
	_tmp2_ = cheese_fileutil_get_video_path (_tmp1_);
#line 1395 "../src/cheese-window.vala"
	cheese_thumb_view_start_monitoring_video_path (_tmp0_, _tmp2_);
#line 1396 "../src/cheese-window.vala"
	_tmp3_ = self->priv->thumb_view;
#line 1396 "../src/cheese-window.vala"
	_tmp4_ = self->priv->fileutil;
#line 1396 "../src/cheese-window.vala"
	_tmp5_ = cheese_fileutil_get_photo_path (_tmp4_);
#line 1396 "../src/cheese-window.vala"
	cheese_thumb_view_start_monitoring_photo_path (_tmp3_, _tmp5_);
#line 5056 "cheese-window.c"
}

/**
     * Set the current media mode (photo, video or burst).
     *
     * @param mode the media mode to set
     */
void
cheese_main_window_set_current_mode (CheeseMainWindow* self,
                                     CheeseMediaMode mode)
{
	CheeseMediaMode _tmp0_;
	ClutterText* _tmp1_;
	CheeseMediaMode _tmp2_;
#line 1404 "../src/cheese-window.vala"
	g_return_if_fail (self != NULL);
#line 1406 "../src/cheese-window.vala"
	self->priv->current_mode = mode;
#line 1408 "../src/cheese-window.vala"
	_tmp0_ = self->priv->current_mode;
#line 1408 "../src/cheese-window.vala"
	cheese_main_window_set_resolution (self, _tmp0_);
#line 1409 "../src/cheese-window.vala"
	cheese_main_window_update_header_bar_title (self);
#line 1410 "../src/cheese-window.vala"
	_tmp1_ = self->priv->timeout_layer;
#line 1410 "../src/cheese-window.vala"
	clutter_actor_hide ((ClutterActor*) _tmp1_);
#line 1412 "../src/cheese-window.vala"
	_tmp2_ = self->priv->current_mode;
#line 1412 "../src/cheese-window.vala"
	switch (_tmp2_) {
#line 1412 "../src/cheese-window.vala"
		case CHEESE_MEDIA_MODE_PHOTO:
#line 5091 "cheese-window.c"
		{
			GtkButton* _tmp3_;
#line 1415 "../src/cheese-window.vala"
			_tmp3_ = self->priv->take_action_button;
#line 1415 "../src/cheese-window.vala"
			gtk_widget_set_tooltip_text ((GtkWidget*) _tmp3_, _ ("Take a photo using a webcam"));
#line 1416 "../src/cheese-window.vala"
			break;
#line 5100 "cheese-window.c"
		}
#line 1412 "../src/cheese-window.vala"
		case CHEESE_MEDIA_MODE_VIDEO:
#line 5104 "cheese-window.c"
		{
			GtkButton* _tmp4_;
			ClutterText* _tmp5_;
			ClutterText* _tmp6_;
#line 1419 "../src/cheese-window.vala"
			_tmp4_ = self->priv->take_action_button;
#line 1419 "../src/cheese-window.vala"
			gtk_widget_set_tooltip_text ((GtkWidget*) _tmp4_, _ ("Record a video using a webcam"));
#line 1420 "../src/cheese-window.vala"
			_tmp5_ = self->priv->timeout_layer;
#line 1420 "../src/cheese-window.vala"
			clutter_text_set_text (_tmp5_, "00:00:00");
#line 1421 "../src/cheese-window.vala"
			_tmp6_ = self->priv->timeout_layer;
#line 1421 "../src/cheese-window.vala"
			clutter_actor_show ((ClutterActor*) _tmp6_);
#line 1422 "../src/cheese-window.vala"
			break;
#line 5123 "cheese-window.c"
		}
#line 1412 "../src/cheese-window.vala"
		case CHEESE_MEDIA_MODE_BURST:
#line 5127 "cheese-window.c"
		{
			GtkButton* _tmp7_;
#line 1425 "../src/cheese-window.vala"
			_tmp7_ = self->priv->take_action_button;
#line 1425 "../src/cheese-window.vala"
			gtk_widget_set_tooltip_text ((GtkWidget*) _tmp7_, _ ("Take multiple photos using a webcam"));
#line 1426 "../src/cheese-window.vala"
			break;
#line 5136 "cheese-window.c"
		}
		default:
#line 1412 "../src/cheese-window.vala"
		break;
#line 5141 "cheese-window.c"
	}
}

/**
     * Set the header bar title.
     */
static void
cheese_main_window_update_header_bar_title (CheeseMainWindow* self)
{
#line 1433 "../src/cheese-window.vala"
	g_return_if_fail (self != NULL);
#line 1435 "../src/cheese-window.vala"
	if (self->priv->is_effects_selector_active) {
#line 1437 "../src/cheese-window.vala"
		cheese_main_window_set_window_title (self, _ ("Choose an Effect"));
#line 5157 "cheese-window.c"
	} else {
		CheeseMediaMode _tmp0_;
#line 1441 "../src/cheese-window.vala"
		_tmp0_ = self->priv->current_mode;
#line 1441 "../src/cheese-window.vala"
		switch (_tmp0_) {
#line 1441 "../src/cheese-window.vala"
			case CHEESE_MEDIA_MODE_PHOTO:
#line 5166 "cheese-window.c"
			{
#line 1444 "../src/cheese-window.vala"
				cheese_main_window_set_window_title (self, _ ("Take a Photo"));
#line 1445 "../src/cheese-window.vala"
				break;
#line 5172 "cheese-window.c"
			}
#line 1441 "../src/cheese-window.vala"
			case CHEESE_MEDIA_MODE_VIDEO:
#line 5176 "cheese-window.c"
			{
#line 1448 "../src/cheese-window.vala"
				cheese_main_window_set_window_title (self, _ ("Record a Video"));
#line 1449 "../src/cheese-window.vala"
				break;
#line 5182 "cheese-window.c"
			}
#line 1441 "../src/cheese-window.vala"
			case CHEESE_MEDIA_MODE_BURST:
#line 5186 "cheese-window.c"
			{
#line 1452 "../src/cheese-window.vala"
				cheese_main_window_set_window_title (self, _ ("Take Multiple Photos"));
#line 1453 "../src/cheese-window.vala"
				break;
#line 5192 "cheese-window.c"
			}
			default:
#line 1441 "../src/cheese-window.vala"
			break;
#line 5197 "cheese-window.c"
		}
	}
}

/**
     * Set the camera.
     *
     * @param camera the camera to set
     */
void
cheese_main_window_set_camera (CheeseMainWindow* self,
                               CheeseCamera* camera)
{
	CheeseCamera* _tmp0_;
#line 1462 "../src/cheese-window.vala"
	g_return_if_fail (self != NULL);
#line 1462 "../src/cheese-window.vala"
	g_return_if_fail (camera != NULL);
#line 1464 "../src/cheese-window.vala"
	_tmp0_ = _g_object_ref0 (camera);
#line 1464 "../src/cheese-window.vala"
	_g_object_unref0 (self->priv->camera);
#line 1464 "../src/cheese-window.vala"
	self->priv->camera = _tmp0_;
#line 1465 "../src/cheese-window.vala"
	cheese_main_window_set_switch_camera_button_state (self);
#line 5224 "cheese-window.c"
}

static void
cheese_main_window_class_init (CheeseMainWindowClass * klass,
                               gpointer klass_data)
{
#line 35 "../src/cheese-window.vala"
	cheese_main_window_parent_class = g_type_class_peek_parent (klass);
#line 35 "../src/cheese-window.vala"
	g_type_class_adjust_private_offset (klass, &CheeseMainWindow_private_offset);
#line 35 "../src/cheese-window.vala"
	G_OBJECT_CLASS (klass)->finalize = cheese_main_window_finalize;
#line 35 "../src/cheese-window.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Cheese/cheese-main-window.ui");
#line 35 "../src/cheese-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "viewport_widget", FALSE, CheeseMainWindow_private_offset + G_STRUCT_OFFSET (CheeseMainWindowPrivate, viewport_widget));
#line 35 "../src/cheese-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "main_vbox", FALSE, CheeseMainWindow_private_offset + G_STRUCT_OFFSET (CheeseMainWindowPrivate, main_vbox));
#line 35 "../src/cheese-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "thumbnails_right", FALSE, CheeseMainWindow_private_offset + G_STRUCT_OFFSET (CheeseMainWindowPrivate, thumbnails_right));
#line 35 "../src/cheese-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "thumbnails_bottom", FALSE, CheeseMainWindow_private_offset + G_STRUCT_OFFSET (CheeseMainWindowPrivate, thumbnails_bottom));
#line 35 "../src/cheese-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "leave_fullscreen_button_box", FALSE, CheeseMainWindow_private_offset + G_STRUCT_OFFSET (CheeseMainWindowPrivate, leave_fullscreen_button_box));
#line 35 "../src/cheese-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "take_action_button", FALSE, CheeseMainWindow_private_offset + G_STRUCT_OFFSET (CheeseMainWindowPrivate, take_action_button));
#line 35 "../src/cheese-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "take_action_button_image", FALSE, CheeseMainWindow_private_offset + G_STRUCT_OFFSET (CheeseMainWindowPrivate, take_action_button_image));
#line 35 "../src/cheese-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "effects_toggle_button", FALSE, CheeseMainWindow_private_offset + G_STRUCT_OFFSET (CheeseMainWindowPrivate, effects_toggle_button));
#line 35 "../src/cheese-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "buttons_area", FALSE, CheeseMainWindow_private_offset + G_STRUCT_OFFSET (CheeseMainWindowPrivate, buttons_area));
#line 35 "../src/cheese-window.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "switch_camera_button", FALSE, CheeseMainWindow_private_offset + G_STRUCT_OFFSET (CheeseMainWindowPrivate, switch_camera_button));
#line 5259 "cheese-window.c"
}

static void
cheese_main_window_instance_init (CheeseMainWindow * self,
                                  gpointer klass)
{
	GtkBuilder* _tmp0_;
#line 35 "../src/cheese-window.vala"
	self->priv = cheese_main_window_get_instance_private (self);
#line 50 "../src/cheese-window.vala"
	_tmp0_ = gtk_builder_new_from_resource ("/org/gnome/Cheese/headerbar.ui");
#line 50 "../src/cheese-window.vala"
	self->priv->header_bar_ui = _tmp0_;
#line 90 "../src/cheese-window.vala"
	self->priv->current_effects_page = (guint) 0;
#line 35 "../src/cheese-window.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 5277 "cheese-window.c"
}

static void
cheese_main_window_finalize (GObject * obj)
{
	CheeseMainWindow * self;
#line 35 "../src/cheese-window.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CHEESE_TYPE_MAIN_WINDOW, CheeseMainWindow);
#line 48 "../src/cheese-window.vala"
	_g_object_unref0 (self->priv->clutter_builder);
#line 50 "../src/cheese-window.vala"
	_g_object_unref0 (self->priv->header_bar_ui);
#line 52 "../src/cheese-window.vala"
	_g_object_unref0 (self->priv->header_bar);
#line 54 "../src/cheese-window.vala"
	_g_object_unref0 (self->priv->settings);
#line 57 "../src/cheese-window.vala"
	_g_object_unref0 (self->priv->viewport_widget);
#line 59 "../src/cheese-window.vala"
	_g_object_unref0 (self->priv->main_vbox);
#line 60 "../src/cheese-window.vala"
	_g_object_unref0 (self->priv->thumb_nav);
#line 61 "../src/cheese-window.vala"
	_g_object_unref0 (self->priv->thumb_view);
#line 63 "../src/cheese-window.vala"
	_g_object_unref0 (self->priv->thumbnails_right);
#line 65 "../src/cheese-window.vala"
	_g_object_unref0 (self->priv->thumbnails_bottom);
#line 67 "../src/cheese-window.vala"
	_g_object_unref0 (self->priv->leave_fullscreen_button_box);
#line 69 "../src/cheese-window.vala"
	_g_object_unref0 (self->priv->take_action_button);
#line 71 "../src/cheese-window.vala"
	_g_object_unref0 (self->priv->take_action_button_image);
#line 73 "../src/cheese-window.vala"
	_g_object_unref0 (self->priv->effects_toggle_button);
#line 75 "../src/cheese-window.vala"
	_g_object_unref0 (self->priv->buttons_area);
#line 77 "../src/cheese-window.vala"
	_g_object_unref0 (self->priv->switch_camera_button);
#line 78 "../src/cheese-window.vala"
	_g_object_unref0 (self->priv->thumbnail_popup);
#line 80 "../src/cheese-window.vala"
	_g_object_unref0 (self->priv->viewport);
#line 81 "../src/cheese-window.vala"
	_g_object_unref0 (self->priv->viewport_layout);
#line 82 "../src/cheese-window.vala"
	_g_object_unref0 (self->priv->video_preview);
#line 83 "../src/cheese-window.vala"
	_g_object_unref0 (self->priv->viewport_layout_manager);
#line 84 "../src/cheese-window.vala"
	_g_object_unref0 (self->priv->countdown_layer);
#line 85 "../src/cheese-window.vala"
	_g_object_unref0 (self->priv->background_layer);
#line 86 "../src/cheese-window.vala"
	_g_object_unref0 (self->priv->error_layer);
#line 87 "../src/cheese-window.vala"
	_g_object_unref0 (self->priv->timeout_layer);
#line 89 "../src/cheese-window.vala"
	_g_object_unref0 (self->priv->current_effects_grid);
#line 91 "../src/cheese-window.vala"
	(self->priv->effects_grids == NULL) ? NULL : (self->priv->effects_grids = (_g_list_free__g_object_unref0_ (self->priv->effects_grids), NULL));
#line 101 "../src/cheese-window.vala"
	_g_object_unref0 (self->priv->camera);
#line 102 "../src/cheese-window.vala"
	_g_object_unref0 (self->priv->fileutil);
#line 103 "../src/cheese-window.vala"
	_g_object_unref0 (self->priv->flash);
#line 105 "../src/cheese-window.vala"
	_g_object_unref0 (self->priv->effects_manager);
#line 107 "../src/cheese-window.vala"
	_g_object_unref0 (self->priv->selected_effect);
#line 487 "../src/cheese-window.vala"
	_g_source_unref0 (self->priv->fullscreen_timeout);
#line 702 "../src/cheese-window.vala"
	_g_object_unref0 (self->priv->current_countdown);
#line 35 "../src/cheese-window.vala"
	G_OBJECT_CLASS (cheese_main_window_parent_class)->finalize (obj);
#line 5356 "cheese-window.c"
}

GType
cheese_main_window_get_type (void)
{
	static volatile gsize cheese_main_window_type_id__volatile = 0;
	if (g_once_init_enter (&cheese_main_window_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (CheeseMainWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) cheese_main_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CheeseMainWindow), 0, (GInstanceInitFunc) cheese_main_window_instance_init, NULL };
		GType cheese_main_window_type_id;
		cheese_main_window_type_id = g_type_register_static (gtk_application_window_get_type (), "CheeseMainWindow", &g_define_type_info, 0);
		CheeseMainWindow_private_offset = g_type_add_instance_private (cheese_main_window_type_id, sizeof (CheeseMainWindowPrivate));
		g_once_init_leave (&cheese_main_window_type_id__volatile, cheese_main_window_type_id);
	}
	return cheese_main_window_type_id__volatile;
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

